package com.reign.gcld.battle.scene;

package ..deTemp.1740546571790;

import com.reign.framework.json.JsonBuilder;
import com.reign.framework.json.JsonDocument;
import com.reign.framework.json.State;
import com.reign.framework.netty.servlet.Session;
import com.reign.framework.netty.util.WrapperUtil;
import com.reign.gcld.battle.common.BattleArmy;
import com.reign.gcld.battle.common.BattleResultRound;
import com.reign.gcld.battle.common.BattleSceneLog;
import com.reign.gcld.battle.common.BattleScheduler;
import com.reign.gcld.battle.common.ErrorSceneLog;
import com.reign.gcld.battle.common.JoinTeamBattleInfo;
import com.reign.gcld.battle.common.RoundInfo;
import com.reign.gcld.battle.common.TeamInfo;
import com.reign.gcld.battle.common.Terrain;
import com.reign.gcld.battle.common.WorldSceneLog;
import com.reign.gcld.battle.domain.PlayerBattleAttribute;
import com.reign.gcld.battle.domain.PlayerGeneralMilitaryPhantom;
import com.reign.gcld.battle.scene.BaseInfo;
import com.reign.gcld.battle.scene.Battle;
import com.reign.gcld.battle.scene.BattleAttacker;
import com.reign.gcld.battle.scene.Builder;
import com.reign.gcld.battle.scene.BuilderFactory;
import com.reign.gcld.battle.scene.CampArmy;
import com.reign.gcld.battle.scene.CityBuilder;
import com.reign.gcld.battle.scene.PlayerInfo;
import com.reign.gcld.battle.service.BattleService;
import com.reign.gcld.battle.service.NewBattleManager;
import com.reign.gcld.common.Configuration;
import com.reign.gcld.common.IDataGetter;
import com.reign.gcld.common.LocalMessages;
import com.reign.gcld.common.Players;
import com.reign.gcld.common.PushCommand;
import com.reign.gcld.common.log.Logger;
import com.reign.gcld.common.util.WebUtil;
import com.reign.gcld.general.domain.PlayerGeneralMilitary;
import com.reign.gcld.huizhan.domain.HuizhanHistory;
import com.reign.gcld.juben.common.JuBenDto;
import com.reign.gcld.juben.service.JuBenManager;
import com.reign.gcld.log.TimerLogger;
import com.reign.gcld.player.domain.Player;
import com.reign.gcld.scenario.common.ScenarioEvent;
import com.reign.gcld.sdata.domain.C;
import com.reign.gcld.sdata.domain.FightStragtegyCoe;
import com.reign.gcld.sdata.domain.Stratagem;
import com.reign.gcld.sdata.domain.Tactic;
import com.reign.gcld.sdata.domain.WorldCity;
import com.reign.gcld.sdata.domain.WorldGuard;
import com.reign.gcld.sdata.domain.WorldGuardInfo;
import com.reign.gcld.team.common.GeneralInfo;
import com.reign.gcld.team.common.Team;
import com.reign.gcld.team.common.TeamMember;
import com.reign.gcld.warbeast.common.WarBeastUtil;
import com.reign.gcld.warbeast.domain.PlayerWarBeast;
import com.reign.gcld.warbeast.domain.PlayerWarBeastResource;
import com.reign.gcld.world.common.WorldCityCommon;
import com.reign.gcld.world.domain.City;
import com.reign.gcld.world.domain.PlayerWorld;
import com.reign.gcld.world.service.CityDataCache;
import com.reign.gcld.world.service.CityService;
import com.reign.util.MessageFormatter;
import com.reign.util.Tuple;
import com.reign.util.random.RandomUtils;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import java.util.concurrent.ConcurrentSkipListSet;
import java.util.concurrent.atomic.AtomicInteger;
import org.apache.commons.lang.StringUtils;

public class Battle implements Serializable, Comparable<Battle> {
  private static final long serialVersionUID = 5346688949777842772L;
  
  private static final Logger timerLog = (Logger)new TimerLogger();
  
  long startTime;
  
  String battleId;
  
  CampArmy campArmyAtt;
  
  CampArmy campArmyDef;
  
  int battleType;
  
  String oldBattleId;
  
  public int terrain;
  
  String terrainName;
  
  public int terrainPic;
  
  public int terrainVal;
  
  boolean auto;
  
  boolean isNpc;
  
  public boolean isQuickConquer;
  
  List<BattleArmy> attList;
  
  List<BattleArmy> defList;
  
  List<CampArmy> attCamp;
  
  List<CampArmy> defCamp;
  
  ConcurrentSkipListSet<Integer> inSceneSet;
  
  Map<Integer, PlayerInfo> inBattlePlayers;
  
  public Set<CampArmy> newlyJoinSet;
  
  BaseInfo attBaseInfo;
  
  BaseInfo defBaseInfo;
  
  ScenarioEvent scenarioEvent;
  
  boolean battleDoing;
  
  StringBuilder curReport;
  
  StringBuilder curBattling;
  
  AtomicInteger attQNum;
  
  AtomicInteger defQNum;
  
  AtomicInteger campNum;
  
  AtomicInteger ticket;
  
  AtomicInteger battleNum;
  
  AtomicInteger roundNum;
  
  public WorldSceneLog worldSceneLog;
  
  long sendMsgTime;
  
  double all_damage_e_att;
  
  double all_damage_e_def;
  
  int att_gongji_base_add;
  
  int att_fangyu_base_add;
  
  int def_gongji_base_add;
  
  int def_fangyu_base_add;
  
  int lastRoundWinState;
  
  long nextMinExeTime;
  
  long nextMaxExeTime;
  
  long nextExeTime;
  
  boolean attChooseTactic;
  
  boolean defChooseTactic;
  
  boolean attChoose;
  
  boolean attBz = false;
  
  boolean defBz = false;
  
  boolean defChoose;
  
  public int lastAttOnQueuePosId;
  
  public int lastDefOnQueuePosId;
  
  boolean waitting;
  
  double world_weaken_besiege_e;
  
  int world_frontLine_buff_type;
  
  double world_frontLine_buff_exp_e;
  
  double world_frontLine_buff_att_def_e;
  
  int world_frontLine_buff_att_def_e_side;
  
  List<Tuple<Integer, String>> attBuffListRound;
  
  List<Tuple<Integer, String>> defBuffListRound;
  
  double world_round_ally_buff_att_e;
  
  double world_round_ally_buff_def_e;
  
  private Map<Integer, Long> shaDiLingMap;
  
  List<Tuple<Integer, String>> attBuffListInit;
  
  List<Tuple<Integer, String>> defBuffListInit;
  
  public Map<Integer, Integer> attSideDetail;
  
  public Map<Integer, Integer> defSideDetail;
  
  int surround;
  
  int quickBattle = 0;
  
  int quicktype = 0;
  
  public boolean tucheng = false;
  
  public boolean attrobotAdded = false;
  
  public boolean defrobotAdded = false;
  
  Map<Integer, Integer> atthbqkillInfo;
  
  Map<Integer, Integer> attxianzhenkillInfo;
  
  Map<Integer, Integer> attwsqkillInfo;
  
  Map<Integer, Integer> defhbqkillInfo;
  
  Map<Integer, Integer> defxianzhenkillInfo;
  
  Map<Integer, Integer> defwsqkillInfo;
  
  public boolean paoji = false;
  
  public String paojiname = "";
  
  public boolean pohuai = false;
  
  public Map<Integer, Map<Integer, CampArmy>> generalMap;
  
  boolean shuaiqi_inuse = false;
  
  int shuaiqi_round = 0;
  
  int shuaiqi_force = 0;
  
  String shuaiqi_name = "";
  
  boolean attneedzscy = false;
  
  boolean defneedzscy = false;
  
  CampArmy battleMonsterAtt;
  
  CampArmy battleMonsterDef;
  
  public Battle(String battleId) {
    this.quickBattle = 0;
    this.startTime = 0L;
    this.campArmyAtt = null;
    this.campArmyDef = null;
    this.oldBattleId = null;
    this.terrainName = null;
    this.isQuickConquer = false;
    this.attList = new ArrayList<>(7);
    this.defList = new ArrayList<>(7);
    this.attCamp = new ArrayList<>();
    this.defCamp = new ArrayList<>();
    this.inSceneSet = new ConcurrentSkipListSet<>();
    this.inBattlePlayers = new HashMap<>();
    this.newlyJoinSet = new HashSet<>();
    this.attBaseInfo = new BaseInfo();
    this.defBaseInfo = new BaseInfo();
    this.scenarioEvent = null;
    this.battleDoing = true;
    this.curReport = new StringBuilder();
    this.curBattling = new StringBuilder();
    this.attQNum = new AtomicInteger(0);
    this.defQNum = new AtomicInteger(0);
    this.campNum = new AtomicInteger(0);
    this.ticket = new AtomicInteger(0);
    this.battleNum = new AtomicInteger(0);
    this.roundNum = new AtomicInteger(0);
    this.worldSceneLog = null;
    this.sendMsgTime = System.currentTimeMillis() - 60000L;
    this.all_damage_e_att = 0.0D;
    this.all_damage_e_def = 0.0D;
    this.att_gongji_base_add = 0;
    this.att_fangyu_base_add = 0;
    this.def_gongji_base_add = 0;
    this.def_fangyu_base_add = 0;
    this.lastRoundWinState = 0;
    this.nextMinExeTime = System.currentTimeMillis();
    this.nextMaxExeTime = System.currentTimeMillis();
    this.nextExeTime = System.currentTimeMillis();
    this.attChooseTactic = false;
    this.defChooseTactic = false;
    this.attChoose = false;
    this.defChoose = false;
    this.lastAttOnQueuePosId = 0;
    this.lastDefOnQueuePosId = 0;
    this.waitting = false;
    this.world_weaken_besiege_e = 0.0D;
    this.world_frontLine_buff_type = 0;
    this.world_frontLine_buff_exp_e = 1.0D;
    this.world_frontLine_buff_att_def_e = 0.0D;
    this.world_frontLine_buff_att_def_e_side = 0;
    this.attBuffListRound = new LinkedList<>();
    this.defBuffListRound = new LinkedList<>();
    this.world_round_ally_buff_att_e = 0.0D;
    this.world_round_ally_buff_def_e = 0.0D;
    this.shaDiLingMap = new HashMap<>();
    this.attBuffListInit = new LinkedList<>();
    this.defBuffListInit = new LinkedList<>();
    this.attSideDetail = new HashMap<>();
    this.defSideDetail = new HashMap<>();
    this.surround = 0;
    this.battleId = battleId;
    this.startTime = System.currentTimeMillis();
    this.atthbqkillInfo = new HashMap<>();
    this.attxianzhenkillInfo = new HashMap<>();
    this.attwsqkillInfo = new HashMap<>();
    this.defhbqkillInfo = new HashMap<>();
    this.defxianzhenkillInfo = new HashMap<>();
    this.defwsqkillInfo = new HashMap<>();
    this.generalMap = new HashMap<>();
  }
  
  public int getQuickBattle() {
    return this.quickBattle;
  }
  
  public void setQuickBattle(int mode) {
    this.quickBattle = mode;
  }
  
  public long getStartTime() {
    return this.startTime;
  }
  
  public int getBattleType() {
    return this.battleType;
  }
  
  public int getTerrainPic() {
    return this.terrainPic;
  }
  
  public int getTerrainVal() {
    return this.terrainVal;
  }
  
  public int getTerrain() {
    return this.terrain;
  }
  
  public boolean isAuto() {
    return this.auto;
  }
  
  public List<BattleArmy> getAttList() {
    return this.attList;
  }
  
  public List<BattleArmy> getDefList() {
    return this.defList;
  }
  
  public List<CampArmy> getAttCamp() {
    return this.attCamp;
  }
  
  public List<CampArmy> getDefCamp() {
    return this.defCamp;
  }
  
  public void addInSceneSet(int playerId) {
    this.inSceneSet.add(Integer.valueOf(playerId));
  }
  
  public ConcurrentSkipListSet<Integer> getInSceneSet() {
    return this.inSceneSet;
  }
  
  public boolean isInSceneSet(int playerId) {
    return this.inSceneSet.contains(Integer.valueOf(playerId));
  }
  
  public Map<Integer, PlayerInfo> getInBattlePlayers() {
    return this.inBattlePlayers;
  }
  
  public Map<Integer, Integer> getAttHbqKillInfos() {
    return this.atthbqkillInfo;
  }
  
  public Map<Integer, Integer> getAttWsqKillInfos() {
    return this.attwsqkillInfo;
  }
  
  public Map<Integer, Integer> getAttXianZhenKillInfos() {
    return this.attxianzhenkillInfo;
  }
  
  public Map<Integer, Integer> getDefHbqKillInfos() {
    return this.defhbqkillInfo;
  }
  
  public Map<Integer, Integer> getDefWsqKillInfos() {
    return this.defwsqkillInfo;
  }
  
  public Map<Integer, Integer> getDefXianZhenKillInfos() {
    return this.defxianzhenkillInfo;
  }
  
  public Map<Integer, Map<Integer, CampArmy>> getGeneralMap() {
    return this.generalMap;
  }
  
  public boolean isBattleDoing() {
    return this.battleDoing;
  }
  
  public AtomicInteger getAttQNum() {
    return this.attQNum;
  }
  
  public AtomicInteger getDefQNum() {
    return this.defQNum;
  }
  
  public AtomicInteger getCampNum() {
    return this.campNum;
  }
  
  public AtomicInteger getTicket() {
    return this.ticket;
  }
  
  public AtomicInteger getBattleNum() {
    return this.battleNum;
  }
  
  public AtomicInteger getRoundNum() {
    return this.roundNum;
  }
  
  public String getBattleId() {
    return this.battleId;
  }
  
  public BaseInfo getAttBaseInfo() {
    return this.attBaseInfo;
  }
  
  public BaseInfo getDefBaseInfo() {
    return this.defBaseInfo;
  }
  
  public boolean isNpc() {
    return this.isNpc;
  }
  
  public void setSendMsgTime(long sendMsgTime) {
    this.sendMsgTime = sendMsgTime;
  }
  
  public long getSendMsgTime() {
    return this.sendMsgTime;
  }
  
  public void clearNewlyJoinSet() {
    this.newlyJoinSet.clear();
  }
  
  public void reSetAllDamageE(IDataGetter dataGetter, int attForceId, int defForceId) {
    Tuple<Double, Double> tuple = dataGetter.getCilvilTrickService().afterStateTrick2(this.defBaseInfo.id, attForceId, defForceId);
    if (tuple != null) {
      this.all_damage_e_att = ((Double)tuple.left).doubleValue();
      this.all_damage_e_def = ((Double)tuple.right).doubleValue();
    } 
  }
  
  public long getNextMinExeTime() {
    return this.nextMinExeTime;
  }
  
  public void setNextMinExeTime(long nextMinExeTime) {
    this.nextMinExeTime = nextMinExeTime;
  }
  
  public long getNextMaxExeTime() {
    return this.nextMaxExeTime;
  }
  
  public void setNextMaxExeTime(long nextMaxExeTime) {
    this.nextMaxExeTime = nextMaxExeTime;
  }
  
  public long getNextExeTime() {
    return this.nextExeTime;
  }
  
  public void setNextExeTime(long exeTime) {
    this.nextExeTime = exeTime;
  }
  
  public boolean isAttChoose() {
    return this.attChoose;
  }
  
  public boolean isAttBz() {
    return this.attBz;
  }
  
  public boolean isDefBz() {
    return this.defBz;
  }
  
  public boolean isDefChoose() {
    return this.defChoose;
  }
  
  public boolean isAttChooseTactic() {
    return this.attChooseTactic;
  }
  
  public boolean isDefChooseTactic() {
    return this.defChooseTactic;
  }
  
  public boolean getTuCheng() {
    return this.tucheng;
  }
  
  public void setTuCheng(boolean bz) {
    this.tucheng = bz;
  }
  
  public boolean getAttRobotAdded() {
    return this.attrobotAdded;
  }
  
  public void setAttRobotAdded(boolean bz) {
    this.attrobotAdded = bz;
  }
  
  public boolean getDefRobotAdded() {
    return this.defrobotAdded;
  }
  
  public void setDefRobotAdded(boolean bz) {
    this.defrobotAdded = bz;
  }
  
  public Long getShaDiLingExpireTime(Integer forceId) {
    if (this.shaDiLingMap == null)
      return null; 
    return this.shaDiLingMap.get(forceId);
  }
  
  public void useShaDiLing(Integer forceId, Long duration) {
    Long baseTime = this.shaDiLingMap.get(forceId);
    if (baseTime == null || baseTime.longValue() < System.currentTimeMillis())
      baseTime = Long.valueOf(System.currentTimeMillis()); 
    this.shaDiLingMap.put(forceId, Long.valueOf(baseTime.longValue() + duration.longValue()));
  }
  
  public Boolean IsShaDiLingDoubleed(Integer forceId) {
    if (this.shaDiLingMap == null || this.shaDiLingMap.isEmpty())
      return Boolean.valueOf(false); 
    Long baseTime = this.shaDiLingMap.get(forceId);
    if (baseTime != null && baseTime.longValue() >= System.currentTimeMillis())
      return Boolean.valueOf(true); 
    return Boolean.valueOf(false);
  }
  
  public int getSurround() {
    return this.surround;
  }
  
  public void setSurround(int surround) {
    this.surround = surround;
  }
  
  public boolean getPaoJi() {
    return this.paoji;
  }
  
  public void setPaoJi(boolean paoji) {
    this.paoji = paoji;
  }
  
  public boolean getPoHuai() {
    return this.pohuai;
  }
  
  public void setPoHuai(boolean pohuai) {
    this.pohuai = pohuai;
  }
  
  public String getPaoJiName() {
    return this.paojiname;
  }
  
  public void setPaoJiName(String paojiname) {
    this.paojiname = paojiname;
  }
  
  public boolean getShuaiQiInUse() {
    return this.shuaiqi_inuse;
  }
  
  public void setShuaiQiInUse(boolean squse) {
    this.shuaiqi_inuse = squse;
  }
  
  public int getShuaiQiRound() {
    return this.shuaiqi_round;
  }
  
  public void setShuaiQiRound(int sqrd) {
    this.shuaiqi_round = sqrd;
  }
  
  public int getShuaiQiForce() {
    return this.shuaiqi_force;
  }
  
  public void setShuaiQiForce(int sqforce) {
    this.shuaiqi_force = sqforce;
  }
  
  public String getShuaiQiName() {
    return this.shuaiqi_name;
  }
  
  public void SetShuaiQiName(String sqname) {
    this.shuaiqi_name = sqname;
  }
  
  public boolean getAttNeedZscy() {
    return this.attneedzscy;
  }
  
  public void setAttNeedZscy(boolean attneedzscy) {
    this.attneedzscy = attneedzscy;
  }
  
  public boolean getDefNeedZscy() {
    return this.defneedzscy;
  }
  
  public void setDefNeedZscy(boolean defneedzscy) {
    this.defneedzscy = defneedzscy;
  }
  
  public CampArmy getBattleMonsterAtt() {
    return this.battleMonsterAtt;
  }
  
  public void setBattleMonsterAtt(CampArmy battleMonsterAtt) {
    this.battleMonsterAtt = battleMonsterAtt;
  }
  
  public CampArmy getBattleMonsterDef() {
    return this.battleMonsterDef;
  }
  
  public void setBattleMonsterDef(CampArmy battleMonsterDef) {
    this.battleMonsterDef = battleMonsterDef;
  }
  
  public int getQuickType() {
    return this.quicktype;
  }
  
  public void setQuickType(int quicktype) {
    this.quicktype = quicktype;
  }
  
  public static boolean proYoudi(IDataGetter dataGetter) {
    C c = (C)dataGetter.getcCache().get("World.Due.SuccessProb");
    double pro = 0.5D;
    if (c != null)
      pro = c.getValue().floatValue(); 
    double tpro = WebUtil.nextDouble();
    return (tpro <= pro);
  }
  
  public static boolean proChuji(IDataGetter dataGetter) {
    C c = (C)dataGetter.getcCache().get("World.InitDue.SuccessProb");
    double pro = 0.5D;
    if (c != null)
      pro = c.getValue().floatValue(); 
    return (WebUtil.nextDouble() <= pro);
  }
  
  public static boolean pkPro(int pkType, IDataGetter dataGetter) {
    if (pkType == 1)
      return proYoudi(dataGetter); 
    return proChuji(dataGetter);
  }
  
  public static void DaZhaoYunBatcamp(CampArmy campArmy, List<BattleArmy> attAddQlist, List<BattleArmy> batList, List<CampArmy> batCamp, int battleSide, AtomicInteger batQNum, BaseInfo baseInfo, Map<Integer, PlayerInfo> inBattlePlayers, RoundInfo roundInfo, Battle bat, IDataGetter dataGetter) {
    if (campArmy.armyHpLoss >= campArmy.armyHpOrg && campArmy.getPlayerId() >= 0 && !campArmy.getZyMaxRow())
      if (campArmy.getGeneralId() == 204 && campArmy.legendEvoke) {
        int gailv = 1000;
        PlayerGeneralMilitary dazyGm = dataGetter.getPlayerGeneralMilitaryDao().getMilitary(campArmy.getPlayerId(), 204);
        Random rand = new Random();
        int randomIntPositive = rand.nextInt(999999999);
        PlayerGeneralMilitaryPhantom phantom = new PlayerGeneralMilitaryPhantom();
        phantom.setBuyTime(new Date());
        phantom.setPlayerId(Integer.valueOf(campArmy.getPlayerId()));
        phantom.setForceId(Integer.valueOf(campArmy.getForceId()));
        phantom.setPlayerLv(Integer.valueOf(campArmy.getPlayerLv()));
        phantom.setGeneralId(Integer.valueOf(campArmy.getGeneralId()));
        phantom.setGeneralLv(Integer.valueOf(campArmy.getGeneralLv()));
        phantom.setTroopId(Integer.valueOf(campArmy.getTroopId()));
        phantom.setStrength(Integer.valueOf(campArmy.getStrength()));
        phantom.setLeader(Integer.valueOf(campArmy.getLeader()));
        phantom.setUnionState(Integer.valueOf(campArmy.getUnionState()));
        phantom.setColumnNum(Integer.valueOf(campArmy.getColumn()));
        int maxFreePc = campArmy.getMaxForces();
        int remainder = maxFreePc % 3 * phantom.getColumnNum().intValue();
        maxFreePc -= remainder;
        phantom.setHp(Integer.valueOf(maxFreePc));
        phantom.setHpMax(Integer.valueOf(maxFreePc));
        if (campArmy.getAttDef_B() != null) {
          phantom.setAttB(Integer.valueOf((campArmy.getAttDef_B()).ATT_B));
          phantom.setDefB(Integer.valueOf((campArmy.getAttDef_B()).DEF_B));
        } else {
          phantom.setAttB(Integer.valueOf(0));
          phantom.setDefB(Integer.valueOf(0));
        } 
        phantom.setTacticAtt(Integer.valueOf(campArmy.getTACTIC_ATT()));
        phantom.setVId(Integer.valueOf(randomIntPositive));
        phantom.setTacticDef(Integer.valueOf(campArmy.getTACTIC_DEF()));
        phantom.setType(Integer.valueOf(campArmy.getCopyType()));
        phantom.setAtt(Integer.valueOf(campArmy.getAttEffect()));
        phantom.setDef(Integer.valueOf(campArmy.getDefEffect()));
        if (dazyGm != null) {
          Player player = dataGetter.getPlayerDao().read(campArmy.getPlayerId());
          if (player != null) {
            CampArmy daJiangCamp;
            Builder builder = BuilderFactory.getInstance().getBuilder(bat.getBattleType());
            if (campArmy.isPhantom) {
              daJiangCamp = builder.copyArmyFromPhantom(dataGetter, bat, phantom, battleSide);
            } else {
              daJiangCamp = builder.copyArmyFromPlayerTable(player, dazyGm, dataGetter, 1, bat, battleSide);
              maxFreePc = daJiangCamp.getMaxForces();
              dazyGm.setForces(Integer.valueOf(maxFreePc));
              int forces = phantom.getHp().intValue();
              forces -= remainder;
              daJiangCamp.setArmyHp(forces);
              daJiangCamp.setArmyHpOrg(forces);
              daJiangCamp.setMaxForces(phantom.getHpMax().intValue());
              daJiangCamp.setColumn(phantom.getColumnNum().intValue());
              daJiangCamp.shield = 999999;
              daJiangCamp.setTroopHp(phantom.getHpMax().intValue() / phantom.getColumnNum().intValue());
            } 
            if (daJiangCamp != null) {
              daJiangCamp.setFuBingType(1);
              daJiangCamp.setTroopType(157);
              daJiangCamp.setNeedZongHeng2(true);
              daJiangCamp.setQiangyi(campArmy.qiangyi);
              daJiangCamp.setZyMaxRow(true);
              batCamp.add(0, daJiangCamp);
              baseInfo.setAllNum(baseInfo.getAllNum() + daJiangCamp.getArmyHp());
              baseInfo.setNum(baseInfo.getNum() + daJiangCamp.getArmyHp());
              List<BattleArmy> attList = new ArrayList<>();
              BattleArmy fjxz = Builder.MaxZYaddQueues(bat, attAddQlist, attList, daJiangCamp, battleSide, batQNum);
              batList.add(0, fjxz);
              Builder.getReportType64(roundInfo.battleMsg, attAddQlist, (battleSide == 1) ? "att" : "def");
            } 
          } 
        } 
      }  
  }
  
  public int chooseCampArmyGeneralId(IDataGetter dataGetter, int playerId, int type) {
    synchronized (this.battleId) {
      if (1 == type) {
        for (CampArmy ca : this.attCamp) {
          if (ca.getPlayerId() == playerId && !ca.isPhantom && !ca.onQueues && ca.getIsDeputy() <= 0)
            return ca.getGeneralId(); 
        } 
      } else if (2 == type) {
        for (CampArmy ca : this.defCamp) {
          if (ca.getPlayerId() == playerId && !ca.isPhantom && !ca.onQueues && ca.getIsDeputy() <= 0)
            return ca.getGeneralId(); 
        } 
      } 
      return 0;
    } 
  }
  
  public int chooseCampArmy(IDataGetter dataGetter, int playerId, CampArmy[] cas, int type) {
    synchronized (this.battleId) {
      if (1 == type) {
        cas[0] = null;
        for (CampArmy ca : this.attCamp) {
          if (ca.getPlayerId() == playerId && !ca.isPhantom && !ca.onQueues && ca.armyHp > 0 && ca.isDeputy <= 0) {
            cas[0] = ca;
            break;
          } 
        } 
        if (cas[0] == null)
          return 2; 
        cas[1] = null;
        int i = 9;
        if (this.defCamp.size() >= 10 && ((CampArmy)this.defCamp.get(9)).isDeputy <= 0 && (!((CampArmy)this.defCamp.get(9)).getLegendEvoke() || (((CampArmy)this.defCamp.get(9)).getLegendEvoke() && cas[0].getArmyHpOrg() * 100 / ((CampArmy)this.defCamp.get(9)).getArmyHpOrg() >= 90))) {
          cas[1] = this.defCamp.get(9);
        } else {
          for (int j = this.defCamp.size() - 1; j >= 1; j--) {
            CampArmy ca2 = getDefCamp().get(j);
            if (!ca2.onQueues && ca2.armyHp > 0 && ca2.isDeputy <= 0 && (!ca2.getLegendEvoke() || (ca2.getLegendEvoke() && cas[0].getArmyHpOrg() * 100 / ca2.getArmyHpOrg() >= 90))) {
              cas[1] = ca2;
              break;
            } 
          } 
        } 
        if (cas[1] == null)
          return 4; 
        if (!proYoudi(dataGetter))
          return 3; 
        this.attCamp.remove(cas[0]);
        this.defCamp.remove(cas[1]);
        if (cas[0].getPlayerId() > 0 && !cas[0].isPhantom())
          NewBattleManager.getInstance().quitBattle(this, cas[0].getPlayerId(), new int[] { cas[0].getGeneralId() }); 
        if (cas[1].getPlayerId() > 0 && !cas[1].isPhantom())
          NewBattleManager.getInstance().quitBattle(this, cas[1].getPlayerId(), new int[] { cas[1].getGeneralId() }); 
        if (this.attBaseInfo.getNum() < (cas[0]).armyHp)
          ErrorSceneLog.getInstance().appendErrorMsg("Battle att num小于0,battle 530行"); 
        this.attBaseInfo.setAllNum(this.attBaseInfo.getAllNum() - (cas[0]).armyHp);
        this.attBaseInfo.setNum(this.attBaseInfo.getNum() - (cas[0]).armyHp);
        if (this.defBaseInfo.getNum() < (cas[1]).armyHp)
          ErrorSceneLog.getInstance().appendErrorMsg("Battle att num小于0,battle 536行"); 
        this.defBaseInfo.setAllNum(this.defBaseInfo.getAllNum() - (cas[1]).armyHp);
        this.defBaseInfo.setNum(this.defBaseInfo.getNum() - (cas[1]).armyHp);
        return 1;
      } 
      if (2 != type)
        return 2; 
      cas[1] = null;
      for (CampArmy ca : this.defCamp) {
        if (ca.getPlayerId() == playerId && !ca.isPhantom && !ca.onQueues && ca.armyHp > 0 && ca.isDeputy <= 0) {
          cas[1] = ca;
          break;
        } 
      } 
      if (cas[1] == null)
        return 2; 
      cas[0] = null;
      int idx = 9;
      if (this.attCamp.size() >= 10 && ((CampArmy)this.attCamp.get(9)).isDeputy <= 0) {
        cas[0] = this.attCamp.get(9);
      } else {
        for (int j = this.attCamp.size() - 1; j >= 1; j--) {
          CampArmy ca2 = this.attCamp.get(j);
          if (!ca2.onQueues && ca2.armyHp > 0 && ca2.isDeputy <= 0) {
            cas[0] = ca2;
            break;
          } 
        } 
      } 
      if (cas[0] == null)
        return 4; 
      if (!proChuji(dataGetter))
        return 3; 
      this.attCamp.remove(cas[0]);
      this.defCamp.remove(cas[1]);
      if (cas[0].getPlayerId() > 0 && !cas[0].isPhantom())
        NewBattleManager.getInstance().quitBattle(this, cas[0].getPlayerId(), new int[] { cas[0].getGeneralId() }); 
      BattleSceneLog.getInstance().info("#batId:" + getBattleId() + "_" + getStartTime() + "#quit:chuji#side:att#playerId:" + cas[0].getPlayerId() + ":" + (cas[0]).isPhantom + "#general:" + cas[0].getGeneralId() + "#attSize:" + this.attCamp.size());
      if (cas[1].getPlayerId() > 0 && !cas[1].isPhantom())
        NewBattleManager.getInstance().quitBattle(this, cas[1].getPlayerId(), new int[] { cas[1].getGeneralId() }); 
      BattleSceneLog.getInstance().info("#batId:" + getBattleId() + "_" + getStartTime() + "#quit:chuji#side:def#playerId:" + cas[1].getPlayerId() + ":" + (cas[1]).isPhantom + "#general:" + cas[1].getGeneralId() + "#defSize:" + this.defCamp.size());
      if (this.attBaseInfo.getNum() < (cas[0]).armyHp)
        ErrorSceneLog.getInstance().appendErrorMsg("Battle att num小于0,battle 594行"); 
      this.attBaseInfo.setNum(this.attBaseInfo.getNum() - (cas[0]).armyHp);
      this.attBaseInfo.setAllNum(this.attBaseInfo.getAllNum() - (cas[0]).armyHp);
      if (this.defBaseInfo.getNum() < (cas[1]).armyHp)
        ErrorSceneLog.getInstance().appendErrorMsg("Battle def num小于0,battle 600行"); 
      this.defBaseInfo.setNum(this.defBaseInfo.getNum() - (cas[1]).armyHp);
      this.defBaseInfo.setAllNum(this.defBaseInfo.getAllNum() - (cas[1]).armyHp);
      return 1;
    } 
  }
  
  public int chooseCampArmyForNTYellowTurbans(IDataGetter dataGetter, int playerId, CampArmy[] cas) {
    Player player = dataGetter.getPlayerDao().read(playerId);
    synchronized (this.battleId) {
      cas[0] = null;
      boolean fromattack = true;
      for (CampArmy ca : this.attCamp) {
        if (ca.getPlayerId() == playerId && !ca.isPhantom && !ca.onQueues && ca.armyHp > 0 && ca.isDeputy <= 0) {
          cas[0] = ca;
          break;
        } 
      } 
      if (cas[0] == null)
        return 2; 
      cas[1] = null;
      for (CampArmy ca : this.attCamp) {
        if (ca.getForceId() != player.getForceId().intValue() && !ca.onQueues && ca.armyHp > 0 && ca.isDeputy <= 0) {
          cas[1] = ca;
          break;
        } 
      } 
      if (cas[1] == null)
        for (CampArmy ca : this.defCamp) {
          if (!ca.onQueues && ca.armyHp > 0 && ca.isDeputy <= 0) {
            cas[1] = ca;
            fromattack = false;
            break;
          } 
        }  
      if (cas[1] == null)
        return 4; 
      if (!proYoudi(dataGetter))
        return 3; 
      this.attCamp.remove(cas[0]);
      if (fromattack) {
        this.attCamp.remove(cas[1]);
      } else {
        this.defCamp.remove(cas[1]);
      } 
      if (cas[0].getPlayerId() > 0 && !cas[0].isPhantom())
        NewBattleManager.getInstance().quitBattle(this, cas[0].getPlayerId(), new int[] { cas[0].getGeneralId() }); 
      BattleSceneLog.getInstance().info("#batId:" + getBattleId() + "_" + getStartTime() + "#quit:youdiNTYellowTurbans#side:att#playerId:" + cas[0].getPlayerId() + ":" + (cas[0]).isPhantom + "#general:" + cas[0].getGeneralId() + "#attSize:" + this.attCamp.size());
      if (cas[1].getPlayerId() > 0 && !cas[1].isPhantom())
        NewBattleManager.getInstance().quitBattle(this, cas[1].getPlayerId(), new int[] { cas[1].getGeneralId() }); 
      BattleSceneLog.getInstance().info("#batId:" + getBattleId() + "_" + getStartTime() + "#quit:youdiNTYellowTurbans#side:att#playerId:" + cas[1].getPlayerId() + ":" + (cas[1]).isPhantom + "#general:" + cas[1].getGeneralId() + "#defSize:" + this.defCamp.size());
      this.attBaseInfo.setAllNum(this.attBaseInfo.getAllNum() - (cas[0]).armyHp);
      if (this.attBaseInfo.getNum() < (cas[0]).armyHp + (cas[1]).armyHp)
        ErrorSceneLog.getInstance().appendErrorMsg("battle chooseCampArmyForNTYellowTurbans 兵力小于0,battle 663行"); 
      this.attBaseInfo.setNum(this.attBaseInfo.getNum() - (cas[0]).armyHp);
      if (fromattack) {
        this.attBaseInfo.setAllNum(this.attBaseInfo.getAllNum() - (cas[1]).armyHp);
        this.attBaseInfo.setNum(this.attBaseInfo.getNum() - (cas[1]).armyHp);
      } else {
        this.defBaseInfo.setAllNum(this.defBaseInfo.getAllNum() - (cas[1]).armyHp);
        this.defBaseInfo.setNum(this.defBaseInfo.getNum() - (cas[1]).armyHp);
      } 
      return 1;
    } 
  }
  
  public void beginOneToOneBattle(IDataGetter dataGetter, int OneToOneBattleType, int playerId, CampArmy[] cas, Battle oldBattle) {
    Builder builder = BuilderFactory.getInstance().getBuilder(OneToOneBattleType);
    synchronized (this.battleId) {
      this.battleType = OneToOneBattleType;
      this.oldBattleId = oldBattle.battleId;
      this.campArmyAtt = cas[0];
      this.campArmyDef = cas[1];
      this.attBaseInfo.setId(playerId);
      int armyhp = (cas[0]).armyHp;
      if (armyhp <= 0) {
        armyhp = 3;
        (cas[0]).armyHp = 3;
        ErrorSceneLog.getInstance().appendErrorMsg("baseinfo setnum 兵力小于0 battle 676行");
      } 
      this.attBaseInfo.setAllNum(armyhp);
      this.attBaseInfo.setNum(armyhp);
      this.attBaseInfo.setForceId((cas[0]).forceId);
      cas[0].setArmyHpOrg(armyhp);
      cas[0].setArmyHpLoss(0);
      int defId = oldBattle.defBaseInfo.id;
      this.defBaseInfo.setId(defId);
      int armyhp1 = (cas[1]).armyHp;
      if (armyhp1 <= 0) {
        armyhp1 = 3;
        (cas[1]).armyHp = 3;
        ErrorSceneLog.getInstance().appendErrorMsg("baseinfo setnum 兵力小于0 battle 690行");
      } 
      this.defBaseInfo.setAllNum(armyhp1);
      this.defBaseInfo.setNum(armyhp1);
      this.defBaseInfo.setForceId((cas[1]).forceId);
      cas[1].setArmyHpOrg(armyhp1);
      cas[1].setArmyHpLoss(0);
      this.worldSceneLog = WorldSceneLog.getInstance();
      setBattleInitBuff(dataGetter, defId);
      caculateCivilTrickBuff(dataGetter);
      Terrain terrain = builder.getTerrain(playerId, defId, dataGetter);
      this.terrain = terrain.getDisplay();
      switch (this.terrainVal = terrain.getValue()) {
        case 1:
          this.terrainName = LocalMessages.TERRAIN_NAME_1;
          break;
        case 2:
          this.terrainName = LocalMessages.TERRAIN_NAME_2;
          break;
        case 3:
          this.terrainName = LocalMessages.TERRAIN_NAME_3;
          break;
        case 4:
          this.terrainName = LocalMessages.TERRAIN_NAME_4;
          break;
        default:
          ErrorSceneLog.getInstance().appendErrorMsg("terrain error").append("builder", Integer.valueOf(builder.battleType)).append("terrainType", Integer.valueOf(defId)).append("this.terrainVal", Integer.valueOf(this.terrainVal)).flush();
          this.terrainName = LocalMessages.TERRAIN_NAME_DEFAULT;
          break;
      } 
      this.terrainPic = terrain.getTerrainPic();
      this.attCamp.add(cas[0]);
      this.defCamp.add(cas[1]);
      builder.setSurroundState(dataGetter, this);
      if (cas[0].getPlayerId() > 0) {
        int zdzsTech = dataGetter.getTechEffectCache().getTechEffect(cas[0].getPlayerId(), 43);
        int autoStrategy = 0;
        if (zdzsTech > 0) {
          PlayerBattleAttribute pba = dataGetter.getPlayerBattleAttributeDao().read(cas[0].getPlayerId());
          autoStrategy = pba.getAutoStrategy().intValue();
        } else {
          autoStrategy = -1;
        } 
        this.inBattlePlayers.put(Integer.valueOf((cas[0]).playerId), new PlayerInfo((cas[0]).playerId, true, autoStrategy));
        if (!(cas[0]).isPhantom)
          NewBattleManager.getInstance().joinBattle(this, (cas[0]).playerId, new int[] { cas[0].getGeneralId() }); 
      } 
      BattleSceneLog.getInstance().info("#batId:" + getBattleId() + "_" + getStartTime() + "#add:1Vs1Add#side:att#playerId:" + cas[0].getPlayerId() + ":" + (cas[0]).isPhantom + "#general:" + cas[0].getGeneralId() + "#attSize:" + this.attCamp.size());
      if (cas[1].getPlayerId() > 0) {
        int zdzsTech = dataGetter.getTechEffectCache().getTechEffect(cas[1].getPlayerId(), 43);
        int autoStrategy = 0;
        if (zdzsTech > 0) {
          PlayerBattleAttribute pba = dataGetter.getPlayerBattleAttributeDao().read(cas[1].getPlayerId());
          autoStrategy = pba.getAutoStrategy().intValue();
        } else {
          autoStrategy = -1;
        } 
        this.inBattlePlayers.put(Integer.valueOf((cas[1]).playerId), new PlayerInfo((cas[1]).playerId, false, autoStrategy));
        if (!(cas[1]).isPhantom)
          NewBattleManager.getInstance().joinBattle(this, (cas[1]).playerId, new int[] { cas[1].getGeneralId() }); 
      } 
      BattleSceneLog.getInstance().info("#batId:" + getBattleId() + "_" + getStartTime() + "#add:1Vs1Add#side:def#playerId:" + cas[1].getPlayerId() + ":" + (cas[1]).isPhantom + "#general:" + cas[1].getGeneralId() + "#defSize:" + this.defCamp.size());
      StringBuilder battleMsg = new StringBuilder();
      int sn = this.ticket.incrementAndGet();
      battleMsg.append(sn).append("|").append(this.battleId).append("#");
      List<BattleArmy> attAddQlist = new ArrayList<>();
      Builder.onceAddQueues(attAddQlist, this.attList, this.attCamp, 1, this.attQNum, this.attBaseInfo, this.inBattlePlayers, null, this, dataGetter);
      Builder.getReportType2(battleMsg, attAddQlist, "att");
      List<BattleArmy> defAddQlist = new ArrayList<>();
      Builder.onceAddQueues(defAddQlist, this.defList, this.defCamp, 0, this.defQNum, this.defBaseInfo, this.inBattlePlayers, null, this, dataGetter);
      Builder.getReportType2(battleMsg, defAddQlist, "def");
      Builder.getReportType13(this, battleMsg);
      Builder.getReportType100(dataGetter, this, battleMsg);
      if (this.attList.size() > 0 && this.defList.size() > 0)
        setBattleRoundBuff(dataGetter, ((BattleArmy)this.attList.get(0)).getCampArmy(), ((BattleArmy)this.defList.get(0)).getCampArmy()); 
      if (this.attList.size() > 0)
        Builder.getReportType16(dataGetter, this, battleMsg, ((BattleArmy)this.attList.get(0)).getCampArmy(), "att", true, true); 
      if (this.defList.size() > 0)
        Builder.getReportType16(dataGetter, this, battleMsg, ((BattleArmy)this.defList.get(0)).getCampArmy(), "def", true, true); 
      SaveCurReport(dataGetter);
      this.curBattling.append("#").append(26).append("|").append(12000).append("|-1|-1|-1|-1#");
      Builder.getStrategyInfo(this.curBattling, this, dataGetter);
      battleMsg.append(26).append("|").append(12000).append("|-1|-1|-1|-1#");
      Builder.getStrategyInfo(battleMsg, this, dataGetter);
      this.waitting = true;
      Builder.sendMsgToAll(this, battleMsg);
      PlayerInfo piAtt = null;
      if (this.attList.size() > 0)
        piAtt = this.inBattlePlayers.get(Integer.valueOf((((BattleArmy)this.attList.get(0)).getCampArmy()).playerId)); 
      boolean attAutoStChoosed = ((piAtt != null && piAtt.autoStrategy == 1) || (cas[0]).isPhantom);
      PlayerInfo piDef = null;
      if (this.defList.size() > 0)
        piDef = this.inBattlePlayers.get(Integer.valueOf((((BattleArmy)this.defList.get(0)).getCampArmy()).playerId)); 
      boolean defAutoStChoosed = ((piDef != null && piDef.autoStrategy == 1) || (cas[1]).isPhantom);
      if (attAutoStChoosed && this.attList.size() > 0 && ((BattleArmy)this.attList.get(0)).getCampArmy().getTacticVal() > 0) {
        this.attChoose = true;
        this.attChooseTactic = true;
      } 
      if (defAutoStChoosed && this.defList.size() > 0 && getSurround() == 0 && ((BattleArmy)this.defList.get(0)).getCampArmy().getTacticVal() > 0) {
        this.defChoose = true;
        this.defChooseTactic = true;
      } 
      if (!attAutoStChoosed && !defAutoStChoosed) {
        this.nextMaxExeTime = System.currentTimeMillis() + 12000L;
      } else {
        this.nextMaxExeTime = System.currentTimeMillis() + 6000L;
      } 
      long exeTime = System.currentTimeMillis();
      String quickMode = Configuration.getProperty("gcld.battle.quick");
      if (quickMode.equals("1") || this.quickBattle > 0) {
        int interval = Integer.parseInt(Configuration.getProperty("gcld.battle.quick.interval"));
        exeTime += interval;
      } else {
        exeTime = this.nextMaxExeTime;
      } 
      changeExeTime(exeTime);
    } 
  }
  
  public boolean init(BattleAttacker battleAttacker, int battleType, int defId, IDataGetter dataGetter, boolean auto, int terrainType) {
    Builder builder = BuilderFactory.getInstance().getBuilder(battleType);
    synchronized (this.battleId) {
      this.battleType = battleType;
      this.worldSceneLog = WorldSceneLog.getInstance();
      builder.setAttDefBaseInfo(dataGetter, this, battleAttacker, battleType, defId);
      this.auto = auto;
      if (battleType == 8) {
        int dixingtype = terrainType;
        if (dixingtype > 1)
          dixingtype--; 
        if (dixingtype <= 0 || dixingtype >= 5)
          dixingtype = 1; 
        Terrain terrain = (Terrain)BattleService.rankTerrainmapValToDis.get(Integer.valueOf(dixingtype));
        this.terrain = terrain.getDisplay();
        switch (this.terrainVal = terrain.getValue()) {
          case 1:
            this.terrainName = LocalMessages.TERRAIN_NAME_1;
            break;
          case 2:
            this.terrainName = LocalMessages.TERRAIN_NAME_2;
            break;
          case 3:
            this.terrainName = LocalMessages.TERRAIN_NAME_3;
            break;
          case 4:
            this.terrainName = LocalMessages.TERRAIN_NAME_4;
            break;
          default:
            ErrorSceneLog.getInstance().appendErrorMsg("terrain error").append("terrainType", Integer.valueOf(terrainType)).append("this.terrainVal", Integer.valueOf(this.terrainVal)).flush();
            this.terrainName = LocalMessages.TERRAIN_NAME_DEFAULT;
            break;
        } 
        this.terrainPic = terrain.getTerrainPic();
      } else {
        Terrain terrain = builder.getTerrain(battleAttacker.attPlayerId, defId, dataGetter);
        this.terrain = terrain.getDisplay();
        switch (this.terrainVal = terrain.getValue()) {
          case 1:
            this.terrainName = LocalMessages.TERRAIN_NAME_1;
            break;
          case 2:
            this.terrainName = LocalMessages.TERRAIN_NAME_2;
            break;
          case 3:
            this.terrainName = LocalMessages.TERRAIN_NAME_3;
            break;
          case 4:
            this.terrainName = LocalMessages.TERRAIN_NAME_4;
            break;
          default:
            ErrorSceneLog.getInstance().appendErrorMsg("terrain error").append("builder", Integer.valueOf(builder.battleType)).append("defId", Integer.valueOf(defId)).append("this.terrainVal", Integer.valueOf(this.terrainVal)).flush();
            this.terrainName = LocalMessages.TERRAIN_NAME_DEFAULT;
            break;
        } 
        this.terrainPic = terrain.getTerrainPic();
      } 
      if (!this.auto && battleAttacker.attPlayerId > 0)
        builder.inBattleInfo(battleAttacker.attPlayerId, true); 
      this.isNpc = builder.initDefCamp(dataGetter, battleAttacker, defId, this);
      if (battleAttacker.attPlayerId > 0)
        builder.addInSceneSet(this, battleAttacker.attPlayerId); 
      builder.setSurroundState(dataGetter, this);
      builder.initAttCamp(dataGetter, battleAttacker, defId, this);
      if (battleAttacker.catapultId > 0) {
        int id = this.campNum.getAndIncrement();
        CampArmy campArmy = Builder.copyArmyFromCach(null, battleAttacker.catapultId, dataGetter, id, this.terrainVal, battleAttacker.attPlayer.getPlayerLv().intValue());
        this.attCamp.add(0, campArmy);
        if (this.attBaseInfo.getNum() + campArmy.armyHp < 0)
          ErrorSceneLog.getInstance().appendErrorMsg("兵力小于0，battle 930行"); 
        this.attBaseInfo.setNum(this.attBaseInfo.getNum() + campArmy.armyHp);
        this.attBaseInfo.setAllNum(this.attBaseInfo.getAllNum() + campArmy.armyHp);
      } 
      if (battleType == 3)
        reSetAllDamageE(dataGetter, this.attBaseInfo.getForceId(), this.defBaseInfo.forceId); 
      setBattleInitBuff(dataGetter, defId);
      setNormalJubenNoExpInitBuff();
      caculateCivilTrickBuff(dataGetter);
      StringBuilder battleMsg = new StringBuilder();
      int sn = this.ticket.incrementAndGet();
      battleMsg.append(sn).append("|").append(this.battleId).append("#");
      List<BattleArmy> attAddQlist = new ArrayList<>();
      Builder.onceAddQueues(attAddQlist, this.attList, this.attCamp, 1, this.attQNum, this.attBaseInfo, this.inBattlePlayers, null, this, dataGetter);
      Builder.getReportType2(battleMsg, attAddQlist, "att");
      List<BattleArmy> defAddQlist = new ArrayList<>();
      Builder.onceAddQueues(defAddQlist, this.defList, this.defCamp, 0, this.defQNum, this.defBaseInfo, this.inBattlePlayers, null, this, dataGetter);
      Builder.getReportType2(battleMsg, defAddQlist, "def");
      Builder.getReportType13(this, battleMsg);
      Builder.getReportType100(dataGetter, this, battleMsg);
      if (this.attList.size() > 0 && this.defList.size() > 0)
        setBattleRoundBuff(dataGetter, ((BattleArmy)this.attList.get(0)).getCampArmy(), ((BattleArmy)this.defList.get(0)).getCampArmy()); 
      if (this.attList.size() > 0)
        Builder.getReportType16(dataGetter, this, battleMsg, ((BattleArmy)this.attList.get(0)).getCampArmy(), "att", true, true); 
      if (this.defList.size() > 0)
        Builder.getReportType16(dataGetter, this, battleMsg, ((BattleArmy)this.defList.get(0)).getCampArmy(), "def", true, true); 
      SaveCurReport(dataGetter);
      this.curBattling.append("#").append(26).append("|").append(12000).append("|");
      Builder.getArrowTowerInfo(dataGetter, this, this.curBattling, defId, battleType);
      Builder.getStrategyInfo(this.curBattling, this, dataGetter);
      battleMsg.append(26).append("|").append(12000).append("|");
      Builder.getArrowTowerInfo(dataGetter, this, battleMsg, defId, battleType);
      Builder.getStrategyInfo(battleMsg, this, dataGetter);
      this.waitting = true;
      Builder.sendMsgToAll(this, battleMsg);
      builder.sendBattleInfo(dataGetter, this, battleAttacker);
      if (battleAttacker.attPlayerId > 0)
        builder.sendTaskMessage(battleAttacker.attPlayerId, defId, dataGetter); 
      dataGetter.getBattleInfoService().saveBattle(this);
      PlayerInfo piAtt = null;
      if (this.attList.size() > 0)
        piAtt = this.inBattlePlayers.get(Integer.valueOf((((BattleArmy)this.attList.get(0)).getCampArmy()).playerId)); 
      boolean attAutoStChoosed = ((piAtt != null && piAtt.autoStrategy == 1) || (this.attList.size() > 0 && (((BattleArmy)this.attList.get(0)).getCampArmy()).isPhantom));
      PlayerInfo piDef = null;
      if (this.defList.size() > 0)
        piDef = this.inBattlePlayers.get(Integer.valueOf((((BattleArmy)this.defList.get(0)).getCampArmy()).playerId)); 
      boolean defAutoStChoosed = ((piDef != null && piDef.autoStrategy == 1) || (this.defList.size() > 0 && (((BattleArmy)this.defList.get(0)).getCampArmy()).isPhantom));
      if (attAutoStChoosed && this.attList.size() > 0 && ((BattleArmy)this.attList.get(0)).getCampArmy().getTacticVal() > 0) {
        this.attChoose = true;
        this.attChooseTactic = true;
      } 
      if (defAutoStChoosed && this.defList.size() > 0 && getSurround() == 0 && ((BattleArmy)this.defList.get(0)).getCampArmy().getTacticVal() > 0) {
        this.defChoose = true;
        this.defChooseTactic = true;
      } 
      if (!attAutoStChoosed && !defAutoStChoosed) {
        this.nextMaxExeTime = System.currentTimeMillis() + 12000L;
      } else {
        this.nextMaxExeTime = System.currentTimeMillis() + 6000L;
      } 
      caculateAgainstInfo(dataGetter);
      long exeTime = System.currentTimeMillis();
      String quickMode = Configuration.getProperty("gcld.battle.quick");
      if (quickMode.equals("1") || this.quickBattle > 0) {
        int interval = Integer.parseInt(Configuration.getProperty("gcld.battle.quick.interval"));
        exeTime += interval;
      } else {
        exeTime = this.nextMaxExeTime;
      } 
      HuizhanHistory hh = dataGetter.getHuiZhanService().getTodayHuizhanBySate(1);
      if (hh != null && defId == hh.getCityId().intValue()) {
        this.nextMaxExeTime = hh.getStartTime().getTime() + 300000L;
        exeTime = this.nextMaxExeTime;
      } 
      changeExeTime(exeTime);
      if (this.defCamp.size() == 0) {
        this.isQuickConquer = true;
        return true;
      } 
      return false;
    } 
  }
  
  public void setBattleRoundBuff(IDataGetter dataGetter, CampArmy attCa, CampArmy defCa) {
    try {
      this.attBuffListRound.clear();
      this.defBuffListRound.clear();
      this.world_round_ally_buff_att_e = 0.0D;
      this.world_round_ally_buff_def_e = 0.0D;
      if (this.attList.size() == 0 || this.defList.size() == 0)
        return; 
      if (attCa.getTerrainAdd() > 0 && defCa.specialGeneral.generalType != 11) {
        Tuple<Integer, String> temp = new Tuple();
        temp.left = Integer.valueOf(23 + attCa.getTerrainQ());
        temp.right = String.valueOf(this.terrainName) + "," + attCa.getTerrainAdd();
        this.attBuffListRound.add(temp);
      } 
      if (defCa.getTerrainAdd() > 0 && attCa.specialGeneral.generalType != 11) {
        Tuple<Integer, String> temp = new Tuple();
        if (defCa.getTerrainQ() == 7) {
          temp.left = Integer.valueOf(29);
          temp.right = MessageFormatter.format(LocalMessages.BUFF_TIPS_29, new Object[] { Integer.valueOf(defCa.getTerrainAdd()) });
        } else {
          temp.left = Integer.valueOf(23 + defCa.getTerrainQ());
          temp.right = String.valueOf(this.terrainName) + "," + defCa.getTerrainAdd();
        } 
        this.defBuffListRound.add(temp);
      } 
      if ((this.battleType == 3 || this.battleType == 13) && this.shaDiLingMap != null) {
        Long attShaDiLingExpireTime = this.shaDiLingMap.get(Integer.valueOf(attCa.getForceId()));
        if (attShaDiLingExpireTime != null && System.currentTimeMillis() <= attShaDiLingExpireTime.longValue()) {
          Tuple<Integer, String> temp2 = new Tuple();
          temp2.left = Integer.valueOf(39);
          temp2.right = LocalMessages.BUFF_TIPS_39;
          this.attBuffListRound.add(temp2);
        } 
        Long defShaDiLingExpireTime = this.shaDiLingMap.get(Integer.valueOf(defCa.getForceId()));
        if (defShaDiLingExpireTime != null && System.currentTimeMillis() <= defShaDiLingExpireTime.longValue()) {
          Tuple<Integer, String> temp3 = new Tuple();
          temp3.left = Integer.valueOf(39);
          temp3.right = LocalMessages.BUFF_TIPS_39;
          this.defBuffListRound.add(temp3);
        } 
      } 
      int attFarmBuff = dataGetter.getWorldFarmService().getBuff(attCa.playerId, attCa.generalId);
      if (attFarmBuff > 0 && !attCa.isPhantom) {
        Tuple<Integer, String> temp2 = new Tuple();
        temp2.left = Integer.valueOf(49);
        temp2.right = LocalMessages.BUFF_TIPS_49;
        this.attBuffListRound.add(temp2);
      } 
      int defFarmBuff = dataGetter.getWorldFarmService().getBuff(defCa.playerId, defCa.generalId);
      if (defFarmBuff > 0 && !defCa.isPhantom) {
        Tuple<Integer, String> temp3 = new Tuple();
        temp3.left = Integer.valueOf(49);
        temp3.right = LocalMessages.BUFF_TIPS_49;
        this.defBuffListRound.add(temp3);
      } 
      Map<Integer, Double> attGemAttrMap = dataGetter.getBattleDataCache().getGemAttribute(attCa.getPlayerId());
      Map<Integer, Double> defGemAttrMap = dataGetter.getBattleDataCache().getGemAttribute(defCa.getPlayerId());
      if (attGemAttrMap != null && !attGemAttrMap.isEmpty()) {
        if (((Double)attGemAttrMap.get(Integer.valueOf(1))).doubleValue() > 0.0D) {
          Tuple<Integer, String> temp4 = new Tuple();
          temp4.left = Integer.valueOf(45);
          temp4.right = LocalMessages.BUFF_TIPS_45;
          this.attBuffListRound.add(temp4);
        } 
        if ((this.battleType == 13 || this.battleType == 15 || this.battleType == 19) && ((Double)attGemAttrMap.get(Integer.valueOf(5))).doubleValue() > 0.0D) {
          Tuple<Integer, String> temp4 = new Tuple();
          temp4.left = Integer.valueOf(46);
          temp4.right = LocalMessages.BUFF_TIPS_46;
          this.attBuffListRound.add(temp4);
        } 
        if (((Double)attGemAttrMap.get(Integer.valueOf(7))).doubleValue() > 0.0D) {
          Tuple<Integer, String> temp4 = new Tuple();
          temp4.left = Integer.valueOf(48);
          temp4.right = LocalMessages.BUFF_TIPS_48;
          this.attBuffListRound.add(temp4);
        } 
      } 
      if (defGemAttrMap != null && !defGemAttrMap.isEmpty()) {
        if (((Double)defGemAttrMap.get(Integer.valueOf(1))).doubleValue() > 0.0D) {
          Tuple<Integer, String> temp4 = new Tuple();
          temp4.left = Integer.valueOf(45);
          temp4.right = LocalMessages.BUFF_TIPS_45;
          this.defBuffListRound.add(temp4);
        } 
        if ((this.battleType == 13 || this.battleType == 15 || this.battleType == 19) && ((Double)defGemAttrMap.get(Integer.valueOf(5))).doubleValue() > 0.0D) {
          Tuple<Integer, String> temp4 = new Tuple();
          temp4.left = Integer.valueOf(46);
          temp4.right = LocalMessages.BUFF_TIPS_46;
          this.defBuffListRound.add(temp4);
        } 
        if (((Double)defGemAttrMap.get(Integer.valueOf(6))).doubleValue() > 0.0D) {
          Tuple<Integer, String> temp4 = new Tuple();
          temp4.left = Integer.valueOf(47);
          temp4.right = LocalMessages.BUFF_TIPS_47;
          this.defBuffListRound.add(temp4);
        } 
      } 
      if (attCa.specialGeneral.generalType == 4) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(30);
        temp4.right = MessageFormatter.format(LocalMessages.BUFF_TIPS_30, new Object[] { Integer.valueOf((int)(attCa.specialGeneral.param * 100.0D)) });
        this.attBuffListRound.add(temp4);
      } 
      if (attCa.specialGeneral.generalType == 2 && (int)attCa.specialGeneral.param > 0) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(31);
        temp4.right = MessageFormatter.format(LocalMessages.BUFF_TIPS_31, new Object[] { Integer.valueOf((int)(attCa.specialGeneral.param * 100.0D)) });
        this.attBuffListRound.add(temp4);
      } 
      if (attCa.specialGeneral.generalType == 3) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(32);
        temp4.right = MessageFormatter.format(LocalMessages.BUFF_TIPS_32, new Object[] { Integer.valueOf((int)(attCa.specialGeneral.param * 100.0D)) });
        this.attBuffListRound.add(temp4);
      } 
      if (attCa.specialGeneral.generalType == 8) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(33);
        temp4.right = LocalMessages.BUFF_TIPS_33;
        this.attBuffListRound.add(temp4);
      } 
      if (attCa.activityAddExp > 0.0F) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(34);
        if (attCa.activityAddExp >= 0.3F) {
          temp4.left = Integer.valueOf(36);
        } else if (attCa.activityAddExp >= 0.2F) {
          temp4.left = Integer.valueOf(35);
        } else if (attCa.activityAddExp >= 0.1F) {
          temp4.left = Integer.valueOf(34);
        } 
        temp4.right = MessageFormatter.format(LocalMessages.BUFF_TIPS_34, new Object[] { Integer.valueOf((int)(attCa.activityAddExp * 100.0F)) });
        this.attBuffListRound.add(temp4);
      } 
      if (attCa.specialGeneral.generalType == 11) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(44);
        temp4.right = LocalMessages.BUFF_TIPS_44;
        this.attBuffListRound.add(temp4);
      } 
      if (defCa.specialGeneral.generalType == 4) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(30);
        temp4.right = MessageFormatter.format(LocalMessages.BUFF_TIPS_30, new Object[] { Integer.valueOf((int)(defCa.specialGeneral.param * 100.0D)) });
        this.defBuffListRound.add(temp4);
      } 
      if (defCa.specialGeneral.generalType == 2 && (int)defCa.specialGeneral.param > 0) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(31);
        temp4.right = MessageFormatter.format(LocalMessages.BUFF_TIPS_31, new Object[] { Integer.valueOf((int)(defCa.specialGeneral.param * 100.0D)) });
        this.defBuffListRound.add(temp4);
      } 
      if (defCa.specialGeneral.generalType == 3) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(32);
        temp4.right = MessageFormatter.format(LocalMessages.BUFF_TIPS_32, new Object[] { Integer.valueOf((int)(defCa.specialGeneral.param * 100.0D)) });
        this.defBuffListRound.add(temp4);
      } 
      if (defCa.specialGeneral.generalType == 8) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(33);
        temp4.right = LocalMessages.BUFF_TIPS_33;
        this.defBuffListRound.add(temp4);
      } 
      if (defCa.activityAddExp > 0.0F) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(34);
        if (defCa.activityAddExp >= 0.3F) {
          temp4.left = Integer.valueOf(36);
        } else if (defCa.activityAddExp >= 0.2F) {
          temp4.left = Integer.valueOf(35);
        } else if (defCa.activityAddExp >= 0.1F) {
          temp4.left = Integer.valueOf(34);
        } 
        temp4.right = MessageFormatter.format(LocalMessages.BUFF_TIPS_34, new Object[] { Integer.valueOf((int)(defCa.activityAddExp * 100.0F)) });
        this.defBuffListRound.add(temp4);
      } 
      if (defCa.specialGeneral.generalType == 11) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(44);
        temp4.right = LocalMessages.BUFF_TIPS_44;
        this.defBuffListRound.add(temp4);
      } 
      if (this.battleType == 3 || this.battleType == 13)
        setRoundAllayBuff(attCa, defCa); 
      if (this.battleType == 18 || this.battleType == 19 || this.battleType == 20)
        setJuBenBattleRoundBuff(); 
      if (attCa.playerId > 0) {
        Date firstpaytime = dataGetter.getPlayerAttributeDao().read(attCa.playerId).getHuiYuanTime();
        Date now = new Date();
        if (firstpaytime != null && now.getTime() < firstpaytime.getTime() + 7200000L) {
          Tuple<Integer, String> temp4 = new Tuple();
          temp4.left = Integer.valueOf(76);
          temp4.right = "100,2";
          this.attBuffListRound.add(temp4);
        } 
      } 
      if (defCa.playerId > 0) {
        Date firstpaytime = dataGetter.getPlayerAttributeDao().read(defCa.playerId).getHuiYuanTime();
        Date now = new Date();
        if (firstpaytime != null && now.getTime() < firstpaytime.getTime() + 7200000L) {
          Tuple<Integer, String> temp4 = new Tuple();
          temp4.left = Integer.valueOf(76);
          temp4.right = "100,2";
          this.defBuffListRound.add(temp4);
        } 
      } 
      if (attCa.buqu > 0) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(37);
        temp4.right = String.valueOf(attCa.buqu * 20);
        this.attBuffListRound.add(temp4);
      } 
      if (defCa.buqu > 0) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(37);
        temp4.right = String.valueOf(defCa.buqu * 20);
        this.defBuffListRound.add(temp4);
      } 
      if (attCa.erzhenbao > 0) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(42);
        temp4.right = "全军战斗力增强";
        this.attBuffListRound.add(temp4);
      } 
      if (defCa.erzhenbao > 0) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(42);
        temp4.right = "全军战斗力增强";
        this.defBuffListRound.add(temp4);
      } 
      if (attCa.bubingdamage + attCa.qibingdamage + attCa.gongbingdamage > 0.0F) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(42);
        temp4.right = "兵种压制，伤害提升" + ((attCa.bubingdamage + attCa.qibingdamage + attCa.gongbingdamage) / 100.0F) + "%";
        this.attBuffListRound.add(temp4);
      } 
      if (defCa.bubingdamage + defCa.qibingdamage + defCa.gongbingdamage > 0.0F) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(42);
        temp4.right = "兵种压制，伤害提升" + ((defCa.bubingdamage + defCa.qibingdamage + defCa.gongbingdamage) / 100.0F) + "%";
        this.defBuffListRound.add(temp4);
      } 
      if (attCa.pingyuandamage + attCa.shandidamage + attCa.shuiyudamage > 0) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(40);
        temp4.right = "地形战法伤害提升" + (attCa.pingyuandamage + attCa.shandidamage + attCa.shuiyudamage);
        this.attBuffListRound.add(temp4);
      } 
      if (defCa.pingyuandamage + defCa.shandidamage + defCa.shuiyudamage > 0) {
        Tuple<Integer, String> temp4 = new Tuple();
        temp4.left = Integer.valueOf(40);
        temp4.right = "平原战法伤害提升" + (defCa.pingyuandamage + defCa.shandidamage + defCa.shuiyudamage);
        this.defBuffListRound.add(temp4);
      } 
    } catch (Exception e) {
      ErrorSceneLog.getInstance().error("Battle.setBattleRoundBuff catch Exception", e);
    } 
  }
  
  private void setRoundAllayBuff(CampArmy attCa, CampArmy defCa) {
    try {
      int attForceId = attCa.forceId;
      int defForceId = defCa.forceId;
      if (attForceId != 1 && attForceId != 2 && attForceId != 3)
        return; 
      if (defForceId != 1 && defForceId != 2 && defForceId != 3)
        return; 
      int thirdForceId = 6 - attForceId - defForceId;
      if (thirdForceId != 1 && thirdForceId != 2 && thirdForceId != 3) {
        ErrorSceneLog.getInstance().appendErrorMsg("thirdForceId error").appendBattleId(this.battleId).append("thirdForceId", Integer.valueOf(thirdForceId)).append("attForceId", Integer.valueOf(attForceId)).append("defForceId", Integer.valueOf(defForceId)).appendMethodName("setBattleRoundBuff").flush();
        return;
      } 
      boolean isAlliedType1 = CityDataCache.isAllied(attForceId, defForceId);
      if (isAlliedType1) {
        this.world_round_ally_buff_att_e = -0.2D;
        Tuple<Integer, String> temp = new Tuple();
        temp.left = Integer.valueOf(21);
        temp.right = LocalMessages.BUFF_TIPS_21;
        this.attBuffListRound.add(temp);
      } 
      boolean isAlliedType2 = CityDataCache.isAllied(attForceId, thirdForceId);
      if (isAlliedType2) {
        this.world_round_ally_buff_att_e = 0.05D;
        Tuple<Integer, String> temp2 = new Tuple();
        temp2.left = Integer.valueOf(22);
        temp2.right = LocalMessages.BUFF_TIPS_22;
        this.attBuffListRound.add(temp2);
      } 
      boolean isAlliedType3 = CityDataCache.isAllied(defForceId, thirdForceId);
      if (isAlliedType3) {
        this.world_round_ally_buff_def_e = 0.05D;
        Tuple<Integer, String> temp3 = new Tuple();
        temp3.left = Integer.valueOf(22);
        temp3.right = LocalMessages.BUFF_TIPS_22;
        this.defBuffListRound.add(temp3);
      } 
    } catch (Exception e) {
      ErrorSceneLog.getInstance().error("Battle.setBattleRoundAllayBuff catch Exception", e);
    } 
  }
  
  private void setJuBenBattleRoundBuffBase() {
    try {
      if (this.attBaseInfo.forceId == 1 || this.attBaseInfo.forceId == 2 || this.attBaseInfo.forceId == 3) {
        JuBenDto juBenDto = JuBenManager.getInstance().getByPid(this.attBaseInfo.id);
        if (juBenDto != null) {
          long now = System.currentTimeMillis();
          if (juBenDto.juben_att_def_base_buff_player_duration_time == 0L || now <= juBenDto.juben_att_def_base_buff_player_duration_time) {
            int buffAttAdd = juBenDto.juben_att_base_buff_player;
            if (buffAttAdd != 0) {
              this.att_gongji_base_add = juBenDto.juben_att_base_buff_player;
              String format = null;
              Tuple<Integer, String> temp = new Tuple();
              if (buffAttAdd > 0) {
                format = LocalMessages.JUBEN_BUFF_Att_ADD_FORMAT;
                temp.left = Integer.valueOf(40);
              } else {
                buffAttAdd = -buffAttAdd;
                format = LocalMessages.JUBEN_BUFF_Att_REDUCE_FORMAT;
                temp.left = Integer.valueOf(40);
              } 
              temp.right = format;
              this.attBuffListRound.add(temp);
            } 
            int buffdefAdd = juBenDto.juben_def_base_buff_player;
            if (buffdefAdd != 0)
              this.att_fangyu_base_add = buffdefAdd; 
          } 
          if (juBenDto.juben_buff_npc_duration_time == 0L || now <= juBenDto.juben_buff_npc_duration_time) {
            int buffAttAdd = juBenDto.juben_att_base_buff_npc;
            if (buffAttAdd != 0) {
              this.def_gongji_base_add = buffAttAdd;
              String format = null;
              Tuple<Integer, String> temp = new Tuple();
              if (buffAttAdd > 0) {
                format = LocalMessages.JUBEN_BUFF_Att_ADD_FORMAT;
                temp.left = Integer.valueOf(40);
              } else {
                buffAttAdd = -buffAttAdd;
                format = LocalMessages.JUBEN_BUFF_Att_REDUCE_FORMAT;
                temp.left = Integer.valueOf(40);
              } 
              temp.right = format;
              this.defBuffListRound.add(temp);
            } 
            int buffdefAdd = juBenDto.juben_def_base_buff_npc;
            if (buffdefAdd != 0)
              this.def_fangyu_base_add = buffdefAdd; 
          } 
        } 
      } else if (this.defBaseInfo.forceId == 1 || this.defBaseInfo.forceId == 2 || this.defBaseInfo.forceId == 3) {
        JuBenDto juBenDto = JuBenManager.getInstance().getByPid(this.defBaseInfo.id);
        if (juBenDto != null) {
          long now = System.currentTimeMillis();
          if (juBenDto.juben_att_def_base_buff_npc_duration_time == 0L || now <= juBenDto.juben_att_def_base_buff_npc_duration_time) {
            int buffAdd = juBenDto.juben_att_base_buff_npc;
            if (buffAdd != 0) {
              this.def_gongji_base_add = buffAdd;
              String format = null;
              Tuple<Integer, String> temp = new Tuple();
              if (buffAdd > 0) {
                format = LocalMessages.JUBEN_BUFF_Att_ADD_FORMAT;
                temp.left = Integer.valueOf(40);
              } else {
                buffAdd = -buffAdd;
                format = LocalMessages.JUBEN_BUFF_Att_REDUCE_FORMAT;
                temp.left = Integer.valueOf(40);
              } 
              temp.right = format;
              this.defBuffListRound.add(temp);
            } 
            buffAdd = juBenDto.juben_def_base_buff_npc;
            if (buffAdd != 0)
              this.def_fangyu_base_add = buffAdd; 
          } 
          if (juBenDto.juben_att_def_base_buff_player_duration_time == 0L || now <= juBenDto.juben_att_def_base_buff_player_duration_time) {
            int buffAdd = juBenDto.juben_att_base_buff_player;
            if (buffAdd != 0) {
              this.att_gongji_base_add = buffAdd;
              String format = null;
              Tuple<Integer, String> temp = new Tuple();
              if (buffAdd > 0) {
                format = LocalMessages.JUBEN_BUFF_Att_ADD_FORMAT;
                temp.left = Integer.valueOf(40);
              } else {
                buffAdd = -buffAdd;
                format = LocalMessages.JUBEN_BUFF_Att_REDUCE_FORMAT;
                temp.left = Integer.valueOf(40);
              } 
              temp.right = format;
              this.attBuffListRound.add(temp);
            } 
            buffAdd = juBenDto.juben_def_base_buff_player;
            if (buffAdd != 0)
              this.att_fangyu_base_add = buffAdd; 
          } 
        } 
      } 
    } catch (Exception e) {
      ErrorSceneLog.getInstance().error("Battle.setJuBenBattleRoundBuffBase catch Exception", e);
    } 
  }
  
  private void setJuBenBattleRoundBuffCoe() {
    try {
      if (this.attBaseInfo.forceId == 1 || this.attBaseInfo.forceId == 2 || this.attBaseInfo.forceId == 3) {
        JuBenDto juBenDto = JuBenManager.getInstance().getByPid(this.attBaseInfo.id);
        if (juBenDto != null) {
          long now = System.currentTimeMillis();
          if (juBenDto.juben_buff_player_duration_time == 0L || now <= juBenDto.juben_buff_player_duration_time) {
            double buffAdd = juBenDto.juben_buff_player - 1.0D;
            if (buffAdd != 0.0D) {
              this.all_damage_e_att += buffAdd;
              String format = null;
              int num = 0;
              Tuple<Integer, String> temp = new Tuple();
              if (buffAdd > 0.0D) {
                format = LocalMessages.JUBEN_BUFF_ADD_FORMAT;
                num = (int)Math.ceil(buffAdd * 100.0D);
                temp.left = Integer.valueOf(37);
              } else {
                format = LocalMessages.JUBEN_BUFF_REDUCE_FORMAT;
                num = (int)Math.ceil(-buffAdd * 100.0D);
                temp.left = Integer.valueOf(38);
              } 
              temp.right = MessageFormatter.format(format, new Object[] { Integer.valueOf(num) });
              this.attBuffListRound.add(temp);
            } 
          } 
          if (juBenDto.juben_buff_npc_duration_time == 0L || now <= juBenDto.juben_buff_npc_duration_time) {
            double buffAdd = juBenDto.juben_buff_npc - 1.0D;
            if (buffAdd != 0.0D) {
              this.all_damage_e_def += buffAdd;
              String format = null;
              int num = 0;
              Tuple<Integer, String> temp = new Tuple();
              if (buffAdd > 0.0D) {
                format = LocalMessages.JUBEN_BUFF_ADD_FORMAT;
                num = (int)Math.ceil(buffAdd * 100.0D);
                temp.left = Integer.valueOf(37);
              } else {
                format = LocalMessages.JUBEN_BUFF_REDUCE_FORMAT;
                num = (int)Math.ceil(-buffAdd * 100.0D);
                temp.left = Integer.valueOf(38);
              } 
              temp.right = MessageFormatter.format(format, new Object[] { Integer.valueOf(num) });
              this.defBuffListRound.add(temp);
            } 
          } 
        } 
      } else if (this.defBaseInfo.forceId == 1 || this.defBaseInfo.forceId == 2 || this.defBaseInfo.forceId == 3) {
        JuBenDto juBenDto = JuBenManager.getInstance().getByPid(this.defBaseInfo.id);
        if (juBenDto != null) {
          long now = System.currentTimeMillis();
          if (juBenDto.juben_buff_player_duration_time == 0L || now <= juBenDto.juben_buff_player_duration_time) {
            double buffAdd = juBenDto.juben_buff_player - 1.0D;
            if (buffAdd != 0.0D) {
              this.all_damage_e_def += buffAdd;
              String format = null;
              int num = 0;
              Tuple<Integer, String> temp = new Tuple();
              if (buffAdd > 0.0D) {
                format = LocalMessages.JUBEN_BUFF_ADD_FORMAT;
                num = (int)Math.ceil(buffAdd * 100.0D);
                temp.left = Integer.valueOf(37);
              } else {
                format = LocalMessages.JUBEN_BUFF_REDUCE_FORMAT;
                num = (int)Math.ceil(-buffAdd * 100.0D);
                temp.left = Integer.valueOf(38);
              } 
              temp.right = MessageFormatter.format(format, new Object[] { Integer.valueOf(num) });
              this.defBuffListRound.add(temp);
            } 
          } 
          if (juBenDto.juben_buff_npc_duration_time == 0L || now <= juBenDto.juben_buff_npc_duration_time) {
            double buffAdd = juBenDto.juben_buff_npc - 1.0D;
            if (buffAdd != 0.0D) {
              this.all_damage_e_att += buffAdd;
              String format = null;
              int num = 0;
              Tuple<Integer, String> temp = new Tuple();
              if (buffAdd > 0.0D) {
                format = LocalMessages.JUBEN_BUFF_ADD_FORMAT;
                num = (int)Math.ceil(buffAdd * 100.0D);
                temp.left = Integer.valueOf(37);
              } else {
                format = LocalMessages.JUBEN_BUFF_REDUCE_FORMAT;
                num = (int)Math.ceil(-buffAdd * 100.0D);
                temp.left = Integer.valueOf(38);
              } 
              temp.right = MessageFormatter.format(format, new Object[] { Integer.valueOf(num) });
              this.attBuffListRound.add(temp);
            } 
          } 
        } 
      } 
    } catch (Exception e) {
      ErrorSceneLog.getInstance().error("Battle.setJuBenBattleRoundBuffCoe catch Exception", e);
    } 
  }
  
  private void setJuBenBattleRoundBuff() {
    setJuBenBattleRoundBuffBase();
    setJuBenBattleRoundBuffCoe();
  }
  
  private void setNormalJubenNoExpInitBuff() {
    try {
      if (this.attBaseInfo.forceId == 1 || this.attBaseInfo.forceId == 2 || this.attBaseInfo.forceId == 3) {
        JuBenDto juBenDto = JuBenManager.getInstance().getByPid(this.attBaseInfo.id);
        if (juBenDto != null && juBenDto.juBen_id <= 10000) {
          Tuple<Integer, String> buff = new Tuple();
          buff.left = Integer.valueOf(14);
          buff.right = LocalMessages.BUFF_TIPS_14;
          this.attBuffListInit.add(buff);
        } 
      } else if (this.defBaseInfo.forceId == 1 || this.defBaseInfo.forceId == 2 || this.defBaseInfo.forceId == 3) {
        JuBenDto juBenDto = JuBenManager.getInstance().getByPid(this.defBaseInfo.id);
        if (juBenDto != null) {
          Tuple<Integer, String> buff = new Tuple();
          buff.left = Integer.valueOf(14);
          buff.right = LocalMessages.BUFF_TIPS_14;
          this.defBuffListInit.add(buff);
        } 
      } 
    } catch (Exception e) {
      ErrorSceneLog.getInstance().error("Battle.setNormalJubenNoExpInitBuff catch Exception", e);
    } 
  }
  
  public void setBattleInitBuff(IDataGetter dataGetter, int defId) {
    this.world_weaken_besiege_e = 0.0D;
    this.world_frontLine_buff_type = 0;
    this.world_frontLine_buff_exp_e = 1.0D;
    this.world_frontLine_buff_att_def_e = 0.0D;
    if (this.battleType == 3 || this.battleType == 13) {
      City city = dataGetter.getCityDao().read(defId);
      int cityTitle = city.getTitle().intValue();
      double coe = 0.0D;
      if (cityTitle == 1 && defId != 255) {
        coe = ((C)dataGetter.getcCache().get("World.DamageWeaken.Besiege1")).getValue().floatValue();
        this.world_weaken_besiege_e = coe;
      } else if (cityTitle == 2 && defId != 255) {
        coe = ((C)dataGetter.getcCache().get("World.DamageWeaken.Besiege2")).getValue().floatValue();
        this.world_weaken_besiege_e = coe;
      } 
      WorldCity worldCity = (WorldCity)dataGetter.getWorldCityCache().get(Integer.valueOf(defId));
      if (city.getForceId().intValue() == 1 || city.getForceId().intValue() == 2 || city.getForceId().intValue() == 3) {
        int attForceId = this.attBaseInfo.forceId;
        int defForceId = this.defBaseInfo.forceId;
        int distanceAtt = worldCity.getDistance(attForceId);
        int distanceDef = worldCity.getDistance(defForceId);
        int distance = (distanceAtt > distanceDef) ? distanceDef : distanceAtt;
        int distanceState = WorldCityCommon.getDistanceState(distance);
        this.world_frontLine_buff_type = distanceState;
        this.world_frontLine_buff_exp_e = WorldCityCommon.getAddExp(distanceState);
        this.world_frontLine_buff_att_def_e = WorldCityCommon.getReduceAttDef(distanceState);
        this.world_frontLine_buff_att_def_e_side = (distanceAtt > distanceDef) ? 1 : 2;
      } 
      if ((this.battleType == 3 || this.battleType == 13) && this.terrainVal == 4 && defId != 255) {
        Tuple<Integer, String> tacticHalfBuff = new Tuple();
        tacticHalfBuff.left = Integer.valueOf(10);
        tacticHalfBuff.right = LocalMessages.BUFF_TIPS_10;
        this.attBuffListInit.add(tacticHalfBuff);
      } 
      if (this.world_frontLine_buff_type != 0) {
        Tuple<Integer, String> frontBuff = new Tuple();
        switch (this.world_frontLine_buff_type) {
          case 1:
            frontBuff.left = Integer.valueOf(9);
            frontBuff.right = "【坚壁清野】战斗不获得经验";
            break;
          case 2:
            frontBuff.left = Integer.valueOf(8);
            frontBuff.right = "行军袭邑，战斗力-10%，经验获得115%";
            break;
          case 3:
            frontBuff.left = Integer.valueOf(7);
            frontBuff.right = LocalMessages.BUFF_TIPS_7;
            break;
        } 
        if (this.world_frontLine_buff_att_def_e_side == 1) {
          this.attBuffListInit.add(frontBuff);
        } else if (this.world_frontLine_buff_att_def_e_side == 2) {
          this.defBuffListInit.add(frontBuff);
        } 
      } 
      Map<Integer, Long> map = dataGetter.getCityService().getShaDiLingInfoInThisCity(defId);
      if (map != null) {
        this.shaDiLingMap = map;
      } else {
        this.shaDiLingMap = new HashMap<>();
      } 
    } 
  }
  
  public byte[] useStrategy(int playerId, int strategyId, IDataGetter dataGetter, int pos) {
    if (System.currentTimeMillis() > this.nextMaxExeTime)
      return JsonBuilder.getJson(State.FAIL, LocalMessages.BATTLE_TIME_OUT_CANNOT_USE_STRATEGY); 
    PlayerInfo pi = this.inBattlePlayers.get(Integer.valueOf(playerId));
    if (pi == null)
      return JsonBuilder.getJson(State.FAIL, LocalMessages.BATTLE_CANNOT_USE_STRATEGY); 
    if (strategyId != 100 && strategyId != 200 && strategyId != 1001 && strategyId != 1002 && strategyId != 1003 && dataGetter
      .getFightStrategiesCache().get(Integer.valueOf(strategyId)) == null)
      return JsonBuilder.getJson(State.FAIL, "参数错误"); 
    synchronized (this.battleId) {
      boolean myChange = false;
      if (this.attList.size() == 0)
        return JsonBuilder.getJson(State.FAIL, LocalMessages.BATTLE_INFO_WORLD_BATENDED); 
      CampArmy myCA = ((BattleArmy)this.attList.get(0)).getCampArmy();
      BattleArmy myBa = this.attList.get(0);
      boolean attSide = true;
      if (myCA.getPlayerId() == playerId) {
        myChange = true;
        attSide = true;
        if (((BattleArmy)this.attList.get(0)).isChoose() || ((BattleArmy)this.attList.get(0)).getPosition() != pos)
          return JsonBuilder.getJson(State.FAIL, LocalMessages.BATTLE_HAD_CHOOSE); 
      } 
      if (!myChange) {
        if (this.defList.size() == 0)
          return JsonBuilder.getJson(State.FAIL, LocalMessages.BATTLE_INFO_WORLD_BATENDED); 
        myCA = ((BattleArmy)this.defList.get(0)).getCampArmy();
        myBa = this.defList.get(0);
        if (myCA.getPlayerId() == playerId) {
          myChange = true;
          attSide = false;
          if (((BattleArmy)this.defList.get(0)).isChoose() || ((BattleArmy)this.defList.get(0)).getPosition() != pos)
            return JsonBuilder.getJson(State.FAIL, LocalMessages.BATTLE_HAD_CHOOSE); 
        } 
      } 
      if (!myChange)
        return JsonBuilder.getJson(State.FAIL, LocalMessages.BATTLE_CANNOT_USE_STRATEGY); 
      if (myBa.getSpecial() == 1)
        return JsonBuilder.getJson(State.FAIL, LocalMessages.BATTLE_CONFUSION_CANNOT_USE_STRATEGY); 
      if (myCA.isPhantom)
        return JsonBuilder.getJson(State.FAIL, LocalMessages.PHANTOM_CANNOT_CHOOSE_ST_TACTIC); 
      boolean canUse = false;
      int[] strategies = myCA.getStrategies();
      for (int i = 0; i < strategies.length; i++) {
        int sId = strategies[i];
        if (sId == strategyId)
          canUse = true; 
      } 
      if (!canUse && strategyId != 100 && strategyId != 200 && strategyId != 1001 && strategyId != 1002 && strategyId != 1003)
        return JsonBuilder.getJson(State.FAIL, "参数错误"); 
      if (strategyId != 100 && strategyId != 200 && strategyId != 1001 && strategyId != 1002 && strategyId != 1003) {
        boolean change = false;
        List<Integer> list = new ArrayList<>();
        for (BattleArmy battleArmy : this.attList) {
          if (battleArmy.getCampArmy().getPlayerId() == playerId && myCA.generalId == battleArmy.getCampArmy().getGeneralId()) {
            change = true;
            battleArmy.setStrategy(strategyId);
            list.add(Integer.valueOf(battleArmy.getPosition()));
          } 
        } 
        if (!change)
          for (BattleArmy battleArmy : this.defList) {
            if (battleArmy.getCampArmy().getPlayerId() == playerId && myCA.generalId == battleArmy.getCampArmy().getGeneralId()) {
              change = true;
              battleArmy.setStrategy(strategyId);
              list.add(Integer.valueOf(battleArmy.getPosition()));
            } 
          }  
        if (change) {
          pi.curStrategy = strategyId;
          if (!list.isEmpty()) {
            if (myChange) {
              if (attSide) {
                this.attChoose = true;
                ((BattleArmy)this.attList.get(0)).setChoose(true);
                if (this.waitting && !this.defChoose && this.battleType == 3) {
                  CampArmy ca = ((BattleArmy)this.defList.get(0)).getCampArmy();
                  if (ca.getPlayerId() > 0 && !ca.isPhantom && Players.getSession(Integer.valueOf(((BattleArmy)this.defList.get(0)).getCampArmy().getPlayerId())) != null)
                    return JsonBuilder.getJson(State.SUCCESS, ""); 
                } 
              } else {
                this.defChoose = true;
                ((BattleArmy)this.defList.get(0)).setChoose(true);
                if (this.waitting && !this.attChooseTactic) {
                  CampArmy ca = ((BattleArmy)this.attList.get(0)).getCampArmy();
                  if (ca.getPlayerId() > 0 && !ca.isPhantom)
                    return JsonBuilder.getJson(State.SUCCESS, ""); 
                } 
              } 
              long time = System.currentTimeMillis(), now = time;
              if (time < this.nextMinExeTime) {
                time = this.nextMinExeTime;
                BattleSceneLog.getInstance().appendLogMsg("choose strategy before this.nextMinExeTime").appendBattleId(this.battleId).append("now", Long.valueOf(now)).append("this.nextMinExeTime", Long.valueOf(this.nextMinExeTime)).append("bias", Long.valueOf(now - this.nextMinExeTime)).flush();
              } 
              StringBuilder battleMsg = new StringBuilder();
              int sn = this.ticket.incrementAndGet();
              battleMsg.append(sn).append("|").append(this.battleId).append("#");
              battleMsg.append(25).append("|").append(playerId).append("|").append(attSide ? 1 : 0).append(";");
              for (Integer position : list)
                battleMsg.append(position).append("|").append(strategyId).append(";"); 
              battleMsg.replace(battleMsg.length() - 1, battleMsg.length(), "#");
              String SingleHeadInfo = " battleId " + this.battleId + " 玩家选择战术，发送给个人:" + (Players.getPlayer(playerId)).playerName + "  battleMsg: ";
              Builder.sendMsgToSingle(this, battleMsg, playerId, SingleHeadInfo, null);
              changeExeTime(time);
            } 
            return JsonBuilder.getJson(State.SUCCESS, "");
          } 
        } 
        return JsonBuilder.getJson(State.FAIL, LocalMessages.BATTLE_CANNOT_USE_STRATEGY);
      } 
      if (myCA.getTacticVal() <= 0 && strategyId == 100)
        return JsonBuilder.getJson(State.FAIL, LocalMessages.BATTLE_CANNOT_USE_TACTIC); 
      if (!attSide && getSurround() > 0)
        return JsonBuilder.getJson(State.FAIL, LocalMessages.BATTLE_CANNOT_USE_TACTIC2); 
      if (myChange) {
        BattleSceneLog.getInstance().appendBattleId(this.battleId).appendLogMsg("choose tactic").appendPlayerName((Players.getPlayer(playerId)).playerName).appendGeneralName(myCA.generalName).append("tactic", ((Tactic)dataGetter.getTacticCache().get(Integer.valueOf(myCA.tacicId))).getName()).flush();
        if (attSide) {
          if (!canUse && strategyId == 200)
            this.attBz = true; 
          if (!canUse && strategyId == 1001)
            myCA.zgTianFz = true; 
          if (!canUse && strategyId == 1002)
            myCA.zgFeiLz = true; 
          if (!canUse && strategyId == 1003)
            myCA.zgDiZz = true; 
          this.attChoose = true;
          this.attChooseTactic = true;
          if (this.waitting && !this.defChoose && this.battleType == 3) {
            CampArmy ca2 = ((BattleArmy)this.defList.get(0)).getCampArmy();
            if (ca2.getPlayerId() > 0 && !ca2.isPhantom)
              return JsonBuilder.getJson(State.SUCCESS, ""); 
          } 
        } else {
          if (!canUse && strategyId == 200)
            this.defBz = true; 
          if (!canUse && strategyId == 1001)
            myCA.zgTianFz = true; 
          if (!canUse && strategyId == 1002)
            myCA.zgFeiLz = true; 
          if (!canUse && strategyId == 1003)
            myCA.zgDiZz = true; 
          this.defChoose = true;
          this.defChooseTactic = true;
          if (this.waitting && !this.attChooseTactic) {
            CampArmy ca2 = ((BattleArmy)this.attList.get(0)).getCampArmy();
            if (ca2.getPlayerId() > 0 && !ca2.isPhantom)
              return JsonBuilder.getJson(State.SUCCESS, ""); 
          } 
        } 
        long time2 = System.currentTimeMillis();
        long now2 = time2;
        if (time2 < this.nextMinExeTime) {
          time2 = this.nextMinExeTime;
          BattleSceneLog.getInstance().appendLogMsg("choose tactic before this.nextMinExeTime").appendBattleId(this.battleId).append("now", Long.valueOf(now2)).append("this.nextMinExeTime", Long.valueOf(this.nextMinExeTime)).append("bias", Long.valueOf(now2 - this.nextMinExeTime)).flush();
        } 
        changeExeTime(time2);
      } 
      return JsonBuilder.getJson(State.SUCCESS, "");
    } 
  }
  
  public void caculateCivilTrickBuff(IDataGetter dataGetter) {
    if (this.battleType == 3 || this.battleType == 13) {
      int cityId = this.defBaseInfo.id;
      int attForceId = this.attBaseInfo.forceId;
      int defForceId = this.defBaseInfo.forceId;
      Tuple<List<Stratagem>, List<Stratagem>> stratagems = null;
      try {
        removeTrickBuff(this.attBuffListInit);
        removeTrickBuff(this.defBuffListInit);
        stratagems = dataGetter.getCilvilTrickService().getStateList(cityId, attForceId, defForceId);
      } catch (Exception e) {
        ErrorSceneLog.getInstance().appendErrorMsg("getStateList catch exception").appendBattleId(this.battleId).append("cityId", Integer.valueOf(cityId)).append("attForceId", Integer.valueOf(attForceId)).append("defForceId", Integer.valueOf(defForceId)).flush();
        return;
      } 
      int lv = 0;
      int param = 0;
      Tuple<Integer, String> buff = new Tuple();
      if (stratagems != null && ((List)stratagems.left).size() > 0)
        for (Stratagem st : stratagems.left) {
          lv = st.getQuality().intValue();
          param = st.getPar1().intValue();
          if (st.getType().equals("guwu")) {
            buff.left = Integer.valueOf(0 + lv);
            buff.right = String.valueOf(String.valueOf(LocalMessages.BUFF_TIPS_GUWU_PART1)) + lv + LocalMessages.BUFF_TIPS_GUWU_PART2 + param + LocalMessages.BUFF_TIPS_GUWU_PART3;
          } else if (st.getType().equals("dongyao")) {
            buff.left = Integer.valueOf(3 + lv);
            buff.right = String.valueOf(String.valueOf(LocalMessages.BUFF_TIPS_DONGYAO_PART1)) + lv + LocalMessages.BUFF_TIPS_DONGYAO_PART2 + param + LocalMessages.BUFF_TIPS_DONGYAO_PART3;
          } 
          this.attBuffListInit.add(buff);
        }  
      if (stratagems != null && ((List)stratagems.right).size() > 0)
        for (Stratagem st : stratagems.right) {
          lv = st.getQuality().intValue();
          param = st.getPar1().intValue();
          if (st.getType().equals("guwu")) {
            buff.left = Integer.valueOf(0 + lv);
            buff.right = String.valueOf(String.valueOf(LocalMessages.BUFF_TIPS_GUWU_PART1)) + lv + LocalMessages.BUFF_TIPS_GUWU_PART2 + param + LocalMessages.BUFF_TIPS_GUWU_PART3;
          } else if (st.getType().equals("dongyao")) {
            buff.left = Integer.valueOf(3 + lv);
            buff.right = String.valueOf(String.valueOf(LocalMessages.BUFF_TIPS_DONGYAO_PART1)) + lv + LocalMessages.BUFF_TIPS_DONGYAO_PART2 + param + LocalMessages.BUFF_TIPS_DONGYAO_PART3;
          } 
          this.defBuffListInit.add(buff);
        }  
    } 
  }
  
  private void removeTrickBuff(List<Tuple<Integer, String>> defBuffList2) {
    List<Tuple<Integer, String>> removeList = new ArrayList<>();
    if (defBuffList2 == null || defBuffList2.isEmpty() || defBuffList2.size() <= 0)
      return; 
    for (Tuple<Integer, String> tuple : defBuffList2) {
      if (tuple == null)
        continue; 
      Integer type = (Integer)tuple.left;
      if ((type.intValue() < 1 || type.intValue() > 3) && (type.intValue() < 4 || type.intValue() > 6))
        continue; 
      removeList.add(tuple);
    } 
    for (Tuple<Integer, String> tuple : removeList) {
      if (tuple == null)
        continue; 
      defBuffList2.remove(tuple);
    } 
  }
  
  public void caculateAgainstInfo(IDataGetter dataGetter) {
    for (Integer side : this.attSideDetail.keySet())
      this.attSideDetail.put(side, Integer.valueOf(0)); 
    for (Integer side : this.defSideDetail.keySet())
      this.defSideDetail.put(side, Integer.valueOf(0)); 
    int forceId = 0;
    Integer num = Integer.valueOf(0);
    for (CampArmy temp : this.attCamp) {
      forceId = temp.forceId;
      num = this.attSideDetail.get(Integer.valueOf(forceId));
      if (num != null) {
        this.attSideDetail.put(Integer.valueOf(forceId), Integer.valueOf(num.intValue() + 1));
        continue;
      } 
      this.attSideDetail.put(Integer.valueOf(forceId), Integer.valueOf(1));
    } 
    for (CampArmy temp : this.defCamp) {
      forceId = temp.forceId;
      num = this.defSideDetail.get(Integer.valueOf(forceId));
      if (num != null) {
        this.defSideDetail.put(Integer.valueOf(forceId), Integer.valueOf(num.intValue() + 1));
        continue;
      } 
      this.defSideDetail.put(Integer.valueOf(forceId), Integer.valueOf(1));
    } 
  }
  
  public BattleResultRound doBattle(IDataGetter dataGetter, long startBatTime) {
    return doBattle2(dataGetter, startBatTime);
  }
  
  private BattleResultRound doBattle2(IDataGetter dataGetter, long startBatTime) {
    long start = System.currentTimeMillis();
    synchronized (this.battleId) {
      BattleResultRound battleResultRound = new BattleResultRound();
      Builder builder = BuilderFactory.getInstance().getBuilder(this.battleType);
      int winSide = builder.isBattleEnd(dataGetter, this);
      if (winSide != 1) {
        if (getRoundNum().get() == 0 || getAttBaseInfo().getAllNum() < 3 || getDefBaseInfo().getAllNum() < 3) {
          ErrorSceneLog.getInstance().appendErrorMsg("empty battle ended at first round").appendBattleId(this.battleId).append("this.roundNum", getRoundNum()).append("attAllNum", Integer.valueOf(getAttBaseInfo().getAllNum())).append("defAllNum", Integer.valueOf(getDefBaseInfo().getAllNum())).flush();
          for (CampArmy kongarmy : getAttCamp())
            ErrorSceneLog.getInstance().appendErrorMsg("player:" + kongarmy.getPlayerId() + ",general:" + kongarmy.getGeneralId() + ",hp:" + kongarmy.getArmyHp() + ",loss:" + kongarmy.getArmyHpLoss() + ",hporg:" + kongarmy.getArmyHpOrg() + ",isphantom:" + kongarmy.isPhantom()).flush(); 
        } 
        this.battleDoing = false;
        builder.endBattle(winSide, dataGetter, this);
        battleResultRound.ended = true;
        return battleResultRound;
      } 
      CampArmy firstAttCA = null;
      if (this.attList.size() > 0)
        firstAttCA = ((BattleArmy)this.attList.get(0)).getCampArmy(); 
      boolean attAutoStChoosed = false;
      if (firstAttCA != null && firstAttCA.playerId > 0 && !firstAttCA.isPhantom) {
        PlayerInfo piAtt = this.inBattlePlayers.get(Integer.valueOf(firstAttCA.playerId));
        attAutoStChoosed = ((piAtt != null && piAtt.autoStrategy == 1) || firstAttCA.isPhantom);
      } 
      CampArmy firstDefCA = null;
      if (this.defList.size() > 0)
        firstDefCA = ((BattleArmy)this.defList.get(0)).getCampArmy(); 
      boolean defAutoStChoosed = false;
      if (firstDefCA != null && firstDefCA.playerId > 0 && !firstDefCA.isPhantom) {
        PlayerInfo piDef = this.inBattlePlayers.get(Integer.valueOf(firstDefCA.playerId));
        defAutoStChoosed = ((piDef != null && piDef.autoStrategy == 1) || firstDefCA.isPhantom);
      } 
      if (((BattleArmy)this.attList.get(0)).getCampArmy().getGeneralId() == 269 && ((BattleArmy)this.attList
        .get(0)).getCampArmy().getChapterId() > 1) {
        double ZG_zgTianFz = 0.5D;
        double ZG_zgFeiLz = 0.3D;
        double ZG_zgDiZz = 0.2D;
        Random random = new Random();
        double randomNum = random.nextDouble();
        if (((BattleArmy)this.attList.get(0)).getCampArmy().getChapterId() > 2) {
          if (randomNum < 0.3D) {
            (((BattleArmy)this.attList.get(0)).getCampArmy()).zgFeiLz = true;
          } else {
            (((BattleArmy)this.attList.get(0)).getCampArmy()).zgTianFz = true;
          } 
        } else if (((BattleArmy)this.attList
          .get(0)).getCampArmy().getChapterId() > 3) {
          if (randomNum < 0.2D) {
            (((BattleArmy)this.attList.get(0)).getCampArmy()).zgDiZz = true;
          } else if (randomNum < 0.5D) {
            (((BattleArmy)this.attList.get(0)).getCampArmy()).zgFeiLz = true;
          } else {
            (((BattleArmy)this.attList.get(0)).getCampArmy()).zgTianFz = true;
          } 
        } else {
          (((BattleArmy)this.attList.get(0)).getCampArmy()).zgTianFz = true;
        } 
        System.out.println("attAutoStChoosed1 ");
      } 
      if (((BattleArmy)this.defList.get(0)).getCampArmy().getGeneralId() == 269 && ((BattleArmy)this.defList
        .get(0)).getCampArmy().getChapterId() > 1) {
        double ZG_zgTianFz = 0.5D;
        double ZG_zgFeiLz = 0.3D;
        double ZG_zgDiZz = 0.2D;
        Random random = new Random();
        double randomNum = random.nextDouble();
        if (((BattleArmy)this.defList.get(0)).getCampArmy().getChapterId() > 2) {
          if (randomNum < 0.3D) {
            (((BattleArmy)this.defList.get(0)).getCampArmy()).zgFeiLz = true;
          } else {
            (((BattleArmy)this.defList.get(0)).getCampArmy()).zgTianFz = true;
          } 
        } else if (((BattleArmy)this.defList
          .get(0)).getCampArmy().getChapterId() > 3) {
          if (randomNum < 0.2D) {
            (((BattleArmy)this.defList.get(0)).getCampArmy()).zgDiZz = true;
          } else if (randomNum < 0.5D) {
            (((BattleArmy)this.defList.get(0)).getCampArmy()).zgFeiLz = true;
          } else {
            (((BattleArmy)this.defList.get(0)).getCampArmy()).zgTianFz = true;
          } 
        } else {
          (((BattleArmy)this.defList.get(0)).getCampArmy()).zgTianFz = true;
        } 
      } 
      if (this.lastRoundWinState == 1 && defAutoStChoosed) {
        if (this.defList.size() > 0) {
          this.defBz = true;
          if (((BattleArmy)this.defList.get(0)).getCampArmy().getTacticVal() > 0 && getSurround() == 0) {
            this.defChoose = true;
            this.defChooseTactic = true;
          } else {
            int attSt = ((BattleArmy)this.attList.get(0)).getStrategy();
            int[] defSts = ((BattleArmy)this.defList.get(0)).getCampArmy().getStrategies();
            FightStragtegyCoe fsc = null;
            if (((BattleArmy)this.defList.get(0)).getSpecial() == 1) {
              fsc = dataGetter.getFightStragtegyCoeCache().getDefLose(attSt, defSts);
            } else {
              fsc = dataGetter.getFightStragtegyCoeCache().getDefWin(attSt, defSts);
            } 
            int defWinSt = (fsc != null) ? fsc.getDefStrategy().intValue() : defSts[0];
            ((BattleArmy)this.defList.get(0)).setStrategy(defWinSt);
          } 
        } 
      } else if (this.lastRoundWinState == 2 && attAutoStChoosed) {
        if (this.attList.size() > 0) {
          this.attBz = true;
          if (((BattleArmy)this.attList.get(0)).getCampArmy().getTacticVal() > 0) {
            this.attChoose = true;
            this.attChooseTactic = true;
          } else {
            int defSt = ((BattleArmy)this.defList.get(0)).getStrategy();
            int[] attSts = ((BattleArmy)this.attList.get(0)).getCampArmy().getStrategies();
            FightStragtegyCoe fsc = null;
            if (((BattleArmy)this.attList.get(0)).getSpecial() == 1) {
              fsc = dataGetter.getFightStragtegyCoeCache().getAttLose(defSt, attSts);
            } else {
              fsc = dataGetter.getFightStragtegyCoeCache().getAttWin(defSt, attSts);
            } 
            int defWinSt = (fsc != null) ? fsc.getAttStrategy().intValue() : attSts[0];
            ((BattleArmy)this.attList.get(0)).setStrategy(defWinSt);
          } 
        } 
      } else if (this.lastRoundWinState == 3 && this.attList.size() > 0 && this.defList.size() > 0) {
        if (attAutoStChoosed) {
          this.defBz = true;
          if (((BattleArmy)this.attList.get(0)).getCampArmy().getTacticVal() > 0) {
            this.attChoose = true;
            this.attChooseTactic = true;
          } else {
            int[] attSts2 = ((BattleArmy)this.attList.get(0)).getCampArmy().getStrategies();
            if (((BattleArmy)this.attList.get(0)).getSpecial() == 1) {
              int defSt2 = ((BattleArmy)this.defList.get(0)).getStrategy();
              FightStragtegyCoe fsc = dataGetter.getFightStragtegyCoeCache().getAttLose(defSt2, attSts2);
              int loseSt = (fsc != null) ? fsc.getAttStrategy().intValue() : attSts2[0];
              ((BattleArmy)this.attList.get(0)).setStrategy(loseSt);
            } else {
              ((BattleArmy)this.attList.get(0)).setStrategy(attSts2[WebUtil.nextInt(attSts2.length)]);
            } 
          } 
        } 
        if (defAutoStChoosed) {
          this.defBz = true;
          if (((BattleArmy)this.defList.get(0)).getCampArmy().getTacticVal() > 0 && getSurround() == 0) {
            this.defChoose = true;
            this.defChooseTactic = true;
          } else {
            int[] defSts2 = ((BattleArmy)this.defList.get(0)).getCampArmy().getStrategies();
            if (((BattleArmy)this.defList.get(0)).getSpecial() == 1) {
              int attSt2 = ((BattleArmy)this.attList.get(0)).getStrategy();
              FightStragtegyCoe fsc = dataGetter.getFightStragtegyCoeCache().getDefLose(attSt2, defSts2);
              int loseSt = (fsc != null) ? fsc.getDefStrategy().intValue() : defSts2[0];
              ((BattleArmy)this.defList.get(0)).setStrategy(loseSt);
            } else {
              ((BattleArmy)this.defList.get(0)).setStrategy(defSts2[WebUtil.nextInt(defSts2.length)]);
            } 
          } 
        } 
      } 
      if (this.attList.size() > 0 && this.defList.size() > 0) {
        if (this.lastRoundWinState == 2 && ((BattleArmy)this.attList.get(0)).getSpecial() == 1) {
          int[] attSts2 = ((BattleArmy)this.attList.get(0)).getCampArmy().getStrategies();
          int defSt2 = ((BattleArmy)this.defList.get(0)).getStrategy();
          FightStragtegyCoe fsc = dataGetter.getFightStragtegyCoeCache().getAttLose(defSt2, attSts2);
          int loseSt = (fsc != null) ? fsc.getAttStrategy().intValue() : attSts2[0];
          ((BattleArmy)this.attList.get(0)).setStrategy(loseSt);
        } 
        if (this.lastRoundWinState == 1 && ((BattleArmy)this.defList.get(0)).getSpecial() == 1) {
          int[] defSts2 = ((BattleArmy)this.defList.get(0)).getCampArmy().getStrategies();
          int attSt2 = ((BattleArmy)this.attList.get(0)).getStrategy();
          FightStragtegyCoe fsc = dataGetter.getFightStragtegyCoeCache().getDefLose(attSt2, defSts2);
          int loseSt = (fsc != null) ? fsc.getDefStrategy().intValue() : defSts2[0];
          ((BattleArmy)this.defList.get(0)).setStrategy(loseSt);
        } 
      } 
      if (this.attList.size() > 0) {
        if (((BattleArmy)this.attList.get(0)).getCampArmy().getHuoYi() > 0)
          ((BattleArmy)this.attList.get(0)).setStrategy(1000130); 
        if (((BattleArmy)this.attList.get(0)).getCampArmy().getTuiShou() > 0)
          ((BattleArmy)this.attList.get(0)).setStrategy(2000120); 
      } 
      if (this.defList.size() > 0) {
        if (((BattleArmy)this.defList.get(0)).getCampArmy().getHuoYi() > 0)
          ((BattleArmy)this.defList.get(0)).setStrategy(1000130); 
        if (((BattleArmy)this.defList.get(0)).getCampArmy().getTuiShou() > 0)
          ((BattleArmy)this.defList.get(0)).setStrategy(2000120); 
      } 
      if (this.attList.size() > 0 && ((BattleArmy)this.attList.get(0)).getCampArmy().getTacticVal() > 0 && (((BattleArmy)this.attList.get(0)).getCampArmy()).isPhantom) {
        this.attChoose = true;
        this.attChooseTactic = true;
      } 
      if (this.defList.size() > 0 && ((BattleArmy)this.defList.get(0)).getCampArmy().getTacticVal() > 0 && (((BattleArmy)this.defList.get(0)).getCampArmy()).isPhantom) {
        this.defChoose = true;
        this.defChooseTactic = true;
      } 
      caculateCivilTrickBuff(dataGetter);
      if (this.attList.size() > 0 && this.defList.size() > 0)
        setBattleRoundBuff(dataGetter, ((BattleArmy)this.attList.get(0)).getCampArmy(), ((BattleArmy)this.defList.get(0)).getCampArmy()); 
      builder.checkErrorAndHandle(dataGetter, this);
      this.waitting = false;
      RoundInfo roundInfo = new RoundInfo();
      doBattleRound(dataGetter, builder, roundInfo);
      if (this.shuaiqi_inuse && this.shuaiqi_round > 0) {
        this.shuaiqi_round--;
      } else if (this.shuaiqi_inuse && this.shuaiqi_round <= 0) {
        setQuickBattle(0);
        setShuaiQiInUse(false);
      } 
      winSide = builder.isBattleEnd(dataGetter, this);
      if (winSide != 1) {
        this.battleDoing = false;
        builder.endBattle(winSide, dataGetter, this);
        battleResultRound.ended = true;
        return battleResultRound;
      } 
      this.nextMinExeTime = System.currentTimeMillis() + roundInfo.nextMinExeTime;
      this.nextMaxExeTime = System.currentTimeMillis() + roundInfo.nextMaxExeTime;
      long time = System.currentTimeMillis();
      String quickMode = Configuration.getProperty("gcld.battle.quick");
      if (quickMode.equals("1") || this.quickBattle > 0) {
        int interval = Integer.parseInt(Configuration.getProperty("gcld.battle.quick.interval"));
        time += interval;
      } else {
        time = this.nextMaxExeTime;
      } 
      changeExeTime(time);
      return battleResultRound;
    } 
  }
  
  private void huanyingdantiao(IDataGetter dataGetter, RoundInfo roundInfo, Builder builder) {
    if (this.battleType != 3)
      return; 
    int chushi = 20;
    int cityId = this.defBaseInfo.getId();
    if (cityId == 255)
      chushi = 5; 
    if (this.attCamp.size() <= chushi || this.defCamp.size() <= chushi)
      return; 
    if (this.attCamp.size() <= chushi || this.defCamp.size() <= chushi)
      return; 
    int dtnum = 5;
    String shuliang = Configuration.getProperty("gcld.huanying.dantiao.num");
    if (StringUtils.isNotBlank(shuliang))
      dtnum = Integer.valueOf(shuliang).intValue(); 
    int beishu = 1;
    if (this.attCamp.size() >= 3000 || this.defCamp.size() >= 3000) {
      beishu = 5;
    } else if (this.attCamp.size() >= 2000 || this.defCamp.size() >= 2000) {
      beishu = 4;
    } else if (this.attCamp.size() >= 1000 || this.defCamp.size() >= 1000) {
      beishu = 3;
    } else if (this.attCamp.size() >= 500 || this.defCamp.size() >= 500) {
      beishu = 2;
    } 
    List<CampArmy> attset = new ArrayList<>();
    List<CampArmy> defset = new ArrayList<>();
    int attnum = 0;
    int defnum = 0;
    int i;
    for (i = this.attCamp.size() - 1; i >= chushi; i--) {
      if (attnum >= dtnum * beishu)
        break; 
      if (i > this.attCamp.size() - 1)
        break; 
      if (i <= chushi)
        break; 
      CampArmy attackCamp = this.attCamp.get(i);
      if (attackCamp.isPhantom && !attackCamp.isOnQueues()) {
        attset.add(attackCamp);
        attnum++;
      } 
    } 
    for (i = this.defCamp.size() - 1; i >= chushi; i--) {
      if (defnum >= dtnum * beishu)
        break; 
      if (i > this.defCamp.size() - 1)
        break; 
      if (i <= chushi)
        break; 
      CampArmy defenceCamp = this.defCamp.get(i);
      if (defenceCamp.isPhantom && !defenceCamp.isOnQueues()) {
        defset.add(defenceCamp);
        defnum++;
      } 
    } 
    if (attset.size() < 1 || defset.size() < 1)
      return; 
    boolean bobao = false;
    int attneedtongzhihbq = 0;
    int attneedtongzhixzy = 0;
    int attneedtongzhiwsq = 0;
    int defneedtongzhihbq = 0;
    int defneedtongzhixzy = 0;
    int defneedtongzhiwsq = 0;
    while (attset.size() > 0) {
      if (defset.size() < 1)
        break; 
      CampArmy[] cas = new CampArmy[2];
      cas[0] = attset.remove(0);
      cas[1] = defset.remove(0);
      if (cas[0].isOnQueues() || cas[1].isOnQueues())
        continue; 
      roundInfo.needPushReport13 = true;
      this.attCamp.remove(cas[0]);
      this.defCamp.remove(cas[1]);
      if (this.attBaseInfo.getNum() < (cas[0]).armyHp)
        ErrorSceneLog.getInstance().appendErrorMsg("兵力小于0，battle 2251行"); 
      this.attBaseInfo.setAllNum(this.attBaseInfo.getAllNum() - (cas[0]).armyHp);
      this.attBaseInfo.setNum(this.attBaseInfo.getNum() - (cas[0]).armyHp);
      if (this.defBaseInfo.getNum() < (cas[1]).armyHp)
        ErrorSceneLog.getInstance().appendErrorMsg("兵力小于0，battle 2257行"); 
      this.defBaseInfo.setAllNum(this.defBaseInfo.getAllNum() - (cas[1]).armyHp);
      this.defBaseInfo.setNum(this.defBaseInfo.getNum() - (cas[1]).armyHp);
      dataGetter.getBattleService().createOneToOneBattle(-1, cas, this, 3, 0, true);
      if (!bobao) {
        String wenzi = String.valueOf((cas[0]).playerName) + "的" + (cas[0]).generalName + "对" + (cas[1]).playerName + "的" + (cas[1]).generalName + "发起了单挑";
        for (Integer playerId : this.inSceneSet) {
          Session session = Players.getSession(Integer.valueOf(playerId.intValue()));
          if (session != null) {
            byte[] bytes = JsonBuilder.getJson(JsonBuilder.getJson(State.PUSH, "notice", wenzi));
            session.write(WrapperUtil.wrapper(PushCommand.PUSH_BATTLE_INNER.getCommand(), 0, bytes));
          } 
        } 
        bobao = true;
      } 
    } 
    if (attneedtongzhihbq > 0 || defneedtongzhihbq > 0) {
      Map<Integer, Integer> atthbqkillinfos = getAttHbqKillInfos();
      Map<Integer, Integer> defhbqkillinfos = getDefHbqKillInfos();
      JsonDocument doc = new JsonDocument();
      doc.startObject();
      if (atthbqkillinfos != null && atthbqkillinfos.size() > 0) {
        Iterator<Integer> iterator = atthbqkillinfos.keySet().iterator();
        if (iterator.hasNext()) {
          Integer hplayid = iterator.next();
          Player playeratt = dataGetter.getPlayerDao().read(hplayid.intValue());
          doc.startObject("att");
          doc.createElement("kills", atthbqkillinfos.get(hplayid));
          doc.createElement("playerName", (playeratt == null) ? "我方" : playeratt.getPlayerName());
          doc.endObject();
        } 
      } 
      if (defhbqkillinfos != null && defhbqkillinfos.size() > 0) {
        Iterator<Integer> iterator = defhbqkillinfos.keySet().iterator();
        if (iterator.hasNext()) {
          Integer hplayid = iterator.next();
          Player playeratt = dataGetter.getPlayerDao().read(hplayid.intValue());
          doc.startObject("def");
          doc.createElement("kills", defhbqkillinfos.get(hplayid));
          doc.createElement("playerName", (playeratt == null) ? "我方" : playeratt.getPlayerName());
          doc.endObject();
        } 
      } 
      doc.endObject();
      for (Integer playerId : this.inSceneSet)
        Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_HBQ, doc.toByte()); 
    } 
    if (attneedtongzhixzy > 0 || defneedtongzhixzy > 0) {
      Map<Integer, Integer> attxianzhenkillinfos = getAttXianZhenKillInfos();
      Map<Integer, Integer> defxianzhenkillinfos = getDefXianZhenKillInfos();
      JsonDocument doc = new JsonDocument();
      doc.startObject("fission");
      if (attxianzhenkillinfos != null && attxianzhenkillinfos.size() > 0) {
        Iterator<Integer> iterator = attxianzhenkillinfos.keySet().iterator();
        if (iterator.hasNext()) {
          Integer hplayid = iterator.next();
          Player playeratt = dataGetter.getPlayerDao().read(hplayid.intValue());
          doc.startObject("att");
          doc.createElement("dants", attxianzhenkillinfos.get(hplayid));
          doc.createElement("playerName", (playeratt == null) ? "我方" : playeratt.getPlayerName());
          doc.endObject();
        } 
      } 
      if (defxianzhenkillinfos != null && defxianzhenkillinfos.size() > 0) {
        Iterator<Integer> iterator = defxianzhenkillinfos.keySet().iterator();
        if (iterator.hasNext()) {
          Integer hplayid = iterator.next();
          Player playeratt = dataGetter.getPlayerDao().read(hplayid.intValue());
          doc.startObject("def");
          doc.createElement("dants", defxianzhenkillinfos.get(hplayid));
          doc.createElement("playerName", (playeratt == null) ? "我方" : playeratt.getPlayerName());
          doc.endObject();
        } 
      } 
      doc.endObject();
      for (Integer playerId : this.inSceneSet)
        Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_XIANZHEN, doc.toByte()); 
    } 
    if (attneedtongzhiwsq > 0 || defneedtongzhiwsq > 0) {
      Map<Integer, Integer> attwsqkillinfos = getAttWsqKillInfos();
      Map<Integer, Integer> defwsqkillinfos = getDefWsqKillInfos();
      JsonDocument doc = new JsonDocument();
      doc.startObject();
      if (attwsqkillinfos != null && attwsqkillinfos.size() > 0) {
        Iterator<Integer> iterator = attwsqkillinfos.keySet().iterator();
        if (iterator.hasNext()) {
          Integer hplayid = iterator.next();
          Player playeratt = dataGetter.getPlayerDao().read(hplayid.intValue());
          doc.startObject("att");
          doc.createElement("kills", attwsqkillinfos.get(hplayid));
          doc.createElement("playerName", (playeratt == null) ? "我方" : playeratt.getPlayerName());
          doc.endObject();
        } 
      } 
      if (defwsqkillinfos != null && defwsqkillinfos.size() > 0) {
        Iterator<Integer> iterator = defwsqkillinfos.keySet().iterator();
        if (iterator.hasNext()) {
          Integer hplayid = iterator.next();
          Player playeratt = dataGetter.getPlayerDao().read(hplayid.intValue());
          doc.startObject("def");
          doc.createElement("kills", defwsqkillinfos.get(hplayid));
          doc.createElement("playerName", (playeratt == null) ? "我方" : playeratt.getPlayerName());
          doc.endObject();
        } 
      } 
      doc.endObject();
      for (Integer playerId : this.inSceneSet)
        Players.push(playerId.intValue(), PushCommand.PUSH_BATTLE_WSQ, doc.toByte()); 
    } 
  }
  
  private void doBattleRound(IDataGetter dataGetter, Builder builder, RoundInfo roundInfo) {
    getRoundNum().incrementAndGet();
    if (this.battleMonsterAtt != null) {
      BattleArmy tempbatArmy = new BattleArmy();
      tempbatArmy.setCampArmy(this.battleMonsterAtt);
      for (int j = 0; j < 3; j++)
        tempbatArmy.getTroopHp()[j] = this.battleMonsterAtt.getArmyHp() / 3; 
      this.battleMonsterAtt.setArmyHp(0);
      int curstrategy = this.battleMonsterAtt.getStrategies()[WebUtil.nextInt((this.battleMonsterAtt.getStrategies()).length)];
      tempbatArmy.setStrategy(curstrategy);
      tempbatArmy.setBloodOrg(this.battleMonsterAtt.getArmyHpOrg());
      this.attCamp.add(0, this.battleMonsterAtt);
      tempbatArmy.setPosition(this.attQNum.getAndIncrement());
      this.attList.add(0, tempbatArmy);
      getAttBaseInfo().setNum(getAttBaseInfo().getNum() + this.battleMonsterAtt.getArmyHp());
      getAttBaseInfo().setAllNum(getAttBaseInfo().getAllNum() + this.battleMonsterAtt.getArmyHp());
      Builder.getReportType66(roundInfo.battleMsg, this.attList, "att");
      this.battleMonsterAtt = null;
    } 
    if (this.battleMonsterDef != null) {
      BattleArmy tempbatArmy = new BattleArmy();
      tempbatArmy.setCampArmy(this.battleMonsterDef);
      for (int j = 0; j < 3; j++)
        tempbatArmy.getTroopHp()[j] = this.battleMonsterDef.getArmyHp() / 3; 
      this.battleMonsterDef.setArmyHp(0);
      int curstrategy = this.battleMonsterDef.getStrategies()[WebUtil.nextInt((this.battleMonsterDef.getStrategies()).length)];
      tempbatArmy.setStrategy(curstrategy);
      tempbatArmy.setBloodOrg(this.battleMonsterDef.getArmyHpOrg());
      this.defCamp.add(0, this.battleMonsterDef);
      tempbatArmy.setPosition(this.defQNum.getAndIncrement());
      this.defList.add(0, tempbatArmy);
      getDefBaseInfo().setNum(getDefBaseInfo().getNum() + this.battleMonsterDef.getArmyHp());
      getDefBaseInfo().setAllNum(getDefBaseInfo().getAllNum() + this.battleMonsterDef.getArmyHp());
      Builder.getReportType66(roundInfo.battleMsg, this.defList, "def");
      this.battleMonsterDef = null;
    } 
    CampArmy attCa = ((BattleArmy)this.attList.get(0)).getCampArmy();
    CampArmy defCa = ((BattleArmy)this.defList.get(0)).getCampArmy();
    if ((this.battleType == 3 || this.battleType == 13) && attCa.forceId == defCa.forceId)
      try {
        ErrorSceneLog.getInstance().appendErrorMsg("general from the same force fight each other").appendBattleId(this.battleId).append("this.roundNum", getRoundNum()).append("this.defBaseInfo.forceId", Integer.valueOf(this.defBaseInfo.forceId)).append("this.attBaseInfo.forceId", Integer.valueOf(this.attBaseInfo.forceId)).append("attCa.forceId", Integer.valueOf(attCa.forceId)).append("attCa.pgmVId", Integer.valueOf(attCa.pgmVId)).append("attCa.playerName", attCa.playerName).append("attCa.playerId", Integer.valueOf(attCa.playerId)).append("attCa.generalName", attCa.generalName).append("attCa.generalId", Integer.valueOf(attCa.generalId)).append("attCa.armyHpOrg", Integer.valueOf(attCa.armyHpOrg)).append("attCa.armyHp", Integer.valueOf(attCa.armyHp)).append("defCa.forceId", Integer.valueOf(defCa.forceId)).append("defCa.pgmVId", Integer.valueOf(defCa.pgmVId)).append("defCa.playerName", defCa.playerName).append("defCa.playerId", Integer.valueOf(defCa.playerId)).append("defCa.generalName", defCa.generalName).append("defCa.generalId", Integer.valueOf(defCa.generalId)).append("defCa.armyHpOrg", Integer.valueOf(defCa.armyHpOrg)).append("defCa.armyHp", Integer.valueOf(defCa.armyHp)).flush();
      } catch (Exception e) {
        ErrorSceneLog.getInstance().error("attCa.forceId == defCa.forceId catch exception.", e);
      }  
    ((BattleArmy)this.attList.get(0)).setChoose(true);
    ((BattleArmy)this.defList.get(0)).setChoose(true);
    ((BattleArmy)this.attList.get(0)).setRoundNum(getRoundNum().get());
    ((BattleArmy)this.defList.get(0)).setRoundNum(getRoundNum().get());
    if (this.quickBattle > 0)
      roundInfo.battleMsg.append("45|").append(this.quicktype).append("#"); 
    Builder.getCurCampInfo(dataGetter, this, roundInfo);
    boolean arrowattack = false;
    boolean xuyaoFight = false;
    boolean exeFight = false;
    if (this.battleType == 3)
      arrowattack = builder.checkArrowAttack(dataGetter, this, roundInfo); 
    if (!arrowattack) {
      xuyaoFight = builder.BeiDongJiNeng(dataGetter, this, roundInfo);
      if (roundInfo.attCampArmy.getNeedReduceDiKang() && roundInfo.attCampArmy.getDiKang() > 0) {
        roundInfo.attCampArmy.setDiKang(roundInfo.attCampArmy.getDiKang() - 1);
        roundInfo.attCampArmy.setNeedReduceDiKang(false);
      } 
      if (roundInfo.defCampArmy.getNeedReduceDiKang() && roundInfo.defCampArmy.getDiKang() > 0) {
        roundInfo.defCampArmy.setDiKang(roundInfo.defCampArmy.getDiKang() - 1);
        roundInfo.defCampArmy.setNeedReduceDiKang(false);
      } 
      if (roundInfo.attCampArmy.armyHpLoss >= roundInfo.attCampArmy.armyHpOrg)
        roundInfo.killAttG = true; 
      if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg)
        roundInfo.killDefG = true; 
    } 
    if (!xuyaoFight && !arrowattack) {
      exeFight = builder.dealTacticStrategy(dataGetter, this, roundInfo);
      Builder.getReportType69(roundInfo.battleMsg, roundInfo);
    } 
    if (roundInfo.zfjxNum > 0) {
      JsonDocument doc = new JsonDocument();
      doc.startObject();
      doc.createElement("zfjxForceId", Integer.valueOf(roundInfo.zfjxForceId));
      doc.createElement("zfjxNum", Integer.valueOf(roundInfo.zfjxNum));
      doc.endObject();
      for (Integer playerId : this.inSceneSet)
        Players.push(playerId.intValue(), PushCommand.PUSH_UPDATE, doc.toByte()); 
      roundInfo.zfjxNum = 0;
    } 
    boolean needdwnum = false;
    if (exeFight) {
      Builder.getCurBattleTroop(dataGetter, this, roundInfo);
      Builder.fight(roundInfo, this.terrainVal);
      builder.dealFight(dataGetter, this, roundInfo);
      if (roundInfo.attCampArmy.getGeneralId() == 208 && roundInfo.attCampArmy.getIsJuexing() > 0 && roundInfo.attCampArmy.getDwNum() > -3) {
        roundInfo.attCampArmy.setDwNum(roundInfo.attCampArmy.getDwNum() + 1);
        needdwnum = true;
      } 
      if (roundInfo.defCampArmy.getGeneralId() == 208 && roundInfo.defCampArmy.getIsJuexing() > 0 && roundInfo.defCampArmy.getDwNum() > -3) {
        roundInfo.defCampArmy.setDwNum(roundInfo.defCampArmy.getDwNum() + 1);
        needdwnum = true;
      } 
    } 
    for (BattleArmy ba : roundInfo.attKilledList) {
      if (ba.getCampArmy().getGeneralId() == 266 && ba.getCampArmy().getIsJuexing() > 0 && roundInfo.killAttG && (ba.getCampArmy()).armyHpLoss >= (ba.getCampArmy()).armyHpOrg && roundInfo.attBattleArmy == ba && ba.getCampArmy().getFuBingType() <= 0) {
        roundInfo.defCampArmy.setChiTuBenXi((ba.getCampArmy()).killGeneral + 1);
        break;
      } 
      if (ba.getCampArmy().getGeneralId() != 201 || ba.getCampArmy().getUnionState() <= 0)
        if (ba.getCampArmy().getGeneralId() == 201 && roundInfo.defCampArmy.generalId != 266 && roundInfo.killAttG && (ba.getCampArmy()).killGeneral > 0 && (ba.getCampArmy()).armyHpLoss >= (ba.getCampArmy()).armyHpOrg && roundInfo.attBattleArmy == ba && ba.getCampArmy().getFuBingType() <= 0) {
          roundInfo.defCampArmy.setChiTuBenXi((ba.getCampArmy()).killGeneral + 1);
          break;
        }  
    } 
    for (BattleArmy ba : roundInfo.defKilledList) {
      if (ba.getCampArmy().getGeneralId() == 266 && ba.getCampArmy().getIsJuexing() > 0 && roundInfo.killDefG && (ba.getCampArmy()).armyHpLoss >= (ba.getCampArmy()).armyHpOrg && roundInfo.defBattleArmy == ba && ba.getCampArmy().getFuBingType() <= 0) {
        roundInfo.attCampArmy.setChiTuBenXi((ba.getCampArmy()).killGeneral + 1);
        break;
      } 
      if (ba.getCampArmy().getGeneralId() != 201 || ba.getCampArmy().getUnionState() <= 0)
        if (ba.getCampArmy().getGeneralId() == 201 && roundInfo.attCampArmy.generalId != 266 && roundInfo.killDefG && (ba.getCampArmy()).killGeneral > 0 && (ba.getCampArmy()).armyHpLoss >= (ba.getCampArmy()).armyHpOrg && roundInfo.defBattleArmy == ba && ba.getCampArmy().getFuBingType() <= 0) {
          roundInfo.attCampArmy.setChiTuBenXi((ba.getCampArmy()).killGeneral + 1);
          break;
        }  
    } 
    if (roundInfo.attCampArmy.getHaveZscy()) {
      roundInfo.attCampArmy.setZscy(roundInfo.attCampArmy.getZscy() - 1);
      roundInfo.attCampArmy.setZscyChiXuNum(roundInfo.attCampArmy.getZscyChiXuNum() + 1);
    } 
    if (roundInfo.defCampArmy.getHaveZscy()) {
      roundInfo.defCampArmy.setZscy(roundInfo.defCampArmy.getZscy() - 1);
      roundInfo.defCampArmy.setZscyChiXuNum(roundInfo.defCampArmy.getZscyChiXuNum() + 1);
    } 
    if (this.attBz) {
      System.out.println("==========>触发变阵 " + this.attBz);
      roundInfo.attCampArmy.setBzStatuCode(true);
    } 
    if (this.defBz)
      roundInfo.defCampArmy.setBzStatuCode(true); 
    if (roundInfo.attCampArmy.getHaveZscy()) {
      int attzsnum = roundInfo.attCampArmy.getZscy();
      int attdis = 0;
      if (attzsnum <= 0 || roundInfo.killAttG || roundInfo.attCampArmy.getZscyChiXuNum() >= 15) {
        attdis = -1;
        roundInfo.attCampArmy.setHaveZscy(false);
        roundInfo.attCampArmy.setZscy(0);
        if (roundInfo.attCampArmy.getZscyChiXuNum() >= 15)
          roundInfo.attCampArmy.setNeedChongZhen(true); 
        roundInfo.attCampArmy.setZscyChiXuNum(0);
        setAttNeedZscy(true);
      } 
      roundInfo.battleMsg.append("65|11,").append(attdis).append(",").append(attzsnum).append(";");
      if (roundInfo.defCampArmy.getHaveZscy()) {
        int defzsnum = roundInfo.defCampArmy.getZscy();
        int defdis = 0;
        if (defzsnum <= 0 || roundInfo.killDefG || roundInfo.defCampArmy.getZscyChiXuNum() >= 15) {
          defdis = -1;
          roundInfo.defCampArmy.setHaveZscy(false);
          roundInfo.defCampArmy.setZscy(0);
          if (roundInfo.defCampArmy.getZscyChiXuNum() >= 15)
            roundInfo.defCampArmy.setNeedChongZhen(true); 
          roundInfo.defCampArmy.setZscyChiXuNum(0);
          setDefNeedZscy(true);
        } 
        roundInfo.battleMsg.append("11,").append(defdis).append(",").append(defzsnum).append("#");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.getHaveZscy()) {
      int defzsnum = roundInfo.defCampArmy.getZscy();
      int defdis = 0;
      if (defzsnum <= 0 || roundInfo.killDefG || roundInfo.defCampArmy.getZscyChiXuNum() >= 15) {
        defdis = -1;
        roundInfo.defCampArmy.setHaveZscy(false);
        roundInfo.defCampArmy.setZscy(0);
        if (roundInfo.defCampArmy.getZscyChiXuNum() >= 15)
          roundInfo.defCampArmy.setNeedChongZhen(true); 
        roundInfo.defCampArmy.setZscyChiXuNum(0);
        setDefNeedZscy(true);
      } 
      roundInfo.battleMsg.append("65|null;11,").append(defdis).append(",").append(defzsnum).append("#");
    } 
    if (!arrowattack)
      builder.AfterRound(dataGetter, this, roundInfo); 
    if (!this.shuaiqi_inuse && this.quickBattle <= 0)
      huanyingdantiao(dataGetter, roundInfo, builder); 
    if (roundInfo.attCampArmy.armyHpLoss >= roundInfo.attCampArmy.armyHpOrg)
      roundInfo.killAttG = true; 
    if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg)
      roundInfo.killDefG = true; 
    if (roundInfo.killAttG && ((roundInfo.attCampArmy.generalId == 281 && roundInfo.attCampArmy.isjuexing <= 0) || roundInfo.attCampArmy.getBuff().equals("baqi")))
      roundInfo.battleMsg.append(69).append("|").append("att").append("|null").append("#"); 
    if (roundInfo.killDefG && ((roundInfo.defCampArmy.generalId == 281 && roundInfo.defCampArmy.isjuexing <= 0) || roundInfo.defCampArmy.getBuff().equals("baqi")))
      roundInfo.battleMsg.append(69).append("|").append("def").append("|null").append("#"); 
    if (roundInfo.attCampArmy.getGeneralId() == 107 && roundInfo.attCampArmy.getIsJuexing() > 0 && roundInfo.killDefG)
      roundInfo.attCampArmy.setLuanShi(0); 
    if (roundInfo.attCampArmy.getGeneralId() == 107 && roundInfo.attCampArmy.getIsJuexing() > 0 && roundInfo.killDefG)
      roundInfo.attCampArmy.setLuanShi(0); 
    if (roundInfo.defCampArmy.getGeneralId() == 107 && roundInfo.defCampArmy.getIsJuexing() > 0 && roundInfo.killAttG)
      roundInfo.defCampArmy.setLuanShi(0); 
    if (roundInfo.attCampArmy.getGeneralId() == 107 && roundInfo.attCampArmy.getIsJuexing() > 0 && roundInfo.killAttG && roundInfo.defCampArmy.getZbAllTimes() > 1 && (roundInfo.attCampArmy.getIsDeputy() > 0 || roundInfo.attCampArmy.getFuBingType() > 0))
      roundInfo.defCampArmy.setZbAllTimes(5); 
    if (roundInfo.defCampArmy.getGeneralId() == 107 && roundInfo.defCampArmy.getIsJuexing() > 0 && roundInfo.killDefG && roundInfo.attCampArmy.getZbAllTimes() > 1 && (roundInfo.defCampArmy.getIsDeputy() > 0 || roundInfo.defCampArmy.getFuBingType() > 0))
      roundInfo.attCampArmy.setZbAllTimes(5); 
    if (roundInfo.attCampArmy.generalId == 205 && roundInfo.attCampArmy.isjuexing > 0)
      roundInfo.attCampArmy.machaotimes += 2; 
    if (roundInfo.defCampArmy.generalId == 205 && roundInfo.defCampArmy.isjuexing > 0)
      roundInfo.defCampArmy.machaotimes += 2; 
    if (roundInfo.attCampArmy.generalId == 270 && roundInfo.attCampArmy.unionrank >= 2) {
      roundInfo.attCampArmy.machaotimes += 2;
      if (roundInfo.attCampArmy.machaotimes >= 10) {
        roundInfo.attCampArmy.setTacticVal(roundInfo.attCampArmy.getTacticVal() + 1);
        roundInfo.attCampArmy.machaotimes = 0;
      } 
    } 
    if (roundInfo.defCampArmy.generalId == 270 && roundInfo.defCampArmy.unionrank >= 2) {
      roundInfo.defCampArmy.machaotimes += 2;
      if (roundInfo.defCampArmy.machaotimes >= 10) {
        roundInfo.defCampArmy.setTacticVal(roundInfo.defCampArmy.getTacticVal() + 1);
        roundInfo.defCampArmy.machaotimes = 0;
      } 
    } 
    if (roundInfo.attCampArmy.generalId == 280 && roundInfo.attCampArmy.isjuexing > 0) {
      roundInfo.attCampArmy.czshinum++;
      roundInfo.attCampArmy.czshiround = roundInfo.attCampArmy.czshinum / 18;
      if (roundInfo.attCampArmy.czshinum % 3 == 0) {
        roundInfo.attCampArmy.immunoNum++;
      } else {
        roundInfo.attCampArmy.missNum++;
      } 
      if (roundInfo.attBattleArmy.getCampArmy().getGeneralId() == 280 && roundInfo.attBattleArmy.getTroopHp()[0] <= 0)
        roundInfo.attCampArmy.immunoNum = 0; 
    } 
    if (roundInfo.defCampArmy.generalId == 280 && roundInfo.defCampArmy.isjuexing > 0) {
      roundInfo.defCampArmy.czshinum++;
      roundInfo.defCampArmy.czshiround = roundInfo.defCampArmy.czshinum / 18;
      if (roundInfo.defCampArmy.czshinum % 3 == 0) {
        roundInfo.defCampArmy.immunoNum++;
      } else {
        roundInfo.defCampArmy.missNum++;
      } 
      if (roundInfo.defBattleArmy.getCampArmy().getGeneralId() == 280 && roundInfo.defBattleArmy.getTroopHp()[0] <= 0)
        roundInfo.defCampArmy.immunoNum = 0; 
    } 
    if (roundInfo.attBattleArmy.getHaveZhanChe() && roundInfo.attBattleArmy.getCampArmy().getDuoChongShaRen() > 0 && roundInfo.attBattleArmy.getHuJia() > 0) {
      int oldhujia = roundInfo.attorignhujia;
      int xinhujia = roundInfo.attBattleArmy.getHuJia();
      if (xinhujia < oldhujia)
        roundInfo.attBattleArmy.getCampArmy().setNeedShaRen(1); 
    } 
    if (roundInfo.defBattleArmy.getHaveZhanChe() && roundInfo.defBattleArmy.getCampArmy().getDuoChongShaRen() > 0 && roundInfo.defBattleArmy.getHuJia() > 0) {
      int oldhujia = roundInfo.deforignhujia;
      int xinhujia = roundInfo.defBattleArmy.getHuJia();
      if (xinhujia < oldhujia)
        roundInfo.defBattleArmy.getCampArmy().setNeedShaRen(1); 
    } 
    if (!roundInfo.attKilledList.isEmpty() && roundInfo.defCampArmy.getGeneralId() == 270 && roundInfo.defCampArmy.getUnionRank() >= 2)
      roundInfo.defCampArmy.setQlrh(true); 
    if (!roundInfo.defKilledList.isEmpty() && roundInfo.attCampArmy.getGeneralId() == 270 && roundInfo.attCampArmy.getUnionRank() >= 2)
      roundInfo.attCampArmy.setQlrh(true); 
    if (roundInfo.attBattleArmy.getHuWei() >= 3) {
      if (roundInfo.defCampArmy.getGeneralId() == 282)
        roundInfo.defCampArmy.tacticVal++; 
      roundInfo.attBattleArmy.setHuWei(0);
    } 
    if (roundInfo.defBattleArmy.getHuWei() >= 3) {
      if (roundInfo.attCampArmy.getGeneralId() == 282)
        roundInfo.attCampArmy.tacticVal++; 
      roundInfo.defBattleArmy.setHuWei(0);
    } 
    if (roundInfo.killAttG && roundInfo.attCampArmy.getFormationType() == 4) {
      roundInfo.battleMsg.append("94|att|0|");
      for (int j = 0; j < this.attList.size(); j++) {
        BattleArmy attarmy = this.attList.get(j);
        if (attarmy.getBaGuaAttack() > 0)
          attarmy.setBaGuaAttack(0); 
        if (attarmy.getBaGuaBaoji() > 0)
          attarmy.setBaGuaBaoji(0); 
        if (attarmy.getBaGuaFangYu() > 0)
          attarmy.setBaGuaFangYu(0); 
        roundInfo.battleMsg.append(attarmy.getPosition()).append(",0,0,0,0,").append(attarmy.getBaGuaDun()).append("*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|1#");
    } 
    if (roundInfo.killDefG && roundInfo.defCampArmy.getFormationType() == 4) {
      roundInfo.battleMsg.append("94|def|0|");
      for (int j = 0; j < this.defList.size(); j++) {
        BattleArmy defarmy = this.defList.get(j);
        if (defarmy.getBaGuaAttack() > 0)
          defarmy.setBaGuaAttack(0); 
        if (defarmy.getBaGuaBaoji() > 0)
          defarmy.setBaGuaBaoji(0); 
        if (defarmy.getBaGuaFangYu() > 0)
          defarmy.setBaGuaFangYu(0); 
        roundInfo.battleMsg.append(defarmy.getPosition()).append(",0,0,0,0,").append(defarmy.getBaGuaDun()).append("*");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      roundInfo.battleMsg.append("31|2#");
    } 
    if (roundInfo.attCampArmy.getsjznLevel() > 0) {
      int arrowlimit = 1;
      int powermax = 300000;
      if (roundInfo.attCampArmy.getsjznLevel() >= 10) {
        arrowlimit = 3;
        powermax = 999999999;
      } else if (roundInfo.attCampArmy.getsjznLevel() >= 9) {
        arrowlimit = 3;
        powermax = 900000;
      } else if (roundInfo.attCampArmy.getsjznLevel() >= 5) {
        arrowlimit = 2;
        powermax = 600000;
      } 
      int arrowtype = roundInfo.attCampArmy.getsjznType();
      if (roundInfo.killAttG) {
        roundInfo.attCampArmy.setsjznType(0);
        arrowtype = 0;
      } 
      if (roundInfo.attCampArmy.getsjznType() == arrowlimit + 1)
        arrowtype = 0; 
      int killdiren = roundInfo.attCampArmy.getsjznPower();
      if (roundInfo.defLost > 0)
        killdiren += roundInfo.defLost / 5; 
      roundInfo.attCampArmy.setsjznPower(killdiren);
      if (roundInfo.attCampArmy.getsjznType() <= arrowlimit + 1) {
        if (roundInfo.attCampArmy.getsjznType() == arrowlimit + 1)
          roundInfo.attCampArmy.setsjznType(roundInfo.attCampArmy.getsjznType() + 1); 
        roundInfo.battleMsg.append("65|13,").append(arrowtype).append(",").append(roundInfo.attCampArmy.getsjznPower()).append(",").append(powermax).append(";null#");
      } 
    } 
    if (roundInfo.defCampArmy.getsjznLevel() > 0) {
      int arrowlimit = 1;
      int powermax = 300000;
      if (roundInfo.defCampArmy.getsjznLevel() >= 10) {
        arrowlimit = 3;
        powermax = 999999999;
      } else if (roundInfo.defCampArmy.getsjznLevel() >= 9) {
        arrowlimit = 3;
        powermax = 900000;
      } else if (roundInfo.defCampArmy.getsjznLevel() >= 5) {
        arrowlimit = 2;
        powermax = 600000;
      } 
      int arrowtype = roundInfo.defCampArmy.getsjznType();
      if (roundInfo.killDefG) {
        roundInfo.defCampArmy.setsjznType(0);
        arrowtype = 0;
      } 
      if (roundInfo.defCampArmy.getsjznType() == arrowlimit + 1)
        arrowtype = 0; 
      int killdiren = roundInfo.defCampArmy.getsjznPower();
      if (roundInfo.attLost > 0)
        killdiren += roundInfo.attLost / 5; 
      roundInfo.defCampArmy.setsjznPower(killdiren);
      if (roundInfo.defCampArmy.getsjznType() <= arrowlimit + 1) {
        if (roundInfo.defCampArmy.getsjznType() == arrowlimit + 1)
          roundInfo.defCampArmy.setsjznType(roundInfo.defCampArmy.getsjznType() + 1); 
        roundInfo.battleMsg.append("65|null;13,").append(roundInfo.defCampArmy.getsjznType()).append(",").append(roundInfo.defCampArmy.getsjznPower()).append(",").append(powermax).append("#");
      } 
    } 
    if (roundInfo.defCampArmy.getGeneralId() == 107 && roundInfo.defCampArmy.getLegendEvoke())
      roundInfo.battleMsg.append(65).append("|").append("null;27,").append(roundInfo.defCampArmy.xuanjian).append(",").append(0).append("#"); 
    if (roundInfo.defCampArmy.qiangyi > 0 && roundInfo.defCampArmy.generalId == 204 && roundInfo.defCampArmy.chapterId >= 4) {
      roundInfo.battleMsg.append(65).append("|").append("null;33,").append(roundInfo.defCampArmy.qiangyi).append(",").append(0).append("#");
      if (roundInfo.killDefG)
        roundInfo.defCampArmy.qiangyi = -1; 
    } 
    if (roundInfo.attCampArmy.qiangyi > 0 && roundInfo.attCampArmy.generalId == 204 && roundInfo.attCampArmy.chapterId >= 4) {
      roundInfo.battleMsg.append("65|33,").append(roundInfo.attCampArmy.qiangyi).append(",0;null#");
      if (roundInfo.killAttG)
        roundInfo.attCampArmy.qiangyi = -1; 
    } 
    if (roundInfo.attCampArmy.getGeneralId() == 269 && roundInfo.attCampArmy.getLegendEvoke() && roundInfo.attCampArmy.getChapterId() >= 1) {
      if (roundInfo.killAttG)
        roundInfo.attCampArmy.maifu = -1; 
      roundInfo.battleMsg.append("65|29,").append(roundInfo.attCampArmy.getMaifu()).append(",").append(roundInfo.attCampArmy.getMaifu()).append(";").append("null#");
    } 
    if (roundInfo.defCampArmy.getGeneralId() == 269 && roundInfo.defCampArmy.getLegendEvoke() && roundInfo.defCampArmy.getChapterId() >= 1) {
      if (roundInfo.killDefG)
        roundInfo.defCampArmy.maifu = -1; 
      roundInfo.battleMsg.append("65|null;").append(29).append(",").append(roundInfo.defCampArmy.getMaifu()).append(",0").append("#");
    } 
    if (roundInfo.attCampArmy.getGeneralId() == 281 && roundInfo.attCampArmy.isjuexing > 0) {
      if (roundInfo.attCampArmy.getBaQiNum() >= 0 && roundInfo.attLost > 0 && !roundInfo.attCampArmy.huxiao) {
        int xinbaqi = roundInfo.attCampArmy.getBaQiNum() + 10;
        if (xinbaqi > 20)
          xinbaqi = 20; 
        roundInfo.attCampArmy.setBaQiNum(xinbaqi);
      } 
      if (roundInfo.killAttG)
        roundInfo.attCampArmy.setBaQiNum(-1); 
      roundInfo.battleMsg.append("65|15,").append(roundInfo.attCampArmy.getBaQiNum()).append(",").append(roundInfo.attBattleArmy.getpose()).append(",").append(roundInfo.attBattleArmy.getPosition()).append(";null#");
    } 
    if (roundInfo.defCampArmy.getGeneralId() == 281 && roundInfo.defCampArmy.isjuexing > 0) {
      if (roundInfo.defCampArmy.getBaQiNum() >= 0 && roundInfo.defLost > 0 && !roundInfo.defCampArmy.huxiao) {
        int xinbaqi = roundInfo.defCampArmy.getBaQiNum() + 10;
        if (xinbaqi > 20)
          xinbaqi = 20; 
        roundInfo.defCampArmy.setBaQiNum(xinbaqi);
      } 
      if (roundInfo.killDefG)
        roundInfo.defCampArmy.setBaQiNum(-1); 
      roundInfo.battleMsg.append("65|null;15,").append(roundInfo.defCampArmy.getBaQiNum()).append(",").append(roundInfo.defBattleArmy.getpose()).append(",").append(roundInfo.defBattleArmy.getPosition()).append("#");
    } 
    if (roundInfo.killAttG && roundInfo.attCampArmy.getGeneralId() == 208 && roundInfo.attCampArmy.getIsJuexing() >= 0) {
      needdwnum = true;
      int count = 0;
      roundInfo.battleMsg.append("102|def|dianwei3|");
      for (int s1 = 0; s1 < this.defList.size(); s1++) {
        if (count >= 4)
          break; 
        BattleArmy fsbat = this.defList.get(s1);
        if (RandomUtils.nextInt(100) < 50 || s1 == 0) {
          fsbat.setSpecial(1);
          count++;
        } 
        roundInfo.battleMsg.append(fsbat.getPosition()).append(",");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
    } 
    if (roundInfo.killDefG && roundInfo.defCampArmy.getGeneralId() == 208 && roundInfo.defCampArmy.getIsJuexing() >= 0) {
      needdwnum = true;
      int count = 0;
      roundInfo.battleMsg.append("102|att|dianwei3|");
      for (int s1 = 0; s1 < this.attList.size(); s1++) {
        if (count >= 4)
          break; 
        BattleArmy fsbat = this.attList.get(s1);
        if (RandomUtils.nextInt(100) < 50 || s1 == 0) {
          fsbat.setSpecial(1);
          count++;
        } 
        roundInfo.battleMsg.append(fsbat.getPosition()).append(",");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
    } 
    if (needdwnum)
      roundInfo.battleMsg.append("65|16,").append(roundInfo.attCampArmy.getDwNum()).append(",0,0;16,").append(roundInfo.defCampArmy.getDwNum()).append(",0,0#"); 
    if ((getBattleType() == 3 || getBattleType() == 13) && roundInfo.killAttG && roundInfo.defCampArmy.getYongYouBeast() && roundInfo.defCampArmy.getPlayerId() > 0) {
      List<PlayerWarBeast> allbeastlist = dataGetter.getPlayerWarBeastDao().getWarBeastListByplayerId(roundInfo.defCampArmy.getPlayerId());
      PlayerWarBeastResource playerwarres = dataGetter.getPlayerWarBeastResourceDao().getWarBeastResourceByplayerId(roundInfo.defCampArmy.getPlayerId());
      if (allbeastlist != null && playerwarres != null && playerwarres.getShangZhen().intValue() < 1000) {
        int curshangzhen = playerwarres.getShangZhen().intValue() + 20;
        if (curshangzhen > 1000)
          curshangzhen = 1000; 
        dataGetter.getPlayerWarBeastResourceDao().updateShangZhen(roundInfo.defCampArmy.getPlayerId(), curshangzhen);
        JsonDocument docwb = new JsonDocument();
        docwb.startObject();
        docwb.startObject("warbeastBar");
        docwb.createElement("curEnergy", Integer.valueOf(curshangzhen));
        docwb.createElement("maxEnergy", Integer.valueOf(1000));
        docwb.createElement("battleId", getBattleId());
        docwb.startArray("warbeastList");
        for (int j = 0; j < 5; j++) {
          docwb.startObject();
          docwb.createElement("pos", Integer.valueOf(j));
          docwb.createElement("needEnergy", Integer.valueOf(1000));
          boolean yongyou = false;
          for (PlayerWarBeast warbest : allbeastlist) {
            if (warbest.getBeastId().intValue() - 1 != j)
              continue; 
            docwb.createElement("pic", WarBeastUtil.beastpic[warbest.getBeastId().intValue() - 1]);
            String state = "";
            if (warbest.getState().intValue() <= 0) {
              state = "AVAILABLE";
              if (warbest.getCoolTime() != null && warbest.getCoolTime().getTime() > System.currentTimeMillis())
                state = "CD"; 
            } else {
              state = "BATTLEING";
            } 
            docwb.createElement("state", state);
            docwb.createElement("cd", Long.valueOf((warbest.getCoolTime() == null) ? 0L : (warbest.getCoolTime().getTime() - System.currentTimeMillis())));
            yongyou = true;
          } 
          if (!yongyou) {
            docwb.createElement("pic", "baihu");
            docwb.createElement("state", "");
            docwb.createElement("cd", Integer.valueOf(0));
          } 
          docwb.endObject();
        } 
        docwb.endArray();
        docwb.endObject();
        docwb.endObject();
        Players.push(roundInfo.defCampArmy.getPlayerId(), PushCommand.PUSH_WARBEAST, docwb.toByte());
      } 
    } 
    if ((getBattleType() == 3 || getBattleType() == 13) && roundInfo.killDefG && roundInfo.attCampArmy.getYongYouBeast() && roundInfo.attCampArmy.getPlayerId() > 0) {
      List<PlayerWarBeast> allbeastlist = dataGetter.getPlayerWarBeastDao().getWarBeastListByplayerId(roundInfo.attCampArmy.getPlayerId());
      PlayerWarBeastResource playerwarres = dataGetter.getPlayerWarBeastResourceDao().getWarBeastResourceByplayerId(roundInfo.attCampArmy.getPlayerId());
      if (allbeastlist != null && playerwarres != null && playerwarres.getShangZhen().intValue() < 1000) {
        int curshangzhen = playerwarres.getShangZhen().intValue() + 20;
        if (curshangzhen > 1000)
          curshangzhen = 1000; 
        dataGetter.getPlayerWarBeastResourceDao().updateShangZhen(roundInfo.attCampArmy.getPlayerId(), curshangzhen);
        JsonDocument docwb = new JsonDocument();
        docwb.startObject();
        docwb.startObject("warbeastBar");
        docwb.createElement("curEnergy", Integer.valueOf(curshangzhen));
        docwb.createElement("maxEnergy", Integer.valueOf(1000));
        docwb.createElement("battleId", getBattleId());
        docwb.startArray("warbeastList");
        for (int j = 0; j < 5; j++) {
          docwb.startObject();
          docwb.createElement("pos", Integer.valueOf(j));
          docwb.createElement("needEnergy", Integer.valueOf(1000));
          boolean yongyou = false;
          for (PlayerWarBeast warbest : allbeastlist) {
            if (warbest.getBeastId().intValue() - 1 != j)
              continue; 
            docwb.createElement("pic", WarBeastUtil.beastpic[warbest.getBeastId().intValue() - 1]);
            String state = "";
            if (warbest.getState().intValue() <= 0) {
              state = "AVAILABLE";
              if (warbest.getCoolTime() != null && warbest.getCoolTime().getTime() > System.currentTimeMillis())
                state = "CD"; 
            } else {
              state = "BATTLEING";
            } 
            docwb.createElement("state", state);
            docwb.createElement("cd", Long.valueOf((warbest.getCoolTime() == null) ? 0L : (warbest.getCoolTime().getTime() - System.currentTimeMillis())));
            yongyou = true;
          } 
          if (!yongyou) {
            docwb.createElement("pic", "baihu");
            docwb.createElement("state", "");
            docwb.createElement("cd", Integer.valueOf(0));
          } 
          docwb.endObject();
        } 
        docwb.endArray();
        docwb.endObject();
        docwb.endObject();
        Players.push(roundInfo.attCampArmy.getPlayerId(), PushCommand.PUSH_WARBEAST, docwb.toByte());
      } 
    } 
    if (roundInfo.attCampArmy.getGeneralId() == 402 && roundInfo.attCampArmy.getSunShangXiangZs() < 9)
      roundInfo.attCampArmy.setSunShangXiangZs(roundInfo.attCampArmy.getSunShangXiangZs() + 1); 
    if (roundInfo.defCampArmy.getGeneralId() == 402 && roundInfo.defCampArmy.getSunShangXiangZs() < 9)
      roundInfo.defCampArmy.setSunShangXiangZs(roundInfo.defCampArmy.getSunShangXiangZs() + 1); 
    if (roundInfo.attCampArmy.getGeneralId() == 232 && roundInfo.attCampArmy.getUnionState() > 0 && this.defList.size() > 0) {
      roundInfo.battleMsg.append("118|def|");
      for (int j = 0; j < this.defList.size(); j++) {
        BattleArmy battlearmy = this.defList.get(j);
        roundInfo.battleMsg.append(battlearmy.getPosition()).append("*").append(battlearmy.getZyNum()).append(",");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
    } 
    if (roundInfo.defCampArmy.getGeneralId() == 232 && roundInfo.defCampArmy.getUnionState() > 0 && this.attList.size() > 0) {
      roundInfo.battleMsg.append("118|att|");
      for (int j = 0; j < this.attList.size(); j++) {
        BattleArmy battlearmy = this.attList.get(j);
        roundInfo.battleMsg.append(battlearmy.getPosition()).append("*").append(battlearmy.getZyNum()).append(",");
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
    } 
    if (roundInfo.attCampArmy.getGeneralId() == 107 && roundInfo.attCampArmy.getLegendEvoke()) {
      if (this.battleType == 13 && !roundInfo.attCampArmy.isPhantom() && 
        roundInfo.defCampArmy.getArmyHpLoss() >= roundInfo.defCampArmy.armyHpOrg) {
        System.out.println("======>defCamp.armyHpOrg  " + roundInfo.defCampArmy.armyHpOrg);
        System.out.println("======>defCamp.armyHpLoss  " + roundInfo.defCampArmy.getArmyHpLoss());
        roundInfo.attCampArmy.ccQzw++;
      } 
      roundInfo.battleMsg.append(65).append("|").append("27,").append(roundInfo.attCampArmy.xuanjian)
        .append(0).append(";null#");
    } 
    builder.roundRemoveCamp(this, roundInfo);
    boolean attzykilled = false;
    boolean defzykilled = false;
    boolean attnzzzkilled = false;
    boolean defnzzzkilled = false;
    int i;
    for (i = this.attList.size() - 1; i >= 0; i--) {
      BattleArmy qBa = this.attList.get(i);
      if (roundInfo.attBattleArmy.getIsDajiang() == 1)
        System.out.println("是否大将排 " + roundInfo.attBattleArmy.getIsDajiang()); 
      for (BattleArmy ba : roundInfo.attKilledList) {
        if (qBa.getPosition() == ba.getPosition()) {
          this.attList.remove(i);
          if (ba.getZyNum() > 0)
            defzykilled = true; 
          if (ba.getCampArmy().getGeneralId() == 232)
            attnzzzkilled = true; 
          if (roundInfo.defCampArmy.getGeneralId() == 107 && roundInfo.defCampArmy.legendEvoke) {
            roundInfo.defCampArmy.xuanjian = 1;
            roundInfo.defCampArmy.setChaunqiccxu(true);
            roundInfo.attCampArmy.setChaunqiccxu(true);
          } 
          if (roundInfo.defCampArmy.getGeneralId() == 281 && roundInfo.defCampArmy.legendEvoke)
            roundInfo.defCampArmy.setIsScjs(true); 
          if (roundInfo.defCampArmy.getGeneralId() == 204 && roundInfo.defCampArmy.legendEvoke && roundInfo.defCampArmy.getChapterId() >= 4)
            if (roundInfo.defCampArmy.qiangyi < 25)
              roundInfo.defCampArmy.qiangyi++;  
          if (ba.getCampArmy().getLegendEvoke() && ba.getCampArmy().getLegendSkill() != null && ba.getCampArmy().getLegendSkill().containsKey("bainiao") && ((Integer)ba.getCampArmy().getLegendSkill().get("bainiao")).intValue() > 0) {
            if (ba.getCampArmy().getGeneralId() != 281)
              (ba.getCampArmy()).tacticVal++; 
            (ba.getCampArmy()).chaunqiccrowsw++;
          } 
          if (ba.getCampArmy().getLegendEvoke() && ba.getCampArmy().getLegendSkill() != null && ba.getCampArmy().getLegendSkill().containsKey("gudan") && ((Integer)ba.getCampArmy().getLegendSkill().get("gudan")).intValue() > 0)
            (ba.getCampArmy()).juejingzhilong++; 
          break;
        } 
      } 
    } 
    if (defzykilled && roundInfo.defCampArmy.getGeneralId() == 232 && roundInfo.defCampArmy.getUnionRank() >= 2)
      roundInfo.defCampArmy.tacticVal++; 
    if (attnzzzkilled && roundInfo.attCampArmy.getGeneralId() == 232 && roundInfo.attCampArmy.getUnionRank() >= 1)
      roundInfo.attCampArmy.setXinBingShangZhen(1); 
    if (roundInfo.attCampArmy.chapterId > 6 && roundInfo.attCampArmy.qiangyi <= 25 && roundInfo.attCampArmy.getGeneralId() == 204)
      roundInfo.attCampArmy.setDefEffect((int)(roundInfo.attCampArmy.qiangyiDef + roundInfo.attCampArmy.qiangyiDef * 0.01D * roundInfo.attCampArmy.qiangyi)); 
    if (roundInfo.defCampArmy.chapterId > 6 && roundInfo.defCampArmy.qiangyi <= 25 && roundInfo.defCampArmy.getGeneralId() == 204)
      roundInfo.defCampArmy.setDefEffect((int)(roundInfo.defCampArmy.qiangyiDef + roundInfo.defCampArmy.qiangyiDef * 0.01D * roundInfo.attCampArmy.qiangyi)); 
    for (i = this.defList.size() - 1; i >= 0; i--) {
      BattleArmy qBa = this.defList.get(i);
      if (roundInfo.attBattleArmy.getIsDajiang() == 1)
        System.out.println("是否大将排 " + roundInfo.attBattleArmy.getIsDajiang()); 
      for (BattleArmy ba : roundInfo.defKilledList) {
        if (qBa.getPosition() == ba.getPosition()) {
          this.defList.remove(i);
          if (ba.getZyNum() > 0)
            attzykilled = true; 
          if (ba.getCampArmy().getGeneralId() == 232)
            defnzzzkilled = true; 
          if (roundInfo.attCampArmy.getGeneralId() == 107 && roundInfo.attCampArmy.legendEvoke) {
            roundInfo.attCampArmy.xuanjian = 1;
            roundInfo.attCampArmy.setChaunqiccxu(true);
          } 
          if (roundInfo.attCampArmy.getGeneralId() == 281 && roundInfo.attCampArmy.legendEvoke)
            roundInfo.attCampArmy.setIsScjs(true); 
          if (roundInfo.attCampArmy.getGeneralId() == 204 && roundInfo.attCampArmy.legendEvoke && roundInfo.attCampArmy.getChapterId() >= 4)
            if (roundInfo.attCampArmy.qiangyi < 25)
              roundInfo.attCampArmy.qiangyi++;  
          if (ba.getCampArmy().getLegendEvoke() && ba.getCampArmy().getLegendSkill() != null && ba.getCampArmy().getLegendSkill().containsKey("bainiao") && ((Integer)ba.getCampArmy().getLegendSkill().get("bainiao")).intValue() > 0 && 
            ba.getCampArmy().getGeneralId() != 281)
            (ba.getCampArmy()).tacticVal++; 
          if (ba.getCampArmy().getLegendEvoke() && ba.getCampArmy().getLegendSkill() != null && ba.getCampArmy().getLegendSkill().containsKey("gudan") && ((Integer)ba.getCampArmy().getLegendSkill().get("gudan")).intValue() > 0)
            (ba.getCampArmy()).juejingzhilong++; 
          break;
        } 
      } 
    } 
    if (attzykilled && roundInfo.attCampArmy.getGeneralId() == 232 && roundInfo.attCampArmy.getUnionRank() >= 2)
      roundInfo.attCampArmy.tacticVal++; 
    if (defnzzzkilled && roundInfo.defCampArmy.getGeneralId() == 232 && roundInfo.defCampArmy.getUnionRank() >= 1)
      roundInfo.defCampArmy.setXinBingShangZhen(1); 
    if (roundInfo.attKilledList.size() > 0 && roundInfo.defCampArmy.getUnionState() > 0 && roundInfo.defCampArmy.getGeneralId() == 103) {
      if (roundInfo.defCampArmy.getUnionRank() >= 3 && roundInfo.defCampArmy.getJFLH() <= 0)
        roundInfo.defCampArmy.setJFLH(1); 
      if (roundInfo.defCampArmy.getUnionRank() >= 2 && roundInfo.defCampArmy.getJFLH() != 1)
        roundInfo.defCampArmy.setDongFeng(1); 
    } 
    if (roundInfo.defKilledList.size() > 0 && roundInfo.attCampArmy.getUnionState() > 0 && roundInfo.attCampArmy.getGeneralId() == 103) {
      if (roundInfo.attCampArmy.getUnionRank() >= 3 && roundInfo.attCampArmy.getJFLH() <= 0)
        roundInfo.attCampArmy.setJFLH(1); 
      if (roundInfo.attCampArmy.getUnionRank() >= 2 && roundInfo.attCampArmy.getJFLH() != 1)
        roundInfo.attCampArmy.setDongFeng(1); 
    } 
    if (roundInfo.smystr != null && roundInfo.smystr.length() > 0) {
      roundInfo.battleMsg.append(roundInfo.smystr.toString());
      roundInfo.smystr = null;
    } 
    if (roundInfo.caocaostr != null && roundInfo.caocaostr.length() > 0) {
      roundInfo.battleMsg.append(roundInfo.caocaostr.toString());
      roundInfo.caocaostr = null;
    } 
    if (roundInfo.attCampArmy.getGeneralId() == 107 && roundInfo.attCampArmy.getIsJuexing() > 0 && roundInfo.killAttG)
      roundInfo.battleMsg.append("65|5,-1,0,4;null#"); 
    if (roundInfo.defCampArmy.getGeneralId() == 107 && roundInfo.defCampArmy.getIsJuexing() > 0 && roundInfo.killDefG)
      roundInfo.battleMsg.append("65|null;5,-1,0,4#"); 
    for (BattleArmy ba : roundInfo.attKilledList) {
      if (ba.getCampArmy().getFuBingNum() > 0) {
        List<BattleArmy> AddQlist = new ArrayList<>();
        Builder.fuBing(ba.getCampArmy(), AddQlist, this.attList, this.attCamp, 1, this.attQNum, this.attBaseInfo, this.inBattlePlayers, roundInfo, this, dataGetter);
        break;
      } 
    } 
    for (BattleArmy ba : roundInfo.defKilledList) {
      if (ba.getCampArmy().getFuBingNum() > 0) {
        List<BattleArmy> AddQlist = new ArrayList<>();
        Builder.fuBing(ba.getCampArmy(), AddQlist, this.defList, this.defCamp, 0, this.defQNum, this.defBaseInfo, this.inBattlePlayers, roundInfo, this, dataGetter);
        break;
      } 
    } 
    if (roundInfo.defCampArmy.getGeneralId() == 281 && !roundInfo.defCampArmy.isPhantom) {
      if (roundInfo.defBattleArmy.getHaveZhanChe())
        roundInfo.defCampArmy.isScCar = true; 
      if (!roundInfo.defBattleArmy.getHaveZhanChe() && roundInfo.defCampArmy.isScCar && roundInfo.defCampArmy.hujia <= 0) {
        roundInfo.defCampArmy.isScCar = false;
        roundInfo.defCampArmy.isScCarPo = true;
      } 
      if (roundInfo.attCampArmy.armyHpLoss >= roundInfo.attCampArmy.armyHpOrg)
        roundInfo.defCampArmy.setDoujiang(true); 
      if (roundInfo.attCampArmy.armyHpLoss >= roundInfo.attCampArmy.armyHpOrg && this.battleType == 13)
        roundInfo.defCampArmy.setSuncChihu(true); 
    } 
    if (roundInfo.attCampArmy.getGeneralId() == 281 && !roundInfo.attCampArmy.isPhantom) {
      if (roundInfo.attBattleArmy.getHaveZhanChe())
        roundInfo.attCampArmy.isScCar = true; 
      if (!roundInfo.attBattleArmy.getHaveZhanChe() && roundInfo.attCampArmy.isScCar && roundInfo.attCampArmy.hujia <= 0) {
        roundInfo.attCampArmy.isScCar = false;
        roundInfo.attCampArmy.isScCarPo = true;
      } 
      if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg)
        roundInfo.attCampArmy.setDoujiang(true); 
      if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg && this.battleType == 13)
        roundInfo.attCampArmy.setSuncChihu(true); 
    } 
    if (roundInfo.killAttG && roundInfo.attCampArmy.getIsBeatMonster() > 0 && roundInfo.attCampArmy.getBeastId() > 0 && roundInfo.attBattleArmy.getTroopHp()[0] <= 0)
      dataGetter.getPlayerWarBeastDao().updateWarBeastStateAndCD(roundInfo.attCampArmy.getPlayerId(), roundInfo.attCampArmy.getBeastId(), 0, new Date(System.currentTimeMillis() + 1800000L), new Date(System.currentTimeMillis())); 
    if (roundInfo.killDefG && roundInfo.defCampArmy.getIsBeatMonster() > 0 && roundInfo.defCampArmy.getBeastId() > 0 && roundInfo.defBattleArmy.getTroopHp()[0] <= 0)
      dataGetter.getPlayerWarBeastDao().updateWarBeastStateAndCD(roundInfo.defCampArmy.getPlayerId(), roundInfo.defCampArmy.getBeastId(), 0, new Date(System.currentTimeMillis() + 1800000L), new Date(System.currentTimeMillis())); 
    if ((roundInfo.killAttG && roundInfo.attCampArmy.getHelpGeneral() == 403) || (roundInfo.attCampArmy.getGeneralId() == 403 && roundInfo.attCampArmy.getIsJuexing() > 0))
      for (BattleArmy bta : this.defList)
        bta.getCampArmy().setZhaXiang(4);  
    if ((roundInfo.killDefG && roundInfo.defCampArmy.getHelpGeneral() == 403) || (roundInfo.defCampArmy.getGeneralId() == 403 && roundInfo.defCampArmy.getIsJuexing() > 0))
      for (BattleArmy bta : this.attList)
        bta.getCampArmy().setZhaXiang(4);  
    if (this.quickBattle > 0) {
      roundInfo.battleMsg.append("46|").append(roundInfo.attBattleArmy.getPosition()).append(";").append(roundInfo.defBattleArmy.getPosition()).append("|");
      if (roundInfo.attKilledList.isEmpty()) {
        roundInfo.battleMsg.append("null|");
      } else {
        for (BattleArmy ba : roundInfo.attKilledList)
          roundInfo.battleMsg.append(ba.getPosition()).append(","); 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "|");
      } 
      if (roundInfo.defKilledList.isEmpty()) {
        roundInfo.battleMsg.append("null#");
      } else {
        for (BattleArmy ba : roundInfo.defKilledList)
          roundInfo.battleMsg.append(ba.getPosition()).append(","); 
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
      } 
    } 
    builder.addAttNpc(dataGetter, this.battleNum.get(), this.attBaseInfo, this.attCamp, this.campNum, this);
    builder.addDefNpc(dataGetter, this, roundInfo);
    builder.systemSinglePK(dataGetter, this, roundInfo);
    List<BattleArmy> attAddQlist = new ArrayList<>();
    Builder.onceAddQueues(attAddQlist, this.attList, this.attCamp, 1, this.attQNum, this.attBaseInfo, this.inBattlePlayers, roundInfo, this, dataGetter);
    Builder.getReportType2(roundInfo.battleMsg, attAddQlist, "att");
    List<BattleArmy> defAddQlist = new ArrayList<>();
    Builder.onceAddQueues(defAddQlist, this.defList, this.defCamp, 0, this.defQNum, this.defBaseInfo, this.inBattlePlayers, roundInfo, this, dataGetter);
    Builder.getReportType2(roundInfo.battleMsg, defAddQlist, "def");
    builder.roundUpdateDB(dataGetter, this, roundInfo);
    Builder.getReportType19(roundInfo.battleMsg, roundInfo);
    if (!xuyaoFight && 
      builder.isBattleEnd(dataGetter, this) == 1)
      Builder.getReportType27(roundInfo.battleMsg, roundInfo, this, dataGetter, -1L); 
    int sn = this.ticket.incrementAndGet();
    StringBuilder sb = new StringBuilder();
    sb.append(sn).append("|").append(this.battleId).append("#");
    if (roundInfo.win == 3 && this.defList.size() > 0 && ((BattleArmy)this.defList.get(0)).getCampArmy().getPlayerId() > 0)
      this.waitting = true; 
    roundInfo.nextMaxExeTime = roundInfo.nextMinExeTime;
    boolean attAutoStChoosed = false;
    if (roundInfo.attCampArmy.playerId > 0 && !roundInfo.attCampArmy.isPhantom) {
      PlayerInfo piAtt = this.inBattlePlayers.get(Integer.valueOf(roundInfo.attCampArmy.playerId));
      attAutoStChoosed = ((piAtt != null && piAtt.autoStrategy == 1) || roundInfo.attCampArmy.isPhantom);
    } 
    boolean defAutoStChoosed = false;
    if (roundInfo.defCampArmy.playerId > 0 && !roundInfo.defCampArmy.isPhantom) {
      PlayerInfo piDef = this.inBattlePlayers.get(Integer.valueOf(roundInfo.defCampArmy.playerId));
      defAutoStChoosed = ((piDef != null && piDef.autoStrategy == 1) || roundInfo.defCampArmy.isPhantom);
    } 
    this.attChooseTactic = false;
    this.defChooseTactic = false;
    this.attChoose = false;
    this.defChoose = false;
    if (!xuyaoFight) {
      builder.updateChooseTime(this, roundInfo, attAutoStChoosed, defAutoStChoosed);
      Builder.getReportType26(sb, roundInfo, this, dataGetter);
    } 
    roundInfo.battleMsg.insert(0, sb);
    builder.saveTimePredicationBuffer(roundInfo);
    if (roundInfo.needPushReport13)
      Builder.getReportType13(this, roundInfo.battleMsg); 
    SaveCurReport(dataGetter);
    Builder.getReportType100(dataGetter, this, roundInfo.battleMsg);
    if (this.attList.size() > 0) {
      BattleArmy fistBattleArmy = this.attList.get(0);
      CampArmy attfirstCamp = fistBattleArmy.getCampArmy();
      if (fistBattleArmy.getIsDajiang() > 0 && attfirstCamp.getLegendSkill().containsKey("zongheng"))
        if (((Integer)attfirstCamp.getLegendSkill().get("zongheng")).intValue() >= 3) {
          attfirstCamp.setNeedZongHeng(true);
          attfirstCamp.setGuDan(true);
        } else if (roundInfo.defKilledList.size() > 0 && ((Integer)attfirstCamp.getLegendSkill().get("zongheng")).intValue() > 0) {
          attfirstCamp.setNeedZongHeng(true);
        }  
    } 
    if (this.defList.size() > 0) {
      BattleArmy fistBattleArmy = this.defList.get(0);
      CampArmy deffirstCamp = fistBattleArmy.getCampArmy();
      if (fistBattleArmy.getIsDajiang() > 0 && deffirstCamp.getLegendSkill().containsKey("zongheng"))
        if (((Integer)deffirstCamp.getLegendSkill().get("zongheng")).intValue() >= 3) {
          deffirstCamp.setNeedZongHeng(true);
          deffirstCamp.setGuDan(true);
        } else if (roundInfo.attKilledList.size() > 0 && ((Integer)deffirstCamp.getLegendSkill().get("zongheng")).intValue() > 0) {
          deffirstCamp.setNeedZongHeng(true);
        }  
    } 
    if (roundInfo.attCampArmy.generalId == 205 && roundInfo.attCampArmy.isjuexing > 0) {
      int attmachaotime = roundInfo.attCampArmy.machaotimes;
      if (roundInfo.attCampArmy.armyHpLoss >= roundInfo.attCampArmy.armyHpOrg)
        attmachaotime = -1; 
      roundInfo.battleMsg.append("65|3,").append(attmachaotime).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      if (roundInfo.defCampArmy.generalId == 205 && roundInfo.defCampArmy.isjuexing > 0) {
        int defmachaotime = roundInfo.defCampArmy.machaotimes;
        if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg)
          defmachaotime = -1; 
        roundInfo.battleMsg.append("3,").append(defmachaotime).append(",").append(1 + roundInfo.defCampArmy.formationLevel / 20).append("#");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.generalId == 205 && roundInfo.defCampArmy.isjuexing > 0) {
      int defmachaotime = roundInfo.defCampArmy.machaotimes;
      if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg)
        defmachaotime = -1; 
      roundInfo.battleMsg.append("65|null;3,").append(defmachaotime).append(",").append(1 + roundInfo.defCampArmy.formationLevel / 20).append("#");
    } 
    if (roundInfo.attCampArmy.generalId == 280 && roundInfo.attCampArmy.isjuexing > 0) {
      roundInfo.battleMsg.append("65|9,").append(roundInfo.attCampArmy.czshinum).append(",").append(roundInfo.attCampArmy.czshiround).append(";");
      if (roundInfo.defCampArmy.generalId == 280 && roundInfo.defCampArmy.isjuexing > 0) {
        roundInfo.battleMsg.append("9,").append(roundInfo.defCampArmy.czshinum).append(",").append(roundInfo.defCampArmy.czshiround).append("#");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.generalId == 280 && roundInfo.defCampArmy.isjuexing > 0) {
      roundInfo.battleMsg.append("65|null;9,").append(roundInfo.defCampArmy.czshinum).append(",").append(roundInfo.defCampArmy.czshiround).append("#");
    } 
    if (roundInfo.attCampArmy.generalId == 280 && roundInfo.attCampArmy.isjuexing > 0) {
      roundInfo.battleMsg.append(85).append("|");
      int cztype = 1;
      if (roundInfo.attCampArmy.czshinum % 3 == 0)
        cztype = 2; 
      roundInfo.battleMsg.append(cztype).append("|att|");
      for (BattleArmy ba : getAttList()) {
        if (ba.getCampArmy() == roundInfo.attCampArmy) {
          roundInfo.battleMsg.append(ba.getPosition()).append(",");
          if (cztype == 1) {
            roundInfo.battleMsg.append(roundInfo.attCampArmy.missNum).append(";");
            continue;
          } 
          roundInfo.battleMsg.append(roundInfo.attCampArmy.immunoNum).append(";");
        } 
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
    } 
    if (roundInfo.defCampArmy.generalId == 280 && roundInfo.defCampArmy.isjuexing > 0) {
      roundInfo.battleMsg.append(85).append("|");
      int cztype = 1;
      if (roundInfo.defCampArmy.czshinum % 3 == 0)
        cztype = 2; 
      roundInfo.battleMsg.append(cztype).append("|def|");
      for (BattleArmy ba : getDefList()) {
        if (ba.getCampArmy() == roundInfo.defCampArmy) {
          roundInfo.battleMsg.append(ba.getPosition()).append(",");
          if (cztype == 1) {
            roundInfo.battleMsg.append(roundInfo.defCampArmy.missNum).append(";");
            continue;
          } 
          roundInfo.battleMsg.append(roundInfo.defCampArmy.immunoNum).append(";");
        } 
      } 
      roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#");
    } 
    if (roundInfo.attCampArmy.generalId == 232 && roundInfo.attCampArmy.isjuexing > 0 && roundInfo.attCampArmy.mfbuff >= 0 && roundInfo.attCampArmy.unionstate <= 0) {
      roundInfo.battleMsg.append("65|10,").append(roundInfo.attCampArmy.mfbuff).append(",0;");
      if (roundInfo.defCampArmy.generalId == 232 && roundInfo.defCampArmy.isjuexing > 0 && roundInfo.defCampArmy.mfbuff >= 0) {
        roundInfo.battleMsg.append("10,").append(roundInfo.defCampArmy.mfbuff).append(",0#");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.generalId == 232 && roundInfo.defCampArmy.isjuexing > 0 && roundInfo.defCampArmy.mfbuff >= 0 && roundInfo.defCampArmy.unionstate <= 0) {
      roundInfo.battleMsg.append("65|null;10,").append(roundInfo.defCampArmy.mfbuff).append(",0#");
    } 
    if (roundInfo.attCampArmy.generalId == 270 && roundInfo.attCampArmy.getUnionRank() >= 2) {
      int attmachaotime = roundInfo.attCampArmy.machaotimes;
      if (roundInfo.attCampArmy.armyHpLoss >= roundInfo.attCampArmy.armyHpOrg)
        attmachaotime = -1; 
      roundInfo.battleMsg.append("65|17,").append(attmachaotime).append(",").append(1 + roundInfo.attCampArmy.formationLevel / 20).append(";");
      if (roundInfo.defCampArmy.generalId == 270 && roundInfo.defCampArmy.unionrank >= 2) {
        int defmachaotime = roundInfo.defCampArmy.machaotimes;
        if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg)
          defmachaotime = -1; 
        roundInfo.battleMsg.append("17,").append(defmachaotime).append(",").append(1 + roundInfo.defCampArmy.formationLevel / 20).append("#");
      } else {
        roundInfo.battleMsg.append("null#");
      } 
    } else if (roundInfo.defCampArmy.generalId == 205 && roundInfo.defCampArmy.isjuexing > 0) {
      int defmachaotime = roundInfo.defCampArmy.machaotimes;
      if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg)
        defmachaotime = -1; 
      roundInfo.battleMsg.append("65|null;17,").append(defmachaotime).append(",").append(1 + roundInfo.defCampArmy.formationLevel / 20).append("#");
    } 
    if (getBattleType() == 3) {
      if (roundInfo.attCampArmy.getMeiXianUpper() > 0 && !roundInfo.defKilledList.isEmpty() && !this.shuaiqi_inuse)
        if (this.quickBattle > 0) {
          int curmeixian = roundInfo.attCampArmy.getMeiXian() + 1;
          roundInfo.attCampArmy.setMeiXian(curmeixian);
          if (curmeixian >= roundInfo.attCampArmy.getMeiXianUpper()) {
            this.quickBattle = 0;
            this.quicktype = 0;
            roundInfo.attCampArmy.setMeiXian(5);
            if (roundInfo.attCampArmy.getGeneralId() == 277 && roundInfo.attCampArmy.getUnionState() > 0)
              roundInfo.attCampArmy.setMeiXian(4); 
          } 
        } else {
          int curmeixian = roundInfo.attCampArmy.getMeiXian() - 1;
          roundInfo.attCampArmy.setMeiXian(curmeixian);
          if (curmeixian <= 0) {
            this.quickBattle = 1;
            this.quicktype = 2;
            int interval = 500;
            long time = System.currentTimeMillis() + 500L;
            changeExeTime(time);
          } 
        }  
      if (roundInfo.defCampArmy.getMeiXianUpper() > 0 && !roundInfo.attKilledList.isEmpty() && !this.shuaiqi_inuse)
        if (this.quickBattle > 0) {
          int curmeixian = roundInfo.defCampArmy.getMeiXian() + 1;
          roundInfo.defCampArmy.setMeiXian(curmeixian);
          if (curmeixian >= roundInfo.defCampArmy.getMeiXianUpper()) {
            this.quickBattle = 0;
            this.quicktype = 0;
            roundInfo.defCampArmy.setMeiXian(5);
            if (roundInfo.defCampArmy.getGeneralId() == 277 && roundInfo.defCampArmy.getUnionState() > 0)
              roundInfo.defCampArmy.setMeiXian(4); 
          } 
        } else {
          int curmeixian = roundInfo.defCampArmy.getMeiXian() - 1;
          roundInfo.defCampArmy.setMeiXian(curmeixian);
          if (curmeixian <= 0) {
            this.quickBattle = 1;
            this.quicktype = 1;
            int interval = 500;
            long time = System.currentTimeMillis() + 500L;
            changeExeTime(time);
          } 
        }  
      if (this.quickBattle > 0 && !this.shuaiqi_inuse) {
        if (roundInfo.attCampArmy.getMeiXianUpper() > 0 && roundInfo.killAttG) {
          this.quickBattle = 0;
          this.quicktype = 0;
        } 
        if (roundInfo.defCampArmy.getMeiXianUpper() > 0 && roundInfo.killDefG) {
          this.quickBattle = 0;
          this.quicktype = 0;
        } 
      } 
    } 
    if (roundInfo.attCampArmy.getZhaXiang() > 0) {
      roundInfo.attCampArmy.setZhaXiang(roundInfo.attCampArmy.getZhaXiang() - 1);
      roundInfo.battleMsg.append(119).append("att|");
      boolean youadd = false;
      for (int j = 0; j < this.attList.size(); j++) {
        youadd = true;
        BattleArmy bta = this.attList.get(j);
        roundInfo.battleMsg.append(bta.getPosition()).append(",").append(bta.getCampArmy().getZhaXiang()).append("*");
      } 
      if (youadd)
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#"); 
    } 
    if (!roundInfo.attCampArmy.getZyMaxRow() && roundInfo.attCampArmy.getGeneralId() == 204 && roundInfo.attCampArmy.getChapterId() >= 5)
      if (roundInfo.attCampArmy.armyHpLoss >= roundInfo.attCampArmy.armyHpOrg) {
        roundInfo.attCampArmy.armyHpLoss += 1200;
        List<BattleArmy> AddQlist = new ArrayList<>();
        DaZhaoYunBatcamp(roundInfo.attCampArmy, AddQlist, this.attList, this.attCamp, 1, this.attQNum, this.attBaseInfo, this.inBattlePlayers, roundInfo, this, dataGetter);
        roundInfo.attCampArmy.setZyMaxRow(true);
        if (this.attList.size() <= 0)
          roundInfo.attCampArmy.zyMaxRow = true; 
      }  
    if (!roundInfo.defCampArmy.getZyMaxRow() && roundInfo.defCampArmy.getGeneralId() == 204 && roundInfo.defCampArmy.getChapterId() >= 5)
      if (roundInfo.defCampArmy.armyHpLoss >= roundInfo.defCampArmy.armyHpOrg) {
        roundInfo.defCampArmy.armyHpLoss += 1200;
        List<BattleArmy> AddQlist = new ArrayList<>();
        DaZhaoYunBatcamp(roundInfo.defCampArmy, AddQlist, this.defList, this.defCamp, 0, this.defQNum, this.defBaseInfo, this.inBattlePlayers, roundInfo, this, dataGetter);
        roundInfo.defCampArmy.setZyMaxRow(true);
        if (this.defList.size() <= 0)
          roundInfo.defCampArmy.zyMaxRow = true; 
      }  
    if (roundInfo.defCampArmy.getGeneralId() == 107 && !roundInfo.defCampArmy.isPhantom)
      if (roundInfo.attCampArmy.armyHpLoss >= roundInfo.attCampArmy.armyHpOrg)
        dataGetter.getBattleService().CaocaodoCopyArmy(roundInfo.defCampArmy.playerId, roundInfo.defCampArmy, this.battleId, 1, 0, 20);  
    if (roundInfo.defCampArmy.getZhaXiang() > 0) {
      roundInfo.defCampArmy.setZhaXiang(roundInfo.defCampArmy.getZhaXiang() - 1);
      roundInfo.battleMsg.append(119).append("def|");
      boolean youadd = false;
      for (int j = 0; j < this.defList.size(); j++) {
        youadd = true;
        BattleArmy bta = this.defList.get(j);
        roundInfo.battleMsg.append(bta.getPosition()).append(",").append(bta.getCampArmy().getZhaXiang()).append("*");
      } 
      if (youadd)
        roundInfo.battleMsg.replace(roundInfo.battleMsg.length() - 1, roundInfo.battleMsg.length(), "#"); 
    } 
    if (roundInfo.attCampArmy.getTuiShou() > 0)
      roundInfo.attCampArmy.setTuiShou(roundInfo.attCampArmy.getTuiShou() - 1); 
    if (roundInfo.defCampArmy.getTuiShou() > 0)
      roundInfo.defCampArmy.setTuiShou(roundInfo.defCampArmy.getTuiShou() - 1); 
    if (roundInfo.attCampArmy.getGeneralId() == 404 && roundInfo.attCampArmy.getIsJuexing() > 0 && roundInfo.attCampArmy.getRoundNum() > 0)
      if (this.roundNum.get() - roundInfo.attCampArmy.getRoundNum() >= 2) {
        roundInfo.attCampArmy.setRoundNum(-1);
        roundInfo.attCampArmy.setBaiYi(1);
        if (roundInfo.attCampArmy.getAttackLevel() < 0)
          roundInfo.attCampArmy.setAttackLevel(0); 
      }  
    if (roundInfo.defCampArmy.getGeneralId() == 404 && roundInfo.defCampArmy.getIsJuexing() > 0 && roundInfo.defCampArmy.getRoundNum() > 0 && 
      this.roundNum.get() - roundInfo.defCampArmy.getRoundNum() >= 2) {
      roundInfo.defCampArmy.setRoundNum(-1);
      roundInfo.defCampArmy.setBaiYi(1);
      if (roundInfo.defCampArmy.getAttackLevel() < 0)
        roundInfo.defCampArmy.setAttackLevel(0); 
    } 
    if (roundInfo.needreport47) {
      if (!this.attList.isEmpty() && !this.defList.isEmpty()) {
        Builder.getReportType47(roundInfo.battleMsg, this.attList, "att", getAttBaseInfo());
        Builder.getReportType47(roundInfo.battleMsg, this.defList, "def", getDefBaseInfo());
      } 
      roundInfo.needreport47 = false;
    } 
    Builder.sendMsgToAll(this, roundInfo.battleMsg);
    saveCurBattling(dataGetter, roundInfo);
    builder.saveCaculateDebugBuffer(roundInfo);
    this.newlyJoinSet.clear();
    this.lastRoundWinState = roundInfo.win;
    builder.setSurroundState(dataGetter, this);
    caculateAgainstInfo(dataGetter);
  }
  
  public void leave(int playerId) {
    synchronized (this.battleId) {
      this.inSceneSet.remove(Integer.valueOf(playerId));
    } 
  }
  
  public Set<CampArmy> quit(int playerId, Set<Integer> gIdSet, IDataGetter dataGetter, boolean isTuJin) {
    Builder builder = BuilderFactory.getInstance().getBuilder(this.battleType);
    synchronized (this.battleId) {
      PlayerInfo pi = this.inBattlePlayers.get(Integer.valueOf(playerId));
      List<CampArmy> camps = this.attCamp;
      List<BattleArmy> lists = this.attList;
      if (pi != null && !pi.isAttSide()) {
        camps = this.defCamp;
        lists = this.defList;
      } 
      Set<CampArmy> cset = new HashSet<>();
      for (CampArmy ca : camps) {
        if (ca.getPlayerId() == playerId && ca.getArmyHp() >= 0 && ca.isInBattle() && !ca.isPhantom() && ca.isDeputy <= 0)
          cset.add(ca); 
      } 
      Set<Integer> bset = new HashSet<>();
      for (BattleArmy bas : lists)
        bset.add(Integer.valueOf(bas.getCampArmy().getId())); 
      Set<CampArmy> quitGids = new HashSet<>();
      for (CampArmy ca2 : cset) {
        if (bset.contains(Integer.valueOf(ca2.getId())))
          continue; 
        if (!gIdSet.contains(Integer.valueOf(ca2.getGeneralId())))
          continue; 
        quitGids.add(ca2);
      } 
      if (quitGids.size() <= 0)
        return quitGids; 
      boolean isQuitAll = (quitGids.size() == cset.size());
      builder.quit(this, dataGetter, playerId, pi, quitGids, isQuitAll, isTuJin);
      if (isQuitAll) {
        builder.inBattleInfo(playerId, false);
        if (pi.battleMode == 0)
          pi.battleMode = 1; 
      } 
      return quitGids;
    } 
  }
  
  public boolean joinOneVsOneBackCA(int playerId, int battleSide, CampArmy ca, IDataGetter dataGetter, int generalState) {
    synchronized (this.battleId) {
      if (!this.battleDoing)
        return false; 
      if (generalState != 19 && CityService.getCityFlag(getDefBaseInfo().getId()) != 0)
        return false; 
      List<CampArmy> campMap = null;
      BaseInfo baseInfo = null;
      if (ca.getForceId() != this.defBaseInfo.forceId) {
        campMap = this.attCamp;
        baseInfo = this.attBaseInfo;
      } else {
        campMap = this.defCamp;
        baseInfo = this.defBaseInfo;
      } 
      campMap.add(ca);
      if (playerId > 0 && !ca.isPhantom)
        NewBattleManager.getInstance().joinBattle(this, playerId, new int[] { ca.getGeneralId() }); 
      baseInfo.setAllNum(baseInfo.getAllNum() + ca.getArmyHp());
      if (baseInfo.getNum() + ca.getArmyHp() < 0)
        ErrorSceneLog.getInstance().appendErrorMsg("兵力小于0,battle 2415行"); 
      baseInfo.setNum(baseInfo.getNum() + ca.getArmyHp());
      this.newlyJoinSet.add(ca);
      if (ca.getPlayerId() > 0 && !ca.isPhantom)
        dataGetter.getPlayerGeneralMilitaryDao().updateState(ca.getPgmVId(), generalState); 
      if (ca.isYellowTrubans)
        dataGetter.getYellowTurbansDao().updateState(Integer.valueOf(ca.getPgmVId()), 3); 
      return true;
    } 
  }
  
  public boolean joinCityNpc(WorldCity wc, int battleSide, IDataGetter dataGetter, int forceId) {
    synchronized (this.battleId) {
      if (!isBattleDoing())
        return false; 
      battleSide = 1;
      if (getDefBaseInfo().getForceId() == forceId)
        battleSide = 0; 
      LinkedList<CampArmy> campChange = new LinkedList<>();
      List<CampArmy> campMap = null;
      BaseInfo baseInfo = null;
      if (battleSide == 1) {
        campMap = this.attCamp;
        baseInfo = this.attBaseInfo;
      } else {
        campMap = this.defCamp;
        baseInfo = this.defBaseInfo;
      } 
      int distance = wc.getDistance(forceId);
      WorldGuardInfo wgi = (WorldGuardInfo)dataGetter.getWorldGuardInfoCache().get(Integer.valueOf(distance));
      WorldGuard wg = dataGetter.getWorldGuardCache().getByForceIdDegree(forceId, wgi.getNpcDegreeBase().intValue());
      if (wg == null)
        return false; 
      CampArmy campArmy = null;
      int num = 0;
      int id = 0;
      int cityNum = dataGetter.getCityDao().getForceCounts(forceId);
      double beilv = 1.0D;
      String jwjzl = Configuration.getProperty("gcld.jinweijun.zhanli");
      String jwjblood = Configuration.getProperty("gcld.jinweijun.blood");
      int addblood = 0;
      if (jwjblood != null && !jwjblood.equals(""))
        addblood = Integer.valueOf(jwjblood).intValue(); 
      if (jwjzl != null && !jwjzl.equals(""))
        beilv = Double.valueOf(jwjzl).doubleValue(); 
      String title = "";
      String pic = "caoren2";
      int att = 50000000;
      int def = 51000000;
      int bd = 50000000;
      double beishu = 1.0D;
      int danpai = 1;
      int zongbing = 0;
      int carId = 51;
      int carskill = 1;
      int type_id = 128;
      int lv = 100;
      if (cityNum <= 20) {
        title = "龙鳞御卫";
        beishu = 3.5D;
        danpai = 10;
        zongbing = 5;
        carId = 87652;
        type_id = 163;
        lv = 300;
        pic = "chuanqizhaoyunzhuanshu2";
        carskill = 4;
      } else if (cityNum <= 30) {
        title = "无敌羽林卫";
        beishu = 3.0D;
        danpai = 8;
        zongbing = 4;
        carId = 87532;
        type_id = 162;
        lv = 250;
        pic = "chuanqizhaoyun5";
        carskill = 3;
      } else if (cityNum <= 40) {
        title = "羽林卫";
        beishu = 2.5D;
        danpai = 6;
        zongbing = 3;
        carId = 87522;
        lv = 200;
        pic = "ganning2j";
        type_id = 160;
        carskill = 2;
      } else if (cityNum <= 50) {
        title = "御龙禁卫军";
        beishu = 2.0D;
        danpai = 5;
        zongbing = 2;
        lv = 150;
        carId = 53;
        carskill = 3;
        type_id = 159;
        pic = "dongyingputong";
      } else if (cityNum <= 60) {
        title = "无敌禁卫军";
        beishu = 1.5D;
        danpai = 3;
        zongbing = 1;
        carId = 52;
        lv = 125;
        type_id = 137;
        carskill = 2;
        pic = "guojiajx";
      } else {
        title = "黄金禁卫军";
        carId = 51;
        carskill = 1;
        pic = "huangyueying2jzhuanshu";
      } 
      String ArmyName = "蜀";
      for (int i = 0; i < wgi.getNpcNum().intValue(); i++) {
        id = this.campNum.getAndIncrement();
        Player player = new Player();
        player.setPlayerId(Integer.valueOf(-1));
        player.setPlayerName(wg.getName());
        player.setForceId(Integer.valueOf(forceId));
        player.setPlayerLv(wg.getLv());
        player.setPayTotal(Integer.valueOf(0));
        campArmy = Builder.copyArmyFromCach(player, wg.getArmyId().intValue(), dataGetter, id, this.terrainVal, wg.getLv().intValue());
        if (campArmy != null) {
          campArmy.setArmyName(title);
          campArmy.setGeneralName(title);
          campArmy.setGeneralLv(lv);
          campArmy.setAttEffect(Double.valueOf(att * beishu * beilv).intValue());
          campArmy.setDefEffect(Double.valueOf(def * beishu * beilv).intValue());
          campArmy.setBdEffect(Double.valueOf(bd * beishu * beilv).intValue());
          int oldrowhp = campArmy.getTroopHp();
          campArmy.setTroopHp(oldrowhp * danpai * (1 + addblood));
          campArmy.setArmyHp(oldrowhp * danpai * (5 + zongbing) * (1 + addblood));
          campArmy.setArmyHpOrg(oldrowhp * danpai * (5 + zongbing) * (1 + addblood));
          campArmy.setMaxForces(oldrowhp * danpai * (5 + zongbing) * (1 + addblood));
          campArmy.setColumn(5 + zongbing);
          campArmy.isPhantom = true;
          campArmy.setCarId(carId);
          campArmy.setCarModel(carskill);
          campArmy.setGeneralPic(pic);
          campArmy.setTroopType(type_id);
          if (carId == 52 || carId == 87522)
            campArmy.setDefence(1); 
          campArmy.setBigGzNum(5);
          campArmy.setCarHp(500000);
          campArmy.setCarMaxHp(25000000);
          campArmy.setHujia(25000);
          campArmy.shield = oldrowhp;
          campArmy.setAttcoe(Double.valueOf(2.0D));
          if (carId == 65 || carId == 87652) {
            campArmy.setSiCheHuJia(30);
            campArmy.setSiCheGeZi(3);
          } 
          campArmy.setNaijiu(50);
          campArmy.setPojia(58888);
          campArmy.setCatapultSkill(carskill);
          num += campArmy.getArmyHpOrg();
          campMap.add(campArmy);
          BattleSceneLog.getInstance().info("#batId:" + getBattleId() + "_" + getStartTime() + "#add:ciytNpc#side:" + ((battleSide == 1) ? "att" : "def") + "#playerId:" + campArmy.getPlayerId() + ":" + campArmy.isPhantom + "#general:" + campArmy.getGeneralId() + "#" + ((battleSide == 1) ? "att" : "def") + "Size:" + campMap.size());
          campChange.add(campArmy);
        } 
      } 
      if (baseInfo.getNum() + num < 0)
        ErrorSceneLog.getInstance().appendErrorMsg("兵力小于0,battle 2472行"); 
      baseInfo.setNum(baseInfo.getNum() + num);
      baseInfo.setAllNum(baseInfo.getAllNum() + num);
      for (CampArmy ca : campChange)
        this.newlyJoinSet.add(ca); 
      return true;
    } 
  }
  
  public JoinTeamBattleInfo joinTeam(Player player, Map<Integer, TeamMember> tmMap, IDataGetter dataGetter, Team team, int teamBatType) {
    JoinTeamBattleInfo jtbi = new JoinTeamBattleInfo();
    synchronized (this.battleId) {
      if (!this.battleDoing) {
        jtbi.error = LocalMessages.BATTLE_END_INFO;
        return jtbi;
      } 
      PlayerInfo pi = this.inBattlePlayers.get(player.getPlayerId());
      if (pi == null) {
        jtbi.error = LocalMessages.T_TEAM_CONDITION_10038;
        return jtbi;
      } 
      List<CampArmy> selfSideCampMap = null;
      List<CampArmy> otherSideCampMap = null;
      List<BattleArmy> selfList = null;
      BaseInfo selfSideBaseInfo = null;
      String reportType = null;
      int battleSide = 0;
      if (pi.isAttSide) {
        selfSideCampMap = this.attCamp;
        otherSideCampMap = this.defCamp;
        selfSideBaseInfo = this.attBaseInfo;
        selfList = this.attList;
        reportType = "att";
        battleSide = 1;
      } else {
        selfSideCampMap = this.defCamp;
        otherSideCampMap = this.attCamp;
        selfSideBaseInfo = this.defBaseInfo;
        selfList = this.defList;
        reportType = "def";
      } 
      boolean isInBat = false;
      for (CampArmy ca : selfSideCampMap) {
        if (ca.getPlayerId() == player.getPlayerId().intValue() && !ca.isPhantom) {
          isInBat = true;
          break;
        } 
      } 
      if (!isInBat) {
        jtbi.error = LocalMessages.T_TEAM_CONDITION_10038;
        return jtbi;
      } 
      boolean alreadyIn = true;
      LinkedList<CampArmy> campJoin = new LinkedList<>();
      LinkedList<CampArmy> campCreate = new LinkedList<>();
      Player tempPlayer = null;
      boolean canPK = true;
      int qFull = 0;
      String pkStr = LocalMessages.STR_YOUDI;
      if (battleSide == 0)
        pkStr = LocalMessages.STR_CHUJI; 
      boolean isNTYellowTurbans = dataGetter.getBattleService().isNTYellowTurbansXiangYangDoing(getDefBaseInfo().getId());
      for (Integer pId : tmMap.keySet()) {
        try {
          TeamMember tm = tmMap.get(pId);
          tempPlayer = dataGetter.getPlayerDao().read(tm.getPlayerId());
          PlayerWorld pw = dataGetter.getPlayerWorldDao().read(tm.getPlayerId());
          Set<Integer> attedSet = new HashSet<>();
          int aId = 0;
          if (pw.getAttedId() != null) {
            String[] ids = pw.getAttedId().split(",");
            for (int i = 0; i < ids.length; i++) {
              String str = ids[i];
              aId = Integer.valueOf(str).intValue();
              attedSet.add(Integer.valueOf(aId));
            } 
          } 
          if (!attedSet.contains(Integer.valueOf(this.defBaseInfo.getId())))
            continue; 
          if (this.inBattlePlayers.get(tempPlayer.getPlayerId()) == null) {
            int zdzsTech = dataGetter.getTechEffectCache().getTechEffect(tempPlayer.getPlayerId().intValue(), 43);
            int autoStrategy = 0;
            if (zdzsTech > 0) {
              PlayerBattleAttribute pba = dataGetter.getPlayerBattleAttributeDao().read(tempPlayer.getPlayerId().intValue());
              autoStrategy = pba.getAutoStrategy().intValue();
            } else {
              autoStrategy = -1;
            } 
            this.inBattlePlayers.put(tempPlayer.getPlayerId(), new PlayerInfo(tempPlayer.getPlayerId().intValue(), pi.isAttSide, autoStrategy));
          } 
          Map<Integer, PlayerGeneralMilitary> pgmMap = dataGetter.getPlayerGeneralMilitaryDao().getMilitaryMap(tempPlayer.getPlayerId().intValue());
          List<PlayerGeneralMilitary> pgmList = new ArrayList<>();
          List<GeneralInfo> giList = tm.getGeneralInfo();
          boolean pk = false;
          for (GeneralInfo gi : giList) {
            pk = false;
            PlayerGeneralMilitary pgm = pgmMap.get(Integer.valueOf(gi.getGeneralId()));
            int maxHp = dataGetter.getBattleDataCache().getMaxHp(pgm);
            if (pgm.getForces().intValue() * 1.0D / maxHp < 0.05D)
              continue; 
            if (pgm.getState().intValue() > 1)
              continue; 
            pgmList.add(pgm);
            if (teamBatType == 1)
              if (qFull < 1 && Builder.canAddBattleArmyList(selfList)) {
                qFull++;
              } else {
                qFull = 2;
                if (canPK && canOneVsOne(pgm, selfSideCampMap, otherSideCampMap, isNTYellowTurbans)) {
                  pk = true;
                } else {
                  canPK = false;
                } 
              }  
            if (pk) {
              if (isNTYellowTurbans) {
                createOneToOneBattleForNTYellowTurbans(pgm, dataGetter, tempPlayer, this, battleSide, new TeamInfo(team.getTeamName(), team.getInspireEffect()), campCreate);
                continue;
              } 
              createOneToOneBattle(pgm, dataGetter, tempPlayer, this, battleSide, new TeamInfo(team.getTeamName(), team.getInspireEffect()), campCreate);
              continue;
            } 
            initJoinPlayer2(pgm, dataGetter, tempPlayer, this, selfSideBaseInfo, selfSideCampMap, campJoin, battleSide, new TeamInfo(team.getTeamName(), team.getInspireEffect()));
          } 
          pushTeamGeneralBat(tempPlayer.getPlayerId().intValue(), pgmList);
          for (PlayerGeneralMilitary pgm2 : pgmList) {
            dataGetter.getCityService().sendAttMoveInfo(pgm2.getPlayerId().intValue(), pgm2.getGeneralId().intValue(), pgm2.getLocationId().intValue(), getDefBaseInfo().getId(), pgm2.getForceId().intValue(), "", pgm2.getForces().intValue(), true);
            dataGetter.getBattleService().updateHuizhanNationForce(getDefBaseInfo().getId(), pgm2.getForceId().intValue(), pgm2.getForces().intValue());
            dataGetter.getBattleService().updateHuizhanPlayerForce(getDefBaseInfo().getId(), pgm2.getPlayerId().intValue(), pgm2.getForces().intValue());
          } 
        } catch (Exception e) {
          ErrorSceneLog.getInstance().error("teamBattle Battle joinTeam playerId:" + pId + e.getMessage());
        } 
      } 
      for (CampArmy ca2 : campJoin)
        this.newlyJoinSet.add(ca2); 
      JsonDocument doc = new JsonDocument();
      doc.startObject();
      doc.createElement("batSide", Integer.valueOf(battleSide));
      doc.startArray("reports");
      StringBuilder battleMsg = null;
      int count = 1;
      if (teamBatType == 1) {
        for (CampArmy ca3 : campCreate) {
          battleMsg = new StringBuilder();
          battleMsg.append(MessageFormatter.format(LocalMessages.TEAM_BATTLE_INFO, new Object[] { ca3.getTeamGenreal(), ca3.getGeneralName(), pkStr, LocalMessages.STR_SUCC }));
          doc.startObject();
          doc.createElement("id", Integer.valueOf(count++));
          doc.createElement("msg", battleMsg.toString());
          doc.endObject();
        } 
        for (CampArmy ca3 : campJoin) {
          battleMsg = new StringBuilder();
          battleMsg.append(MessageFormatter.format(LocalMessages.TEAM_BATTLE_INFO2, new Object[] { ca3.getTeamGenreal(), ca3.getGeneralName() }));
          doc.startObject();
          doc.createElement("id", Integer.valueOf(count++));
          doc.createElement("msg", battleMsg.toString());
          doc.endObject();
        } 
      } else {
        for (CampArmy ca3 : campJoin) {
          battleMsg = new StringBuilder();
          battleMsg.append(MessageFormatter.format(LocalMessages.TEAM_BATTLE_INFO2, new Object[] { ca3.getTeamGenreal(), ca3.getGeneralName() }));
          doc.startObject();
          doc.createElement("id", Integer.valueOf(count++));
          doc.createElement("msg", battleMsg.toString());
          doc.endObject();
        } 
      } 
      doc.endArray();
      doc.endObject();
      if (campJoin.size() > 0 || campCreate.size() > 0)
        for (Integer playerId : this.inSceneSet) {
          if (NewBattleManager.getInstance().isWatchBattle(playerId.intValue(), getBattleId()))
            Players.push(playerId.intValue(), PushCommand.PUSH_TEAM_START_BAT, doc.toByte()); 
        }  
      pushJoinInfo(campJoin, reportType, true, dataGetter, player.getPlayerId().intValue());
      jtbi.result = true;
      jtbi.battleSide = battleSide;
      jtbi.campJoin = campJoin;
      jtbi.campCreate = campCreate;
    } 
    return jtbi;
  }
  
  private void createOneToOneBattle(PlayerGeneralMilitary pgm, IDataGetter dataGetter, Player player, Battle bat, int battleSide, TeamInfo teamInfo, LinkedList<CampArmy> campChange) {
    CampArmy[] cas = new CampArmy[2];
    int OneToOneBattleType = 0;
    switch (bat.getBattleType()) {
      case 3:
        OneToOneBattleType = 13;
        break;
      case 14:
        OneToOneBattleType = 15;
        break;
    } 
    Builder builder = BuilderFactory.getInstance().getBuilder(OneToOneBattleType);
    CampArmy pgmCa = CityBuilder.copyCampFromPlayerTable(player, pgm, dataGetter, builder.getGeneralState(), bat, battleSide);
    if (pgmCa == null)
      return; 
    pgmCa.teamGenreal = teamInfo.teamName;
    pgmCa.teamEffect = teamInfo.teamEffect;
    campChange.add(pgmCa);
    int pkType = 1;
    if (battleSide == 0) {
      pkType = 2;
      cas[1] = pgmCa;
      for (CampArmy ca : bat.getAttCamp()) {
        if (!ca.onQueues && ca.isDeputy <= 0) {
          cas[0] = ca;
          bat.getAttCamp().remove(ca);
          if (ca.getPlayerId() > 0 && !ca.isPhantom())
            NewBattleManager.getInstance().quitBattle(this, ca.getPlayerId(), new int[] { ca.getGeneralId() }); 
          bat.attBaseInfo.setAllNum(bat.attBaseInfo.getAllNum() - (cas[0]).armyHp);
          if (bat.attBaseInfo.getNum() < (cas[0]).armyHp)
            ErrorSceneLog.getInstance().appendErrorMsg("battle createOneToOneBattle att 兵力小于0,battle 2714行"); 
          bat.attBaseInfo.setNum(bat.attBaseInfo.getNum() - (cas[0]).armyHp);
          break;
        } 
      } 
    } else {
      cas[0] = pgmCa;
      for (CampArmy ca : bat.getDefCamp()) {
        if (!ca.onQueues && ca.isDeputy <= 0) {
          cas[1] = ca;
          bat.getDefCamp().remove(ca);
          if (ca.getPlayerId() > 0 && !ca.isPhantom())
            NewBattleManager.getInstance().quitBattle(this, ca.getPlayerId(), new int[] { ca.getGeneralId() }); 
          bat.defBaseInfo.setAllNum(bat.defBaseInfo.getAllNum() - (cas[1]).armyHp);
          if (bat.defBaseInfo.getNum() < (cas[1]).armyHp)
            ErrorSceneLog.getInstance().appendErrorMsg("battle createOneToOneBattle def 兵力小于0,battle 2733行"); 
          bat.defBaseInfo.setNum(bat.defBaseInfo.getNum() - (cas[1]).armyHp);
          break;
        } 
      } 
    } 
    dataGetter.getBattleService().createOneToOneBattle(player.getPlayerId().intValue(), cas, bat, pkType, 0, false);
  }
  
  private void createOneToOneBattleForNTYellowTurbans(PlayerGeneralMilitary pgm, IDataGetter dataGetter, Player player, Battle bat, int battleSide, TeamInfo teamInfo, LinkedList<CampArmy> campChange) {
    CampArmy[] cas = new CampArmy[2];
    int OneToOneBattleType = 0;
    switch (bat.getBattleType()) {
      case 3:
        OneToOneBattleType = 13;
        break;
      case 14:
        OneToOneBattleType = 15;
        break;
    } 
    Builder builder = BuilderFactory.getInstance().getBuilder(OneToOneBattleType);
    CampArmy pgmCa = CityBuilder.copyCampFromPlayerTable(player, pgm, dataGetter, builder.getGeneralState(), bat, battleSide);
    if (pgmCa == null)
      return; 
    pgmCa.teamGenreal = teamInfo.teamName;
    pgmCa.teamEffect = teamInfo.teamEffect;
    campChange.add(pgmCa);
    cas[0] = pgmCa;
    cas[1] = null;
    for (CampArmy ca : bat.getAttCamp()) {
      if (!ca.onQueues && ca.getForceId() != pgmCa.getForceId() && ca.isDeputy <= 0) {
        cas[1] = ca;
        bat.getAttCamp().remove(ca);
        if (bat.getAttBaseInfo().getNum() < ca.getArmyHp())
          ErrorSceneLog.getInstance().appendErrorMsg("battle createOneToOneBattleForNTYellowTurbans att兵力小于0,battle 2772行"); 
        bat.getAttBaseInfo().setNum(bat.getAttBaseInfo().getNum() - ca.getArmyHp());
        bat.getAttBaseInfo().setAllNum(bat.getAttBaseInfo().getAllNum() - ca.getArmyHp());
        break;
      } 
    } 
    if (cas[1] == null)
      return; 
    dataGetter.getBattleService().createOneToOneBattle(player.getPlayerId().intValue(), cas, bat, 2, 0, false);
  }
  
  private void initJoinPlayer2(PlayerGeneralMilitary pgm, IDataGetter dataGetter, Player player, Battle bat, BaseInfo baseInfo, List<CampArmy> campMap, List<CampArmy> campChange, int battleSide, TeamInfo teamInfo) {
    Builder builder = BuilderFactory.getInstance().getBuilder(bat.getBattleType());
    CampArmy campArmy = null;
    int num = 0;
    campArmy = CityBuilder.copyCampFromPlayerTable(player, pgm, dataGetter, builder.getGeneralState(), bat, battleSide);
    if (campArmy == null)
      return; 
    num += campArmy.getArmyHpOrg();
    campArmy.setTeamGenreal(teamInfo.teamName);
    campArmy.setTeamEffect(teamInfo.teamEffect);
    campMap.add(campArmy);
    BattleSceneLog.getInstance().info("#batId:" + bat.getBattleId() + "_" + bat.getStartTime() + "#add:join#side:" + ((battleSide == 1) ? "att" : "def") + "#playerId:" + campArmy.getPlayerId() + ":" + campArmy.isPhantom + "#general:" + campArmy.getGeneralId() + "#" + ((battleSide == 1) ? "att" : "def") + "Size:" + campMap.size());
    campChange.add(campArmy);
    if (baseInfo.getNum() + num < 0)
      ErrorSceneLog.getInstance().appendErrorMsg("兵力小于0,battle 2801行"); 
    baseInfo.setNum(baseInfo.getNum() + num);
    baseInfo.setAllNum(baseInfo.getAllNum() + num);
  }
  
  private boolean canOneVsOne(PlayerGeneralMilitary pgm, List<CampArmy> selfSideCampMap, List<CampArmy> otherSideCampMap, boolean isNTYellowTurbans) {
    boolean flag = false;
    if (isNTYellowTurbans) {
      for (CampArmy ca : selfSideCampMap) {
        if (!ca.onQueues && pgm.getForceId().intValue() != ca.getForceId()) {
          flag = true;
          break;
        } 
      } 
    } else {
      for (CampArmy ca : otherSideCampMap) {
        if (!ca.onQueues) {
          flag = true;
          break;
        } 
      } 
    } 
    return flag;
  }
  
  private void pushTeamGeneralBat(int playerId, List<PlayerGeneralMilitary> pgmList) {
    JsonDocument doc = new JsonDocument();
    doc.startObject();
    doc.startArray("batGenerals");
    for (PlayerGeneralMilitary pgm : pgmList) {
      doc.startObject();
      doc.createElement("generalId", pgm.getGeneralId());
      doc.endObject();
    } 
    doc.endArray();
    doc.endObject();
    Players.push(playerId, PushCommand.PUSH_TEAM_GENERAL_BAT, doc.toByte());
  }
  
  public boolean joinZhengZhaoLing(IDataGetter dataGetter, int playerId, List<PlayerGeneralMilitary> pgmList, double teamEffect, int attEffect, int defEffect, String playerName) {
    Builder builder = BuilderFactory.getInstance().getBuilder(this.battleType);
    synchronized (this.battleId) {
      if (!this.battleDoing)
        return false; 
      if (this.battleType <= 0) {
        BattleSceneLog.getInstance().error("Battle join battleType, 战斗还没初始化完成就想加入battleId" + this.battleId);
        return false;
      } 
      if (System.currentTimeMillis() > this.nextMaxExeTime + 180000L)
        return false; 
      boolean isNTYellowTurbans = dataGetter.getBattleService().isNTYellowTurbansXiangYangDoing(getDefBaseInfo().getId());
      int battleSide = 1;
      Player player = dataGetter.getPlayerDao().read(playerId);
      if (player != null)
        battleSide = builder.getBattleSide(dataGetter, player, (getDefBaseInfo()).id); 
      builder.inBattleInfo(playerId, true);
      builder.addInSceneSet(this, playerId);
      LinkedList<CampArmy> campChange = new LinkedList<>();
      List<CampArmy> campMap = null;
      List<CampArmy> counterCampMap = null;
      BaseInfo baseInfo = null;
      BaseInfo counterBaseInfo = null;
      String reportType = null;
      boolean alreadyIn = false;
      if ((this.battleType == 3 || this.battleType == 14) && this.inSceneSet.contains(Integer.valueOf(playerId)))
        alreadyIn = true; 
      int zdzsTech = dataGetter.getTechEffectCache().getTechEffect(playerId, 43);
      int autoStrategy = 0;
      if (zdzsTech > 0) {
        PlayerBattleAttribute pba = dataGetter.getPlayerBattleAttributeDao().read(playerId);
        autoStrategy = pba.getAutoStrategy().intValue();
      } else {
        autoStrategy = -1;
      } 
      if (battleSide == 1) {
        campMap = this.attCamp;
        counterCampMap = this.defCamp;
        baseInfo = this.attBaseInfo;
        counterBaseInfo = this.defBaseInfo;
        reportType = "att";
        if (this.inBattlePlayers.get(Integer.valueOf(playerId)) == null)
          this.inBattlePlayers.put(Integer.valueOf(playerId), new PlayerInfo(playerId, true, autoStrategy)); 
      } else {
        campMap = this.defCamp;
        counterCampMap = this.attCamp;
        baseInfo = this.defBaseInfo;
        counterBaseInfo = this.attBaseInfo;
        reportType = "def";
        if (this.inBattlePlayers.get(Integer.valueOf(playerId)) == null)
          this.inBattlePlayers.put(Integer.valueOf(playerId), new PlayerInfo(playerId, false, autoStrategy)); 
      } 
      builder.initZhengZhaoLingJoinPlayer(dataGetter, this, player, battleSide, pgmList, baseInfo, campMap, campChange, teamEffect, attEffect, defEffect, playerName);
      int force = 0;
      for (CampArmy ca : campChange)
        force += ca.getArmyHp(); 
      dataGetter.getBattleService().updateHuizhanPlayerForce(getDefBaseInfo().getId(), playerId, force);
      dataGetter.getBattleService().updateHuizhanNationForce(getDefBaseInfo().getId(), player.getForceId().intValue(), force);
      Set<CampArmy> singlePkSet = new HashSet<>();
      if (isNTYellowTurbans) {
        singlePkSet = sysSinglePkForNTYellowTurbans(dataGetter, campChange, campMap, baseInfo);
      } else {
        singlePkSet = sysSinglePk(dataGetter, campChange, campMap, counterCampMap, baseInfo, counterBaseInfo);
      } 
      for (CampArmy ca2 : campChange) {
        if (singlePkSet != null && singlePkSet.contains(ca2))
          continue; 
        this.newlyJoinSet.add(ca2);
      } 
      pushJoinInfo(campChange, reportType, alreadyIn, dataGetter, playerId);
      builder.sendTaskMessage(playerId, this.defBaseInfo.getId(), dataGetter);
    } 
    return true;
  }
  
  private Set<CampArmy> sysSinglePk(IDataGetter dataGetter, List<CampArmy> campChange, List<CampArmy> myCamp, List<CampArmy> counterCamp, BaseInfo myBaseInfo, BaseInfo counterBaseInfo) {
    try {
      int battleSide = 1;
      if (myCamp == this.defCamp)
        battleSide = 0; 
      Set<CampArmy> singlePkSet = new HashSet<>();
      for (CampArmy ca : campChange) {
        CampArmy[] cas = new CampArmy[2];
        int counterChooseId = counterCamp.size() - 1;
        cas[0] = ca;
        cas[1] = counterCamp.get(counterChooseId);
        if ((cas[0]).onQueues || (cas[0]).isDeputy > 0 || (cas[1]).onQueues || (cas[1]).isDeputy > 0)
          continue; 
        myCamp.remove(cas[0]);
        counterCamp.remove(cas[1]);
        myBaseInfo.setAllNum(myBaseInfo.getAllNum() - (cas[0]).armyHp);
        if (myBaseInfo.getNum() < (cas[0]).armyHp)
          ErrorSceneLog.getInstance().appendErrorMsg("battle sysSinglePk 攻击兵力小于0,battle 2949行"); 
        myBaseInfo.setNum(myBaseInfo.getNum() - (cas[0]).armyHp);
        counterBaseInfo.setAllNum(counterBaseInfo.getAllNum() - (cas[1]).armyHp);
        if (counterBaseInfo.getNum() < (cas[1]).armyHp)
          ErrorSceneLog.getInstance().appendErrorMsg("battle sysSinglePk def兵力小于0,battle 2955行"); 
        counterBaseInfo.setNum(counterBaseInfo.getNum() - (cas[1]).armyHp);
        if (battleSide == 0) {
          CampArmy temp = cas[0];
          cas[0] = cas[1];
          cas[1] = temp;
        } 
        dataGetter.getBattleService().createOneToOneBattle(-1, cas, this, 3, 0, false);
        singlePkSet.add(ca);
      } 
      return singlePkSet;
    } catch (Exception e) {
      ErrorSceneLog.getInstance().error("Battle.sysSinglePk catch Exception", e);
      return null;
    } 
  }
  
  private Set<CampArmy> sysSinglePkForNTYellowTurbans(IDataGetter dataGetter, List<CampArmy> campChange, List<CampArmy> myCamp, BaseInfo myBaseInfo) {
    try {
      Set<CampArmy> singlePkSet = new HashSet<>();
      for (CampArmy ca : campChange) {
        int forceId = ca.getForceId();
        CampArmy[] cas = { ca };
        if (myCamp.size() > 2)
          for (CampArmy tempCa : myCamp) {
            if (tempCa == myCamp.get(0) || tempCa == myCamp.get(1))
              continue; 
            if (tempCa.getForceId() != forceId && !tempCa.onQueues && tempCa.isDeputy <= 0) {
              cas[1] = tempCa;
              break;
            } 
          }  
        if ((cas[0]).onQueues || (cas[0]).isDeputy > 0 || cas[1] == null)
          continue; 
        myCamp.remove(cas[0]);
        myCamp.remove(cas[1]);
        myBaseInfo.setAllNum(myBaseInfo.getAllNum() - (cas[0]).armyHp - (cas[1]).armyHp);
        if (myBaseInfo.getNum() < (cas[0]).armyHp + (cas[1]).armyHp)
          ErrorSceneLog.getInstance().appendErrorMsg("battle sysSinglePkForNTYellowTurbans 兵力小于0,battle 2997行"); 
        myBaseInfo.setNum(myBaseInfo.getNum() - (cas[0]).armyHp - (cas[1]).armyHp);
        dataGetter.getBattleService().createOneToOneBattle(-1, cas, this, 3, 0, false);
        singlePkSet.add(ca);
      } 
      return singlePkSet;
    } catch (Exception e) {
      ErrorSceneLog.getInstance().error("Battle.sysSinglePk catch Exception", e);
      return null;
    } 
  }
  
  public boolean join(Player player, List<PlayerGeneralMilitary> pgmList, IDataGetter dataGetter) throws Exception {
    Builder builder = BuilderFactory.getInstance().getBuilder(this.battleType);
    synchronized (this.battleId) {
      if (!this.battleDoing)
        return false; 
      if (this.battleType <= 0) {
        BattleSceneLog.getInstance().error("Battle join battleType, 战斗还没初始化完成就想加入battleId" + this.battleId);
        return false;
      } 
      if (System.currentTimeMillis() > this.nextMaxExeTime + 180000L)
        throw new Exception("battle exception : battle stop"); 
      int playerId = player.getPlayerId().intValue();
      builder.inBattleInfo(playerId, true);
      builder.addInSceneSet(this, playerId);
      int battleSide = builder.getBattleSide(dataGetter, player, (getDefBaseInfo()).id);
      LinkedList<CampArmy> campChange = new LinkedList<>();
      List<CampArmy> campMap = null;
      BaseInfo baseInfo = null;
      String reportType = null;
      boolean alreadyIn = false;
      if ((this.battleType == 3 || this.battleType == 14 || this.battleType == 18) && this.inSceneSet.contains(Integer.valueOf(playerId)))
        alreadyIn = true; 
      int zdzsTech = dataGetter.getTechEffectCache().getTechEffect(playerId, 43);
      int autoStrategy = 0;
      if (zdzsTech > 0) {
        PlayerBattleAttribute pba = dataGetter.getPlayerBattleAttributeDao().read(playerId);
        autoStrategy = pba.getAutoStrategy().intValue();
      } else {
        autoStrategy = -1;
      } 
      if (battleSide == 1) {
        campMap = this.attCamp;
        baseInfo = this.attBaseInfo;
        reportType = "att";
        if (this.inBattlePlayers.get(Integer.valueOf(playerId)) == null)
          this.inBattlePlayers.put(Integer.valueOf(playerId), new PlayerInfo(playerId, true, autoStrategy)); 
      } else {
        campMap = this.defCamp;
        baseInfo = this.defBaseInfo;
        reportType = "def";
        if (this.inBattlePlayers.get(Integer.valueOf(playerId)) == null)
          this.inBattlePlayers.put(Integer.valueOf(playerId), new PlayerInfo(playerId, false, autoStrategy)); 
      } 
      builder.initJoinPlayer(pgmList, dataGetter, player, this, baseInfo, campMap, campChange, battleSide, null);
      for (CampArmy ca : campChange)
        this.newlyJoinSet.add(ca); 
      pushJoinInfo(campChange, reportType, alreadyIn, dataGetter, playerId);
      builder.sendTaskMessage(playerId, this.defBaseInfo.getId(), dataGetter);
    } 
    return true;
  }
  
  private void pushJoinInfo(LinkedList<CampArmy> campChange, String reportType, boolean alreadyIn, IDataGetter dataGetter, int playerId) {
    StringBuilder battleMsgPart1 = new StringBuilder();
    int sn = this.ticket.incrementAndGet();
    battleMsgPart1.append(sn).append("|").append(this.battleId).append("#");
    System.out.println("pushJoinInfo:" + battleMsgPart1.toString());
    List<BattleArmy> attAddQlist = new ArrayList<>();
    Builder.onceAddQueues(attAddQlist, this.attList, this.attCamp, 1, this.attQNum, this.attBaseInfo, this.inBattlePlayers, null, this, dataGetter);
    Builder.getReportType2(battleMsgPart1, attAddQlist, "att");
    List<BattleArmy> defAddQlist = new ArrayList<>();
    Builder.onceAddQueues(defAddQlist, this.defList, this.defCamp, 0, this.defQNum, this.defBaseInfo, this.inBattlePlayers, null, this, dataGetter);
    Builder.getReportType2(battleMsgPart1, defAddQlist, "def");
    Builder.getReportType13(this, battleMsgPart1);
    SaveCurReport(dataGetter);
    System.out.println(battleMsgPart1.toString());
    if (alreadyIn) {
      Builder.sendMsgToAll(this, battleMsgPart1);
    } else {
      Builder.sendMsgToAllExcludeOne(this, battleMsgPart1, playerId);
      if (this.curBattling.indexOf("#26") == 0 && this.curBattling.indexOf("#27") > 0) {
        this.curBattling.replace(this.curBattling.indexOf("#26") + 4, this.curBattling.indexOf("#27"), (new StringBuilder(String.valueOf(this.nextMaxExeTime - System.currentTimeMillis()))).toString());
      } else if (this.curBattling.indexOf("#26") > 0 && this.curBattling.indexOf("#27") > 0) {
        this.curBattling.replace(this.curBattling.indexOf("#26") + 4, this.curBattling.indexOf("#27"), (new StringBuilder(String.valueOf(this.nextMaxExeTime - System.currentTimeMillis()))).toString());
      } 
      StringBuilder msgToCurrentPlayer = new StringBuilder();
      msgToCurrentPlayer.append(sn).append("|").append(this.battleId).append("#").append(this.curReport).append(this.curBattling);
      String playerName = dataGetter.getPlayerDao().read(playerId).getPlayerName();
      String SingleHeadInfo = " battleId " + this.battleId + " 发送给个人:" + playerName + "  battleMsg: ";
      Builder.sendMsgToSingle(this, msgToCurrentPlayer, playerId, SingleHeadInfo, null);
    } 
  }
  
  public boolean joinCampArmy(IDataGetter dataGetter, int battleSide, CampArmy CaPhantom, int... lianxu) {
    try {
      synchronized (this.battleId) {
        if (!this.battleDoing)
          return false; 
        int defForceId = this.defBaseInfo.forceId;
        if (CaPhantom.forceId == defForceId) {
          if (battleSide == 1) {
            try {
              ErrorSceneLog.getInstance().appendErrorMsg("joinPhantom forceId error").appendBattleId(this.battleId).append("this.roundNum", getRoundNum()).append("battleSide", Integer.valueOf(battleSide)).append("defForceId", Integer.valueOf(defForceId)).append("CaPhantom.forceId", Integer.valueOf(CaPhantom.forceId)).append("CaPhantom.pgmVId", Integer.valueOf(CaPhantom.pgmVId)).append("CaPhantom.playerName", CaPhantom.playerName).append("CaPhantom.playerId", Integer.valueOf(CaPhantom.playerId)).append("CaPhantom.generalName", CaPhantom.generalName).append("CaPhantom.generalId", Integer.valueOf(CaPhantom.generalId)).append("CaPhantom.armyHpOrg", Integer.valueOf(CaPhantom.armyHpOrg)).append("CaPhantom.armyHp", Integer.valueOf(CaPhantom.armyHp)).flush();
            } catch (Exception e) {
              ErrorSceneLog.getInstance().error("Battle joinPhantom " + e);
            } 
            battleSide = 0;
          } 
        } else if (battleSide == 0) {
          try {
            ErrorSceneLog.getInstance().appendErrorMsg("joinPhantom forceId error").appendBattleId(this.battleId).append("this.battleNum", this.battleNum).append("battleSide", Integer.valueOf(battleSide)).append("defForceId", Integer.valueOf(defForceId)).append("CaPhantom.forceId", Integer.valueOf(CaPhantom.forceId)).append("CaPhantom.pgmVId", Integer.valueOf(CaPhantom.pgmVId)).append("CaPhantom.playerName", CaPhantom.playerName).append("CaPhantom.playerId", Integer.valueOf(CaPhantom.playerId)).append("CaPhantom.generalName", CaPhantom.generalName).append("CaPhantom.generalId", Integer.valueOf(CaPhantom.generalId)).append("CaPhantom.armyHpOrg", Integer.valueOf(CaPhantom.armyHpOrg)).append("CaPhantom.armyHp", Integer.valueOf(CaPhantom.armyHp)).flush();
          } catch (Exception e) {
            ErrorSceneLog.getInstance().error("Battle joinPhantom 2" + e);
          } 
          battleSide = 1;
        } 
        LinkedList<CampArmy> campChange = new LinkedList<>();
        List<CampArmy> campMap = null;
        BaseInfo baseInfo = null;
        if (battleSide == 1) {
          campMap = this.attCamp;
          baseInfo = this.attBaseInfo;
          this.worldSceneLog.appendLogMsg("CaPhantom join to attCamp").newLine().Indent();
        } else {
          campMap = this.defCamp;
          baseInfo = this.defBaseInfo;
          this.worldSceneLog.appendLogMsg("CaPhantom join to defCamp").newLine().Indent();
        } 
        this.worldSceneLog.appendPlayerName(CaPhantom.getPlayerName()).appendGeneralName(CaPhantom.getGeneralName()).appendPlayerId(CaPhantom.getPlayerId()).append("phantom vId", Integer.valueOf(CaPhantom.getPgmVId())).newLine();
        campMap.add(CaPhantom);
        campChange.add(CaPhantom);
        PlayerInfo piPhantom = this.inBattlePlayers.get(Integer.valueOf(CaPhantom.playerId));
        if (CaPhantom.playerId > 0 && piPhantom == null) {
          int zdzsTech = dataGetter.getTechEffectCache().getTechEffect(CaPhantom.playerId, 43);
          int autoStrategy = 0;
          if (zdzsTech > 0) {
            PlayerBattleAttribute pba = dataGetter.getPlayerBattleAttributeDao().read(CaPhantom.playerId);
            autoStrategy = pba.getAutoStrategy().intValue();
          } else {
            autoStrategy = -1;
          } 
          boolean isAttside = (battleSide == 1);
          this.inBattlePlayers.put(Integer.valueOf(CaPhantom.playerId), new PlayerInfo(CaPhantom.playerId, isAttside, autoStrategy));
        } 
        this.newlyJoinSet.add(CaPhantom);
        baseInfo.setNum(baseInfo.getNum() + CaPhantom.getArmyHpOrg());
        baseInfo.setAllNum(baseInfo.getAllNum() + CaPhantom.getArmyHpOrg());
        if (lianxu.length <= 0) {
          StringBuilder battleMsg = new StringBuilder();
          int sn = this.ticket.incrementAndGet();
          battleMsg.append(sn).append("|").append(this.battleId).append("#");
          Builder.getReportType13(this, battleMsg);
          SaveCurReport(dataGetter);
          Builder.sendMsgToAll(this, battleMsg);
        } 
        boolean hzFlag = dataGetter.getHuiZhanService().isHuiZhanInStatePreparation(getDefBaseInfo().getId());
        if (hzFlag)
          caculateAgainstInfo(dataGetter); 
        dataGetter.getBattleService().updateHuizhanNationForce(this.defBaseInfo.getId(), CaPhantom.forceId, CaPhantom.getArmyHp());
      } 
      return true;
    } catch (Exception e2) {
      return false;
    } 
  }
  
  public String getCurrentBattleInfo(int playerId, int battleSide, IDataGetter dataGetter, int backOrJoin) {
    synchronized (this.battleId) {
      if (this.curBattling.indexOf("#26") == 0 && this.curBattling.indexOf("#27") > 0) {
        this.curBattling.replace(this.curBattling.indexOf("#26") + 4, this.curBattling.indexOf("#27"), (new StringBuilder(String.valueOf(this.nextMaxExeTime - System.currentTimeMillis()))).toString());
      } else if (this.curBattling.indexOf("#26") > 0 && this.curBattling.indexOf("#27") > 0) {
        this.curBattling.replace(this.curBattling.indexOf("#26") + 4, this.curBattling.indexOf("#27"), (new StringBuilder(String.valueOf(this.nextMaxExeTime - System.currentTimeMillis()))).toString());
      } 
      StringBuilder battleMsg = new StringBuilder();
      System.out.println("【step 01】getCurrentBattleInfo 战斗报告：" + battleMsg);
      battleMsg.append(this.ticket.get()).append("|")
        .append(this.battleId).append("#")
        .append(17).append("|").append(battleSide)
        .append("#");
      battleMsg.append(this.curReport).append(this.curBattling);
      Builder.getReportType100(dataGetter, this, battleMsg);
      String saveReport = Configuration.getProperty("gcld.battle.report.save");
      String headInfo = null;
      if (saveReport.equals("1")) {
        String playerName = dataGetter.getPlayerDao().read(playerId).getPlayerName();
        if (backOrJoin == 1) {
          headInfo = " battleId " + getBattleId() + " 返回战斗场景, 发送给个人  " + playerName + "  battleMsg:";
        } else if (backOrJoin == 2) {
          headInfo = " battleId " + getBattleId() + " 加入战斗, 发送给个人  " + playerName + "  battleMsg:";
        } 
        Builder.getLog(battleMsg.toString(), headInfo);
      } 
      return battleMsg.toString();
    } 
  }
  
  public void SaveCurReport(IDataGetter dataGetter) {
    StringBuilder battleMsg = new StringBuilder();
    Builder.getReportType10(battleMsg, this.attList, "att", getAttBaseInfo());
    Builder.getReportType10(battleMsg, this.defList, "def", getDefBaseInfo());
    Builder.getReportType13(this, battleMsg);
    CampArmy attCampArmy = null;
    if (this.attList.size() > 0)
      attCampArmy = ((BattleArmy)this.attList.get(0)).getCampArmy(); 
    if (attCampArmy != null)
      Builder.getReportType16(dataGetter, this, battleMsg, attCampArmy, "att", true, true); 
    CampArmy defCampArmy = null;
    if (this.defList.size() > 0)
      defCampArmy = ((BattleArmy)this.defList.get(0)).getCampArmy(); 
    if (defCampArmy != null)
      Builder.getReportType16(dataGetter, this, battleMsg, defCampArmy, "def", true, true); 
    this.curReport = battleMsg;
  }
  
  private void saveCurBattling(IDataGetter dataGetter, RoundInfo roundInfo) {
    String[] strs = null;
    this.curBattling.delete(0, this.curBattling.length());
    this.curBattling.append(12).append("|").append(";");
    BattleArmy attBa = roundInfo.attBattleArmy;
    int attSpecialType = (attBa.getCampArmy().getTeamGenreal() == null) ? 0 : ((attBa.getCampArmy().getTeamEffect() > 0.0D) ? 2 : 1);
    if (attBa.getTD_defense_e() > 0.0D)
      attSpecialType = 3; 
    this.curBattling.append(attBa.getPosition()).append("|").append(attBa.getCampArmy().getPlayerId()).append("|").append(attBa.getCampArmy().getTroopSerial()).append("|").append(attBa.getCampArmy().getTroopType()).append("|").append(attBa.getCampArmy().getTroopName()).append("|").append(attBa.getCampArmy().getTroopDropType()).append("|").append(attBa.getStrategy()).append("|").append(attSpecialType).append("|");
    boolean diyihang = attBa.getHaveZhanChe();
    CampArmy campArmy = attBa.getCampArmy();
    this.curBattling.append(campArmy.getIsJuexing()).append("|").append(campArmy.getIsChongFeng()).append("|").append(attBa.getIsDajiang()).append("|").append(campArmy.getCopyType()).append("|").append(campArmy.getJueEquip()).append("|").append(campArmy.getAttack()).append("|").append(campArmy.getDefence()).append("|").append(campArmy.getResistePercentage()).append("|");
    if (diyihang) {
      int carid = campArmy.getCarId();
      this.curBattling.append(carid).append("|").append(attBa.getBigGzNum()).append("|");
    } else if (attBa.getZhanchedun() > 0) {
      int carid = campArmy.getCarId();
      if (campArmy.getCatapultSkill() == 2 && campArmy.getGeneralId() == 275 && campArmy.getIsJuexing() > 0) {
        carid = 999;
      } else if (campArmy.getCatapultSkill() == 4 && campArmy.getGeneralId() == 275 && campArmy.getIsJuexing() > 0) {
        carid = 879992;
      } 
      this.curBattling.append(carid).append("|").append(attBa.getBigGzNum()).append("|");
    } else {
      this.curBattling.append(0).append("|").append(0).append("|");
    } 
    this.curBattling.append(campArmy.getbsPro()).append("|").append(attBa.getZfShiled()).append("|")
      .append(attBa.getSpecial()).append("|").append(campArmy.getWeiweiHuaide()).append("|")
      .append(attBa.getYubaoEffect()).append("|").append(campArmy.getFormationType()).append("|")
      .append(campArmy.getHasbigFormationskill()).append("|").append(campArmy.getFyzShield())
      .append("|").append(campArmy.getLgdcBuff()).append("|").append(campArmy.getIsBurn()).append("|")
      .append(campArmy.getSex()).append("|").append(campArmy.getDeputy()).append("|")
      .append(campArmy.getJxType()).append("|").append(campArmy.getYbTx()).append("|").append(campArmy.getWsb()).append("|")
      
      .append(attBa.getTouXian()).append("|").append(attBa.getLonglin()).append("|").append(attBa.getSangDanType()).append("|0|").append(campArmy.getMissNum()).append("|").append(campArmy.getImmunoNum()).append("|").append(campArmy.getCarPoDunNum()).append("|").append(campArmy.getIsFanShang()).append("|").append(campArmy.getIsBmy()).append("|").append(campArmy.getZhsNum()).append("|").append(campArmy.getMfFire()).append("|").append(attBa.getCardebuff()).append("|").append(attBa.getQingCheng()).append("|").append(attBa.getCarGzLevel()).append("|").append(attBa.getHuWei()).append("|").append(attBa.getCarTsBj()).append("|").append(attBa.getpose()).append("|").append(campArmy.getSneer()).append("|").append(campArmy.getIsBeatMonster()).append("|").append(campArmy.getBeastStar()).append("|").append("0|").append(campArmy.getFkbhHpPro()).append("|").append(campArmy.getIsZhenFaLvUp()).append("|").append(campArmy.getIsFlower()).append("|").append(campArmy.getSunShangXiangZs()).append("|").append(campArmy.getZsMyMa()).append("|").append(campArmy.getSsxMa()).append("|").append(attBa.getHuShou()).append("|").append(attBa.getFengDao()).append("|").append(attBa.getZyNum()).append("|");
    this.curBattling.append(campArmy.getHuoYi()).append("|").append(campArmy.getZhaXiang())
      .append("|").append(campArmy.getHasZh()).append("|").append(campArmy.getLjNum())
      .append("|null|").append(campArmy.getLeblMa()).append("|").append(campArmy.guzhu)
      .append("|").append(campArmy.getTuiShou());
    this.curBattling.append("|0|0|0|0|0|0|0|0|0|0|0|0|0|")
      .append(campArmy.getTouXian()).append("|");
    int troopHpMax = attBa.getCampArmy().getTroopHp() / 3;
    for (int j = 0; j < 3; j++) {
      if (diyihang) {
        this.curBattling.append(attBa.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(attBa.getShield()).append("*").append(attBa.getMaxShield()).append("*").append(attBa.getHuJia()).append("*").append(attBa.getCarMaxHp()).append("*").append(attBa.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
      } else if (attBa.getZhanchedun() > 0) {
        this.curBattling.append(attBa.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(attBa.getShield()).append("*").append(attBa.getMaxShield()).append("*").append(attBa.getZCdunHp()).append("*").append(attBa.getCarMaxHp()).append("*").append(attBa.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
      } else {
        this.curBattling.append(attBa.getTroopHp()[j]).append("*").append(troopHpMax).append("*").append(attBa.getShield()).append("*").append(attBa.getMaxShield()).append("*").append(0).append("*").append(0).append("*").append(attBa.getShiledType()).append("*").append(campArmy.getDefenseDow()).append(",");
      } 
    } 
    this.curBattling.replace(this.curBattling.length() - 1, this.curBattling.length(), ";");
    BattleArmy defBa = roundInfo.defBattleArmy;
    int defSpecialType = (defBa.getCampArmy().getTeamGenreal() == null) ? 0 : ((defBa.getCampArmy().getTeamEffect() > 0.0D) ? 2 : 1);
    if (defBa.getTD_defense_e() > 0.0D)
      defSpecialType = 3; 
    this.curBattling.append(defBa.getPosition()).append("|").append(defBa.getCampArmy().getPlayerId()).append("|").append(defBa.getCampArmy().getTroopSerial()).append("|").append(defBa.getCampArmy().getTroopType()).append("|").append(defBa.getCampArmy().getTroopName()).append("|").append(defBa.getCampArmy().getTroopDropType()).append("|").append(defBa.getStrategy()).append("|").append(defSpecialType).append("|");
    boolean diyihang2 = defBa.getHaveZhanChe();
    CampArmy campArmy2 = defBa.getCampArmy();
    this.curBattling.append(campArmy2.getIsJuexing()).append("|").append(campArmy2.getIsChongFeng()).append("|").append(campArmy2.getIsMain()).append("|").append(campArmy2.getCopyType()).append("|").append(campArmy2.getJueEquip()).append("|").append(campArmy2.getAttack()).append("|").append(campArmy2.getDefence()).append("|").append(campArmy2.getResistePercentage()).append("|");
    if (diyihang2) {
      int carid = campArmy2.getCarId();
      this.curBattling.append(carid).append("|").append(defBa.getBigGzNum()).append("|");
    } else if (defBa.getZhanchedun() > 0) {
      int carid = campArmy2.getCarId();
      if (campArmy2.getCatapultSkill() == 2 && campArmy2.getGeneralId() == 275) {
        carid = 999;
      } else if (campArmy2.getCatapultSkill() == 4 && campArmy2.getGeneralId() == 275) {
        carid = 879992;
      } 
      this.curBattling.append(carid).append("|").append(defBa.getBigGzNum()).append("|");
    } else {
      this.curBattling.append(0).append("|").append(0).append("|");
    } 
    this.curBattling.append(campArmy2.getbsPro()).append("|").append(defBa.getZfShiled()).append("|").append(defBa.getSpecial()).append("|").append(campArmy2.getWeiweiHuaide()).append("|").append(campArmy2.getYubaoEffect()).append("|").append(campArmy2.getFormationType()).append("|").append(campArmy2.getHasbigFormationskill()).append("|").append(campArmy2.getFyzShield()).append("|").append(campArmy2.getLgdcBuff()).append("|").append(campArmy2.getIsBurn()).append("|").append(campArmy2.getSex()).append("|").append(campArmy2.getDeputy()).append("|").append(campArmy2.getJxType()).append("|").append(campArmy2.getYbTx()).append("|").append(campArmy2.getWsb()).append("|")
      .append(defBa.getTouXian()).append("|").append(defBa.getLonglin()).append("|").append(defBa.getSangDanType()).append("|0|").append(campArmy2.getMissNum()).append("|").append(campArmy2.getImmunoNum()).append("|").append(campArmy2.getCarPoDunNum()).append("|").append(campArmy2.getIsFanShang()).append("|").append(campArmy2.getIsBmy()).append("|").append(campArmy2.getZhsNum()).append("|").append(campArmy2.getMfFire()).append("|").append("0|").append(defBa.getQingCheng()).append(defBa.getCarGzLevel()).append("|").append(defBa.getHuWei()).append("|").append(defBa.getCarTsBj()).append("|").append(defBa.getpose()).append("|").append(campArmy2.getSneer()).append("|").append(campArmy2.getIsBeatMonster()).append("|").append(campArmy2.getBeastStar()).append("|").append("0|").append(campArmy2.getFkbhHpPro()).append("|").append(campArmy2.getIsZhenFaLvUp()).append("|").append(campArmy2.getIsFlower()).append("|").append(campArmy2.getSunShangXiangZs()).append("|").append(campArmy2.getZsMyMa()).append("|").append(campArmy2.getSsxMa()).append("|").append(defBa.getHuShou()).append("|").append(defBa.getFengDao()).append("|").append(defBa.getZyNum()).append("|");
    this.curBattling.append(campArmy2.getHuoYi()).append("|").append(campArmy2.getZhaXiang()).append("|").append(campArmy2.getHasZh()).append("|").append(campArmy2.getLjNum()).append("|null|").append(campArmy2.getLeblMa()).append("|").append(campArmy2.guzhu).append("|").append(campArmy2.getTuiShou());
    this.curBattling.append("|1|0|0|0|0|0|0|0|0|0|0|0|0|")
      .append(campArmy2.getTouXian()).append("|");
    troopHpMax = defBa.getCampArmy().getTroopHp() / 3;
    for (int i = 0; i < 3; i++) {
      if (diyihang) {
        this.curBattling.append(defBa.getTroopHp()[i]).append("*").append(troopHpMax).append("*").append(defBa.getShield()).append("*").append(defBa.getMaxShield()).append("*").append(defBa.getHuJia()).append("*").append(defBa.getCarMaxHp()).append("*").append(defBa.getShiledType()).append("*").append(campArmy2.getDefenseDow()).append(",");
      } else if (defBa.getZhanchedun() > 0) {
        this.curBattling.append(defBa.getTroopHp()[i]).append("*").append(troopHpMax).append("*").append(defBa.getShield()).append("*").append(defBa.getMaxShield()).append("*").append(defBa.getZCdunHp()).append("*").append(defBa.getCarMaxHp()).append("*").append(defBa.getShiledType()).append("*").append(campArmy2.getDefenseDow()).append(",");
      } else {
        this.curBattling.append(defBa.getTroopHp()[i]).append("*").append(troopHpMax).append("*").append(defBa.getShield()).append("*").append(defBa.getMaxShield()).append("*").append(0).append("*").append(0).append("*").append(defBa.getShiledType()).append("*").append(campArmy2.getDefenseDow()).append(",");
      } 
    } 
    this.curBattling.replace(this.curBattling.length() - 1, this.curBattling.length(), ";");
    if (roundInfo.reports != null) {
      for (int l = 0; l < roundInfo.reports.length; l++) {
        String str = roundInfo.reports[l];
        strs = str.split(";");
        this.curBattling.append(strs[strs.length - 1]).append(",");
      } 
    } else if (roundInfo.win == 1) {
      for (int k = 0; k < 3; k++)
        this.curBattling.append("1001|1").append(","); 
    } else if (roundInfo.win == 2) {
      for (int k = 0; k < 3; k++)
        this.curBattling.append("1001|2").append(","); 
    } else {
      for (int k = 0; k < 3; k++)
        this.curBattling.append("1001|3").append(","); 
    } 
    this.curBattling.replace(this.curBattling.length() - 1, this.curBattling.length(), "#");
    this.curBattling.append(26).append("|").append(6000).append("|");
    Builder.getArrowTowerInfo(dataGetter, this, this.curBattling, getDefBaseInfo().getId(), this.battleType);
    Builder.getReportType27(this.curBattling, roundInfo, this, dataGetter, -1L);
  }
  
  public boolean canCallHelp(int playerId) {
    return ((this.battleType == 2 || this.battleType == 7) && this.attBaseInfo.getId() == playerId);
  }
  
  public boolean fireASinglePk(IDataGetter dataGetter) {
    try {
      synchronized (getBattleId()) {
        CampArmy[] cas = new CampArmy[2];
        if (this.attCamp.size() == 0 || this.defCamp.size() == 0)
          return false; 
        int attChooseId = this.attCamp.size() - 1;
        int defChooseId = this.defCamp.size() - 1;
        cas[0] = this.attCamp.get(attChooseId);
        cas[1] = this.defCamp.get(defChooseId);
        if ((cas[0]).onQueues || (cas[1]).onQueues)
          return false; 
        if ((cas[0]).isDeputy > 0 || (cas[1]).isDeputy > 0)
          return false; 
        this.attCamp.remove(cas[0]);
        this.defCamp.remove(cas[1]);
        this.attBaseInfo.setAllNum(this.attBaseInfo.getAllNum() - (cas[0]).armyHp);
        if (this.attBaseInfo.getNum() < (cas[0]).armyHp)
          ErrorSceneLog.getInstance().appendErrorMsg("battle fireASinglePk att兵力小于0,battle 3440行"); 
        this.attBaseInfo.setNum(this.attBaseInfo.getNum() - (cas[0]).armyHp);
        this.defBaseInfo.setAllNum(this.defBaseInfo.getAllNum() - (cas[1]).armyHp);
        if (this.defBaseInfo.getNum() < (cas[1]).armyHp)
          ErrorSceneLog.getInstance().appendErrorMsg("battle fireASinglePk def兵力小于0,battle3446行"); 
        this.defBaseInfo.setNum(this.defBaseInfo.getNum() - (cas[1]).armyHp);
        dataGetter.getBattleService().createOneToOneBattle(-1, cas, this, 3, 0, false);
        return true;
      } 
    } catch (Exception e) {
      ErrorSceneLog.getInstance().error("Battle.fireASinglePk catch Exception", e);
      return false;
    } 
  }
  
  public Tuple<Boolean, String> changeExeTime(long newExeTime) {
    Tuple<Boolean, String> result = new Tuple();
    result.left = Boolean.valueOf(false);
    synchronized (this.battleId) {
      if (newExeTime < this.nextMinExeTime || newExeTime > this.nextMaxExeTime) {
        String quickMode = Configuration.getProperty("gcld.battle.quick");
        if (!quickMode.equals("1") && this.quickBattle <= 0) {
          ErrorSceneLog.getInstance().appendErrorMsg("newExeTime is invalid").appendBattleId(this.battleId).append("roundNum", getRoundNum()).append("newExeTime", Long.valueOf(newExeTime)).append("nextMinExeTime", Long.valueOf(this.nextMinExeTime)).append("nextMaxExeTime", Long.valueOf(this.nextMaxExeTime)).appendMethodName("changeExeTime").appendClassName("Battle").flush();
          result.right = LocalMessages.BATTLE_APPOINTED_TIME_CANNOT_EXECUTE;
          return result;
        } 
      } 
      BattleScheduler.getInstance().removeBattle(this);
      this.nextExeTime = newExeTime;
      BattleScheduler.getInstance().addBattleToScheduler(this);
      result.left = Boolean.valueOf(true);
      return result;
    } 
  }
  
  public int compareTo(Battle battle) {
    return (int)(this.nextExeTime - battle.nextExeTime);
  }
  
  public CampArmy checkfujiang(IDataGetter dataGetter, int battleSide, CampArmy campArmy) {
    if (campArmy.getDeputy() <= 0 || campArmy.getPlayerId() <= 0 || campArmy.getUnionState() > 0)
      return null; 
    PlayerGeneralMilitary fjpgm = dataGetter.getPlayerGeneralMilitaryDao().getMilitary(campArmy.getPlayerId(), campArmy.getDeputy());
    if (fjpgm == null)
      return null; 
    Player player = dataGetter.getPlayerDao().read(campArmy.getPlayerId());
    if (player == null)
      return null; 
    Builder builder = BuilderFactory.getInstance().getBuilder(getBattleType());
    CampArmy campArmy1 = builder.copyArmyFromPlayerTable(player, fjpgm, dataGetter, builder.getGeneralState(), this, battleSide);
    if (campArmy1 != null) {
      campArmy1.setIsDeputy(1);
      campArmy1.setZhuJiangId(campArmy.getGeneralId());
      campArmy.setHaveFujiang(true);
      campArmy.setDeputyCamId(campArmy1.getId());
      campArmy1.updateDB = false;
    } 
    return campArmy1;
  }
  
  public static int getHuanYingDamage(CampArmy a, CampArmy b, double all_damage, int terrainValue) {
    if (a.armyHp <= 0 || b.armyHp <= 0)
      return 0; 
    double zchuoli = 1.0D;
    if (a.hujia > 0)
      zchuoli = a.attcoe.doubleValue(); 
    if (a.generalId == 224 && a.isjuexing > 0)
      a.buqu = 2; 
    if (b.generalId == 224 && b.isjuexing > 0)
      b.buqu = 2; 
    if (a.generalId == 270 && a.isjuexing > 0)
      a.attacklevel = 2; 
    if (b.generalId == 270 && b.isjuexing > 0)
      b.attacklevel = 2; 
    int kezhoutai = 1;
    int beikezhoutai = 1;
    if (a.generalId == 205 && a.isjuexing > 0 && b.generalId == 224 && b.isjuexing > 0)
      kezhoutai = 2; 
    if (b.generalId == 205 && b.isjuexing > 0 && a.generalId == 224 && a.isjuexing > 0)
      beikezhoutai = 2; 
    int czshinuma = a.czshinum;
    if (czshinuma > 18)
      czshinuma = 18; 
    int czshinumb = b.czshinum;
    if (czshinumb > 18)
      czshinumb = 18; 
    int BASE_ATT = (int)(a.attEffect * (1.0D + 0.1D * a.attacklevel + 0.1D * a.buqu / 2.5D / beikezhoutai + 0.05D * czshinuma) * zchuoli * (1.0D + a.paytotal / 200000.0D));
    int BASE_DEF = (int)(b.defEffect * (1.0D + 0.1D * b.attacklevel + 0.1D * b.buqu / 2.5D / kezhoutai + 0.05D * czshinumb) * (1.0D + b.paytotal / 200000.0D));
    double damage = (BASE_ATT - BASE_DEF);
    if (damage < 0.0D)
      damage = 0.0D; 
    damage += a.bdEffect;
    int arealhp = a.armyHp;
    int brealhp = b.armyHp;
    if (a.generalId == 204 && a.isjuexing > 0 && !a.legendEvoke)
      arealhp /= 30; 
    if (b.generalId == 204 && b.isjuexing > 0 && !b.legendEvoke)
      brealhp /= 30; 
    double bloodE = Math.pow(1.0D * arealhp / brealhp, 0.25D);
    if (bloodE < 0.2D)
      bloodE = 0.2D; 
    if (bloodE > 5.0D)
      bloodE = 5.0D; 
    damage *= bloodE;
    double t_e = 1.0D + ((b.specialGeneral.generalType == 11) ? 0.0D : a.terrain) - ((a.specialGeneral.generalType == 11) ? 0.0D : b.terrain);
    if (t_e < 0.6D)
      t_e = 0.6D; 
    if (t_e > 1.6D)
      t_e = 1.6D; 
    damage *= t_e;
    double all_damage_e = 1.0D + all_damage;
    if (all_damage_e < 0.5D)
      all_damage_e = 0.5D; 
    if (all_damage_e > 2.0D)
      all_damage_e = 2.0D; 
    damage *= all_damage_e;
    int LeaDiff = a.leader - b.leader;
    double LeaCoE = 1.0D + LeaDiff * 0.005D;
    if (LeaCoE > 1.35D)
      LeaCoE = 1.35D; 
    if (LeaCoE < 0.65D)
      LeaCoE = 0.65D; 
    damage *= LeaCoE;
    double bzkz = (a.bubingdamage + a.qibingdamage + a.gongbingdamage - b.bubingdamage - b.qibingdamage - b.gongbingdamage);
    if (bzkz < 0.0D)
      bzkz = 0.0D; 
    if (bzkz > 3.0D)
      bzkz = 3.0D; 
    damage *= 1.0D + bzkz;
    double damage_append = (2 * a.attDef_B.ATT_B - b.attDef_B.DEF_B);
    double zbgj = (a.erzhenbao + a.sizhenbao + a.qizhenbao + a.sanzhenbao - b.erzhenbao - b.sizhenbao - b.qizhenbao - b.sanzhenbao);
    if (zbgj <= 0.0D)
      zbgj = 0.0D; 
    damage_append += zbgj;
    damage_append = damage_append + a.shandidamage + a.pingyuandamage + a.shuiyudamage - b.shandidamage - b.pingyuandamage - b.shuiyudamage;
    damage_append += ((a.leader - b.leader) * 10);
    if (damage_append < 0.0D)
      damage_append = 0.0D; 
    double damage_append_temp = damage + damage_append;
    if (damage_append_temp < damage * 0.1D) {
      damage *= 0.1D;
    } else if (damage_append_temp > damage * 3.0D) {
      damage *= 3.0D;
    } else {
      damage = damage_append_temp;
    } 
    if (damage < damage_append * 0.5D)
      damage = damage_append * 0.5D; 
    damage *= 1.0D + a.pingkan / 100.0D;
    if (a.generalId == 205 && a.isjuexing > 0 && a.machaofrank > 0) {
      damage = 0.0D;
    } else if (a.formationtype == 2 && a.hasbigformationskill > 0) {
      damage = 0.0D;
    } 
    if (b.generalId == 205 && b.isjuexing > 0 && b.machaofrank > 0)
      damage = 0.0D; 
    if (a.generalId == 205 && a.isjuexing > 0) {
      if (b.generalId == 204 && b.isjuexing > 0)
        damage = 0.0D; 
      if (b.generalId == 224 && b.isjuexing > 0)
        damage = 0.0D; 
    } 
    if (b.generalId == 281 || b.buff.equals("baqi")) {
      damage /= 2.0D;
      if (b.baqi2 > 0)
        damage /= (1 + b.baqi2); 
      if (b.generalId == 281 && b.isjuexing > 0)
        damage /= (1 + b.baqinum / 5); 
    } 
    if (b.generalId == 266 && b.isjuexing > 0 && a.sex <= 0)
      damage *= 0.5D; 
    int dixingadd = 0;
    if (a.generalId == 275 && (terrainValue == 1 || terrainValue == 4) && b.generalId != 275)
      dixingadd = 5000; 
    if (a.generalId == 273 && terrainValue == 2 && b.generalId != 273)
      dixingadd = 5000; 
    damage += dixingadd;
    if (b.generalId == 268 && b.isjuexing > 0)
      damage *= 0.625D; 
    if (b.resistepercentage > 0.0D)
      damage *= 1.0D - b.resistepercentage; 
    if (damage < 1.0D)
      damage = 1.0D; 
    if (damage > b.armyHp)
      damage = b.armyHp; 
    return (int)damage;
  }
}
